print("Loading RevoltTypreScripts.lua from Loyalty++ version "..GlobalParameters.Lpp_VERSION_MAJOR.."."..GlobalParameters.Lpp_VERSION_MINOR.."."..GlobalParameters.Lpp_VERSION_PATCH);

local ImobilizedUnit = {};

function LoyaltyRecover(playerid, pCityName , Value)
    local pPlayer = Players[playerid]
    if Value == nil then
        Value = 1000
    end
    for _, pCity in pPlayer:GetCities():Members() do
          if pCity ~= nil and pCity:GetName() == pCityName then 
                    pCity:ChangeLoyalty(Value)             -- loyalty to 1000
          end                   
    end     
end
LuaEvents.restoreLoyalty.Add( LoyaltyRecover )

function ChangeLoyalty(Value ,playerid,CityName) 
    local pPlayer = Players[playerid] 
    if type(Value) ~= "number" then
        Value = 0 
    end
    if CityName then
        for _, pCity in pPlayer:GetCities():Members() do
            if pCity:GetName() == CityName then
                pCity:ChangeLoyalty(Value)         
            end
        end
    else
        for _, pCity in pPlayer:GetCities():Members() do
            if pCity ~= nil then   
                pCity:ChangeLoyalty(Value)
             end                   
        end    
    end
end
 LuaEvents.ChangeLoyaltyScript.Add( ChangeLoyalty )
-- GameEvents.PlayerTurnStarted.Add( ChangeLoyalty )


function UnitSpawn(playerid, x, y, UnitType, IsSiege, cityKey, UnitCount)
    local pPlayer = Players[playerid]
    local UnitType = GameInfo.Units[UnitType].Index
    pPlayer:GetUnits():Create (UnitType, x, y)
    if IsSiege then
        for _, pUnit in ipairs (Units.GetUnitsInPlot(Map.GetPlot(x, y))) do
            LuaEvents.SaveData(cityKey..".siegeUnitID."..UnitCount, pUnit:GetID() )
            LuaEvents.SaveData(cityKey..".IsDead."..UnitCount, false )
        end
    end
end
LuaEvents.LittleRevolt.Add( UnitSpawn )

function GiveTech( iTech, playerID)
    Players[playerID]:GetTechs():SetTech(iTech, true)
end
function SetTechProgress(iTech, Value, playerID)
    Players[playerID]:GetTechs():SetResearchProgress(iTech, Value)
end
function GiveCivic( iCivic, playerID)
    Players[playerID]:GetCulture():SetCivic(iCivic, true)
end
function SetCulture( iCivic, Value, playerID)
    Players[playerID]:GetCulture():SetCulturalProgress(iCivic, Value)
end
LuaEvents.GainTech.Add(         GiveTech )
LuaEvents.SetResearch.Add(      SetTechProgress )
LuaEvents.GainCivic.Add(        GiveCivic )
LuaEvents.SetCivic.Add(         SetCulture )


function FreeCity(cityID, playerID, UnitsID, Owner)                                                  -- City Become free city
    local pCity = CityManager.GetCity(playerID, cityID)
    local unitsInPlot = Units.GetUnitsInPlot(pCity:GetX(), pCity:GetY())
    for _, pUnit in ipairs(unitsInPlot) do     
        UnitManager.Kill(pUnit)
    end
    for _, UnitID in pairs(UnitsID) do
        local pUnit     = UnitManager.GetUnit(Owner, UnitID)
        local UnitType  = pUnit:GetType()
        local x         = pUnit:GetX()
        local y         = pUnit:GetY()
        UnitManager.Kill(pUnit)
        Players[62]:GetUnits():Create (UnitType, x, y)
    end
    pCity:ChangeLoyalty(- 2000)
end
LuaEvents.RevoltType1.Add( FreeCity )

function KillPlayer(PlayerID)
    local pPlayer = Players[PlayerID]
    UnitManager.InitUnit(PlayerID  , "UNIT_SETTLER", -1, -1);
    for _, pUnit in  pPlayer:GetUnits():Members() do
        if(pUnit:GetX() >= 0 or  pUnit:GetY() >= 0) then
            pPlayer:GetUnits():Destroy(pUnit);
        end
    end
end
LuaEvents.KillPlayer.Add( KillPlayer );


function toerase()
    local numberOfIndependentColonialNation         = 0
    local kPlayers	                         :table = PlayerManager.GetWasEverAlive();
    local maxNumberOfIndependentColonialNation      = #kPlayers / 5;
    local maxNumberMinorIndependentColonialNation   = maxNumberOfIndependentColonialNation /2
    local NumberMinorIndependentColonialNation      = 0
    local RandomIndependantnation                   = {};
    local HumanPlayerContinent                      = {}
    for _, pPlayer in pairs(kPlayers) do
        if not pPlayer:IsHuman() and pPlayer:GetCities():GetCount() == 0  and pPlayer:GetID() < 60 then
            table.insert(RandomIndependantnation, pPlayer)
        elseif pPlayer:IsHuman() then
            for _, pUnit in  pPlayer:GetUnits():Members() do
                if(pUnit:GetX() >= 0 or  pUnit:GetY() >= 0) then
                    HumanPlayerContinent[Map.GetPlot(pUnit:GetX(), pUnit:GetY()):GetContinentType()] = true
                end
            end
        end
    end
    while numberOfIndependentColonialNation < maxNumberOfIndependentColonialNation and #RandomIndependantnation > 1 do
        local randomNumber = math.random(1, #RandomIndependantnation)
        local pPlayer = RandomIndependantnation[randomNumber];
        table.remove(RandomIndependantnation, randomNumber)
        if pPlayer:IsMajor() or NumberMinorIndependentColonialNation < maxNumberMinorIndependentColonialNation then
            if not pPlayer:IsMajor() then
                NumberMinorIndependentColonialNation = NumberMinorIndependentColonialNation +1
            end
        
            local PlayerID = pPlayer:GetID() 
            local playerContinentPlots;
            local SameContinentPlayer = {}
            UnitManager.InitUnit(PlayerID  , "UNIT_SETTLER", -1, -1);
            for _, pUnit in  pPlayer:GetUnits():Members() do
                if(pUnit:GetX() >= 0 or  pUnit:GetY() >= 0) then
                    if not playerContinentPlots then
                        local playerContinent = Map.GetPlot(pUnit:GetX(), pUnit:GetY()):GetContinentType()
                        if not  HumanPlayerContinent[playerContinent] then
                            playerContinentPlots = Map.GetContinentPlots(playerContinent)
                        end
                    end
                    pPlayer:GetUnits():Destroy(pUnit);
                end
            end
            LuaEvents.CreateIndependentColonialNation(PlayerID)    ;   
            numberOfIndependentColonialNation = numberOfIndependentColonialNation + 1;
            if numberOfIndependentColonialNation > maxNumberOfIndependentColonialNation then 
                break;
            end
            if playerContinentPlots then
                local AlreadyIn = {}
                for k, plotID in pairs(playerContinentPlots) do
                    local pPlot       = Map.GetPlotByIndex(plotID)
                    local unitsInPlot = Units.GetUnitsInPlot(pPlot:GetX(), pPlot:GetY())
                    if #unitsInPlot > 0 then
                        local pUnit = unitsInPlot[1]
                        for key, CanIndependantPlayer in ipairs(RandomIndependantnation) do
                            if pUnit:GetOwner() == CanIndependantPlayer:GetID() and not AlreadyIn[key] then
                                table.insert(SameContinentPlayer, key)
                                AlreadyIn[key] = true
                                break;
                            elseif AlreadyIn[key] then
                                break;
                            end
                        end
                    end
                end
                for _, key in ipairs(SameContinentPlayer) do
                    local pPlayer = RandomIndependantnation[key];
                    table.remove(RandomIndependantnation, key)
                    if not pPlayer:IsHuman() and (pPlayer:IsMajor() or NumberMinorIndependentColonialNation < maxNumberMinorIndependentColonialNation) then
                        if not pPlayer:IsMajor() then
                            NumberMinorIndependentColonialNation = NumberMinorIndependentColonialNation +1
                        end
                        local PlayerID = pPlayer:GetID() 
                        UnitManager.InitUnit(PlayerID  , "UNIT_SETTLER", -1, -1);
                        for _, pUnit in  pPlayer:GetUnits():Members() do
                            if(pUnit:GetX() >= 0 or  pUnit:GetY() >= 0) then
                                pPlayer:GetUnits():Destroy(pUnit);
                            end
                        end
                        LuaEvents.CreateIndependentColonialNation(PlayerID)    ;   
                        numberOfIndependentColonialNation = numberOfIndependentColonialNation + 1;
                        if numberOfIndependentColonialNation > maxNumberOfIndependentColonialNation then 
                            break;
                        end
                    end
                end
            end
        end
    end
end

function MoveUnitTo(playerID, unitID, x,y)
    local pUnit                         = UnitManager.GetUnit(playerID, unitID);
    UnitManager.RestoreMovementToFormation(pUnit)
    UnitManager.RestoreMovement(pUnit)
    UnitManager.RestoreUnitAttacks(pUnit)
    UnitManager.MoveUnit(pUnit, x, y)
    if pUnit:GetX() == x and  pUnit:GetY() == y then
        LuaEvents.UnitMoved( true )
    else
        LuaEvents.UnitMoved( false )
    end
end
LuaEvents.MoveUnitToLocation.Add(MoveUnitTo); 

function GetUnitLocation(playerID, unitID)
    local pUnit     = UnitManager.GetUnit(playerID, unitID);
    local x         = pUnit:GetX()
    local y         = pUnit:GetY()
    LuaEvents.SetUnitLocation( x,y )
end

LuaEvents.GetUnitLocation.Add(GetUnitLocation); 

function ChangeCityOwner( CityX, CityY, IndependentPlayerIDCityOwner, cityData )
    local pCity             = CityManager.GetCityAt(CityX, CityY);
    Cities.DestroyCity(pCity);
    Players[IndependentPlayerIDCityOwner]:GetCities():Create(CityX, CityY);
    local pCity = CityManager.GetCityAt(CityX, CityY);
    pCity:ChangePopulation( cityData.Population - pCity:GetPopulation());
    pCity:SetName(cityData.Name);
    local pCityBuildQueue = pCity:GetBuildQueue();
    for _, plotID in ipairs(cityData.Plots) do 
        local pPlot = Map.GetPlotByIndex(plotID);
        pPlot:SetOwner(IndependentPlayerIDCityOwner, pCity:GetID(), true);
    end
    for _,DistrictType in ipairs(cityData.district) do   
        pCityBuildQueue:CreateIncompleteDistrict(DistrictType, cityData.district[DistrictType.."location"], 100)
    end
    for _, buildingtype in ipairs(cityData.buldings) do
            local building	= GameInfo.Buildings[buildingtype];
            pCityBuildQueue:CreateIncompleteBuilding(buildingtype, 100)
            pCity:GetBuildings():SetPillaged(buildingtype, cityData.buldings[buildingtype.."IsPillaged"] );
    end
    for _,CityReligionid in ipairs(cityData.Religion) do
        pCity:GetReligion():AddReligiousPressure("UselessArg??", CityReligionid, cityData.Religion[CityReligionid.."religionpressure"]);
    end
    for _, pUnit in Players[62]:GetUnits():Members() do
        if Map.GetPlotDistance(pCity:GetX(), pCity:GetY(), pUnit:GetX(), pUnit:GetY()) < 4 then
            local UnitType  = pUnit:GetType()
            local x         = pUnit:GetX()
            local y         = pUnit:GetY()
            UnitManager.Kill(pUnit)
            Players[IndependentPlayerIDCityOwner]:GetUnits():Create (UnitType, x, y)
        end
    end
end
LuaEvents.ChangeCityOwnerTo.Add( ChangeCityOwner );     

function ChangePressureArea(CityName,player, amount)
    local pPlayer = Players[player] 
    for _, pCity in pPlayer:GetCities():Members() do
        local pCityName = pCity:GetName()
        if pCityName == CityName then 
            for _, pCity2 in pPlayer:GetCities():Members() do
                local DistancebtweenCities = Map.GetPlotDistance(pCity:GetX(), pCity:GetY(), pCity2:GetX(), pCity2:GetY())
                if DistancebtweenCities < 10 and pCity ~= pCity2 then
                    local religionID = pCity:GetReligion():GetMajorityReligion()
                    pCity2:GetReligion():AddReligiousPressure("VeryUsefullArg", religionID, amount)
                end
            end    
        end
    end                                
end
LuaEvents.RevoltType2.Add(  ChangePressureArea  )


function ChangePopulation(playerID, cityID, Value)
    Players[playerID]:GetCities():FindID(cityID):ChangePopulation(Value)
end
LuaEvents.ChangePopulation.Add( ChangePopulation )




function changeGold(Amount,playerid)
 local   pPlayer = Players[playerid]
    pPlayer:GetTreasury():ChangeGoldBalance(Amount) 
    
end
LuaEvents.NoMoreTax.Add( changeGold )


function changeFaith(Amount,playerid)
   local   pPlayer = Players[playerid]
    pPlayer:GetReligion():ChangeFaithBalance(Amount)   
    
end
LuaEvents.NoMoreFaith.Add( changeFaith )



function changeScience(Amount,playerid)
     local   pPlayer = Players[playerid]
    pPlayer:GetTechs():ChangeCurrentResearchProgress(Amount)  
    
end
LuaEvents.NoMoreScience.Add( changeScience )



function changeCulture(Amount,playerid)
     local   pPlayer = Players[playerid]
    pPlayer:GetCulture():ChangeCurrentCulturalProgress(Amount)
end
LuaEvents.NoMoreCulture.Add( changeCulture )



