print("Loading LoyaltyMod.lua from Loyalty++ version "..GlobalParameters.Lpp_VERSION_MAJOR.."."..GlobalParameters.Lpp_VERSION_MINOR.."."..GlobalParameters.Lpp_VERSION_PATCH);

include("CivilizationIcon");
include( "SupportFunctions" );
include( "LoyaltySupport" );
include( "InstanceManager" );
include( "LuaClass" );
include( "CitySupport" );                     -- Get CityData

-- ===========================================================================
--	CONSTANTS
-- ===========================================================================

local PLOT_HIDDEN				:number	= 0;
local PLOT_REVEALED				:number	= 1;
local PLOT_VISIBLE				:number	= 2;


-- LOYALTY
local PRESSURE_BREAKDOWN_TYPE_POPULATION_PRESSURE	:string = "PopulationPressure";
local PRESSURE_BREAKDOWN_TYPE_GOVERNORS				:string = "Governors";
local PRESSURE_BREAKDOWN_TYPE_HAPPINESS				:string = "Happiness";
local PRESSURE_BREAKDOWN_TYPE_OTHER					:string = "Other";
local PRESSURE_BREAKDOWN_TYPE_CITY_STATE_BONUS		:string = "CityStateBonus";
local PRESSURE_BREAKDOWN_TYPE_FREE_CITY_BONUS		:string = "FreeCityBonus";

local m_LoyaltyModInst 	                            :table  = InstanceManager:new( "LoyaltyModInfoInstance",	"Anchor", Controls.CityLoyaltyModInfo );
local m_CivChoicesInst 	                            :table  = InstanceManager:new( "CivChoices",	"TheyAre3", Controls.CivChoiceStack );
-- ===========================================================================
--	VARIABLES
-- ===========================================================================

local ReadyForPhase                     :boolean = false;
local m_isLoyaltyLensActive		        :boolean = false;
local UnitMoved                         :boolean = true;   
local SameContinent                     :boolean = false;   
local deactivatePopulationChangedNotif  :boolean = false;   

local zoomMultiplier                    :number	= 1;
local m_prevZoomMultiplier              :number	= 1;
local ZOOM_MULT_DELTA	                :number	= .01;

local ActivePlayerID                    :number	= 0;
local MinimumDistanceForColonialRiot    :number	= Map.GetPlotCount() / 400 > 10 and Map.GetPlotCount() / 400 or 10;

local NumOfMajorToKill                  :number	= 0;
local NumOfMinorToKill                  :number	= 0;

local WaitTimes                         :number	= 0;

local LastUnitLocationX;
local LastUnitLocationY;

local Triggerthisturn           :table	= {};
local Triggerturn               :table	= {};
local LastTurnNumberOfTrigger   :table  = {};

local SelectedPlayer            :table  = {};

local LoyaltyModInfo            :table  = {};
local LoyaltyModInfoInstances   :table  = {};
local LastEraUnit               :table  = {};
local WaterRiotUnit             :table  = {};
local UnitToImmobilize          :table  = {};
local IsInTerritory             :table  = {};
local SetCityPlots              :table  = {};
local NotifTable                :table  = {};





function SaveToSlot(sSlotName, Value)
   GameConfiguration.SetValue(sSlotName, Value);
end
LuaEvents.SaveData.Add( SaveToSlot );

function loadSlot(sSlotName)
   return GameConfiguration.GetValue(sSlotName);
end
LuaEvents.LoadData.Add( SaveToSlot );

local Loyalty                   = {};
for playerID, pPlayer in pairs(Players) do  
    Loyalty[playerID]   = {};
    Loyalty[playerID].Culture         = Locale.Lookup(string.gsub(PlayerConfigurations[playerID]:GetCivilizationDescription(), "DESCRIPTION", "ADJECTIVE"));
    if pPlayer:WasEverAlive() then
        for _, pCity in pPlayer:GetCities():Members() do
            local cityKey               = pCity:GetX().."."..pCity:GetY();
            Loyalty[playerID][cityKey] = {}
            Loyalty[cityKey] = {}
            
            Loyalty[playerID][cityKey].ReligionStability                        = {};
            Loyalty[playerID][cityKey].ReligionStability.Amount                 = 0;
            Loyalty[playerID][cityKey].ReligionStability.tooltip                = "";
            Loyalty[cityKey].Heretics                                           = {}
        
            Loyalty[playerID][cityKey].LastRevoltTurn                           = loadSlot("LastRevoltTurn"..playerID.."."..cityKey) and loadSlot("LastRevoltTurn"..playerID.."."..cityKey) or -40;
            Loyalty[playerID][cityKey].CurrentChanceOfRevolt                    = 0;
        
            Loyalty[playerID][cityKey].Separatism                               = {};
            Loyalty[playerID][cityKey].Separatism.Amount                        = loadSlot("SeparatismAmount"..playerID.."."..cityKey) and loadSlot("SeparatismAmount"..playerID.."."..cityKey) or 0
            Loyalty[playerID][cityKey].Separatism.tooltipOnSet                  = "";
            Loyalty[playerID][cityKey].Separatism.tooltipPerTurn                = "";
            Loyalty[cityKey].Culture                                            = loadSlot("Culture"..cityKey) and loadSlot("Culture"..cityKey) or Loyalty[playerID].Culture;
            
            Loyalty[cityKey].Migration                                          = {}                    -- ideal city is not at war and have a positive loyalty per turn
            Loyalty[cityKey].Migration.FleeWarLeaving                           = {}                      -- will search ideal city
            Loyalty[cityKey].Migration.ReligionLeaving                          = {}                      -- will search ideal city with ideal religion
            Loyalty[cityKey].Migration.GovernmentLeaving                        = {}                      -- will search ideal city with a different government
            Loyalty[cityKey].Migration.SeparatistLeaving                        = {}                      -- will search ideal city in his original country
            Loyalty[cityKey].Migration.FleeWarArrival                           = {}                      
            Loyalty[cityKey].Migration.ReligionArrival                          = {}                     
            Loyalty[cityKey].Migration.GovernmentArrival                        = {}                      
            Loyalty[cityKey].Migration.SeparatistArrival                        = {}  
            Loyalty[cityKey].Migration.currentMigration                         = loadSlot("currentMigration"..cityKey) and loadSlot("currentMigration"..cityKey) or 0;
            
            Loyalty[playerID][cityKey].ColonialRiotAmount                       = loadSlot("ColonialRiotAmount"..playerID.."."..cityKey) and loadSlot("ColonialRiotAmount"..playerID.."."..cityKey) or 0
            
            SaveToSlot( "Culture"..cityKey, Loyalty[cityKey].Culture ); 
            SaveToSlot( "LastRevoltTurn"..playerID.."."..cityKey, Loyalty[playerID][cityKey].LastRevoltTurn ); 
            SaveToSlot( "currentMigration"..cityKey, Loyalty[cityKey].Migration.currentMigration );
            SaveToSlot( "ColonialRiotAmount"..playerID.."."..cityKey, Loyalty[playerID][cityKey].ColonialRiotAmount );
            
            if GameConfiguration.GetValue(cityKey.."SiegeTurnLeft") and GameConfiguration.GetValue(cityKey.."SiegeTurnLeft") > -1 then
                for UnitCount = 1, GameConfiguration.GetValue(cityKey.."totalUnits") do
                    if not GameConfiguration.GetValue(cityKey..".IsDead."..UnitCount ) then
                        local pUnit = UnitManager.GetUnit(63, GameConfiguration.GetValue(cityKey..".siegeUnitID."..UnitCount))
                        if pUnit and pUnit:GetX() > 0 and  pUnit:GetY() > 0 and GameConfiguration.GetValue(cityKey..".siegeUnitID."..UnitCount) == pUnit:GetID() then
                            local UnitData          = {}
                            UnitData.GetUnitID      = pUnit:GetID()
                            UnitData.Owner          = pUnit:GetOwner()
                            UnitData.where          = playerID
                            table.insert(UnitToImmobilize, UnitData)
                        else
                            GameConfiguration.SetValue(cityKey..".siegeUnitID."..UnitCount, nil)
                            GameConfiguration.SetValue(cityKey..".IsDead."..UnitCount, true )
                        end
                    end
                end
            end
        end
        Loyalty[playerID].NeedSeparatismTest                                        = loadSlot("NeedSeparatismTest"..playerID) and loadSlot("NeedSeparatismTest"..playerID) or false;   
        
        Loyalty[playerID].WarExhaustion                                     = {};
        Loyalty[playerID].WarExhaustion.Amount                              = loadSlot("WarExhaustionAmount"..playerID) and loadSlot("WarExhaustionAmount"..playerID) or 0;
        Loyalty[playerID].WarExhaustion.WarDeclarationTurn                  = loadSlot("WarExhaustionWarDeclarationTurn"..playerID) and loadSlot("WarExhaustionWarDeclarationTurn"..playerID) or 0;
        Loyalty[playerID].WarExhaustion.WarmongerTooltip                    = "";
        Loyalty[playerID].WarExhaustion.WarExhaustionPerTurnTooltip         = "";
        Loyalty[playerID].WarExhaustion.WarEventTooltip                     = {};
        Loyalty[playerID].WarExhaustion.WarcountTurn                        = loadSlot("WarExhaustionWarcountTurn"..playerID) and loadSlot("WarExhaustionWarcountTurn"..playerID) or 0;

        Loyalty[playerID].GovernmentStability                               = {};
        Loyalty[playerID].GovernmentStability.Amount                        = loadSlot("GovernmentStabilityAmount"..playerID) and loadSlot("GovernmentStabilityAmount"..playerID) or 0;
        Loyalty[playerID].GovernmentStability.ReligionMultiplier            = 1;
        Loyalty[playerID].GovernmentStability.Tootip                        = "";
        Loyalty[playerID].GovernmentStability.HistoryTooltip                = {};
        Loyalty[playerID].GovernmentID                                      = 0 
    end
end 

local CurrentEra = Game.GetEras():GetCurrentEra()
for UnitData in GameInfo.Units() do
    local LastEraType = GameInfo.Eras[CurrentEra -1] and GameInfo.Eras[CurrentEra -1].EraType  or GameInfo.Eras[CurrentEra].EraType;
    if ((UnitData.PrereqTech and GameInfo.Technologies[UnitData.PrereqTech].EraType == LastEraType) or (UnitData.PrereqCivic and GameInfo.Civics[UnitData.PrereqCivic].EraType  == LastEraType)) and not UnitData.TraitType and UnitData.Combat > 1 then
        if  UnitData.Domain == "DOMAIN_LAND" then
            table.insert(LastEraUnit, UnitData.UnitType)
        elseif UnitData.Domain == "DOMAIN_SEA" then
            table.insert(WaterRiotUnit, UnitData.UnitType)
        end
    end
end
-- Notification
local notifid               :number	= 100000;
local bWaitOne              :boolean = false;
local turnDeal              :table  = {};
local exportedResources     :table  = {};
local importedResources     :table  = {};

local CurrentReligionInCity :table  = {};
local AllCityPlots          :table  = {};
function SetCurrentReligionInCity(ReligionType, cityKey)
    CurrentReligionInCity[cityKey]      = ReligionType;
end

local bCityFounded          :table  = {};

for playerID, pPlayer in pairs (Players) do
    if pPlayer:WasEverAlive() then
        for _, pCity in pPlayer:GetCities():Members() do
            local cityKey               = pCity:GetX().."."..pCity:GetY();
            if CurrentReligionInCity[cityKey] == nil then
                SetCurrentReligionInCity(pCity:GetReligion():GetMajorityReligion(), cityKey);
            end
            SaveToSlot("CityOwner"..cityKey, playerID);
        end
    end
end



function OnUnitActivate(owner, unitID, x, y, eReason, bVisibleToLocalPlayer)
    if (eReason == EventSubTypes.FOUND_CITY) then
        local cityKey           = x.."."..y;
        SetCurrentReligionInCity(-1, cityKey);
        SaveToSlot("CityOwner"..cityKey, owner);
        if Loyalty[owner][cityKey] == nil then
            Loyalty[owner][cityKey] = {}
        end
        Loyalty[cityKey]                                                    = {};
        Loyalty[owner][cityKey].ReligionStability                           = {};
        Loyalty[owner][cityKey].ReligionStability.Amount                    = 0;
        Loyalty[owner][cityKey].ReligionStability.tooltip                   = "";
        Loyalty[cityKey].Heretics                                           = {}
            
        Loyalty[owner][cityKey].LastRevoltTurn                              = -40;
        Loyalty[owner][cityKey].CurrentChanceOfRevolt                       = 0;
        
        Loyalty[owner][cityKey].Separatism                                  = {};
        Loyalty[owner][cityKey].Separatism.Amount                           = 0;
        Loyalty[owner][cityKey].Separatism.tooltipOnSet                     = "";
        Loyalty[owner][cityKey].Separatism.tooltipPerTurn                   = "";
        Loyalty[owner][cityKey].Separatism.NeedTest                         = false;
        Loyalty[cityKey].Culture                                            = Loyalty[owner].Culture;
        
        Loyalty[cityKey].Migration                                          = {}                    -- ideal city is not at war and have a positive loyalty per turn
        Loyalty[cityKey].Migration.FleeWarLeaving                           = {}                      -- will search ideal city
        Loyalty[cityKey].Migration.ReligionLeaving                          = {}                      -- will search ideal city with ideal religion
        Loyalty[cityKey].Migration.GovernmentLeaving                        = {}                      -- will search ideal city with a different government
        Loyalty[cityKey].Migration.SeparatistLeaving                        = {}                      -- will search ideal city in his original country
        Loyalty[cityKey].Migration.FleeWarArrival                           = {}                      
        Loyalty[cityKey].Migration.ReligionArrival                          = {}                     
        Loyalty[cityKey].Migration.GovernmentArrival                        = {}                      
        Loyalty[cityKey].Migration.SeparatistArrival                        = {}      
        Loyalty[cityKey].Migration.currentMigration                         = 0                 
        Loyalty[cityKey].Migration.FleeWarTooltip                           = ""                      
        Loyalty[cityKey].Migration.ReligionTooltip                          = ""                     
        Loyalty[cityKey].Migration.GovernmentTooltip                        = ""                      
        Loyalty[cityKey].Migration.SeparatistTooltip                        = ""  
        
        Loyalty[owner][cityKey].ColonialRiotAmount                          = 0
            
        
        SaveToSlot( "LastRevoltTurn"..owner.."."..cityKey, Loyalty[owner][cityKey].LastRevoltTurn);
        SaveToSlot( "SeparatismAmount"..owner.."."..cityKey, 0)
        SaveToSlot( "Culture"..cityKey, Loyalty[cityKey].Culture);
        SaveToSlot( "currentMigration"..cityKey, Loyalty[cityKey].Migration.currentMigration);
        SaveToSlot( "ColonialRiotAmount"..owner.."."..cityKey, Loyalty[owner][cityKey].ColonialRiotAmount );
        
    end
end
Events.UnitActivate.Add( OnUnitActivate );



function OnPhaseBegin()
    print("Phase has Begun");
    ReadyForPhase = true;
end
function OnPhaseEnd()
    ReadyForPhase = false;
end
Events.PhaseBegin.Add( OnPhaseBegin );
Events.PhaseEnd.Add( OnPhaseEnd );

function OnSelecetedPlayerToKill(option)
    Controls.SetColonialNation:SetHide(true);
    if option == "Random" then
        local kPlayers	                         :table = PlayerManager.GetAlive();
        if NumOfMajorToKill == 0 and NumOfMinorToKill==0 then
            return;
        elseif NumOfMajorToKill == 0 then
            kPlayers	                                = PlayerManager.GetAliveMinors();
        elseif NumOfMinorToKill == 0 then
            kPlayers	                                = PlayerManager.GetAliveMajors();
        end
        numberOfMajorKilled = 0
        numberOfMinorKilled = 0
        local RandomIndependantnation                   = {};
        local HumanPlayerContinent                      = {};
        for _, pPlayer in pairs(kPlayers) do
            if not pPlayer:IsHuman() and pPlayer:GetCities():GetCount() == 0  and pPlayer:GetID() < 60 then
                table.insert(RandomIndependantnation, pPlayer)
            elseif pPlayer:IsHuman() then
                    for _, pUnit in  pPlayer:GetUnits():Members() do
                    if(pUnit:GetX() >= 0 or  pUnit:GetY() >= 0) then
                        HumanPlayerContinent[Map.GetPlot(pUnit:GetX(), pUnit:GetY()):GetContinentType()] = true
                    end
                end
            end
        end
        while (numberOfMajorKilled ~= NumOfMajorToKill or numberOfMinorKilled ~= NumOfMinorToKill) and #RandomIndependantnation > 0 do
            local randomNumber = #RandomIndependantnation ~= 1 and math.random(1, #RandomIndependantnation) or 1
            local pPlayer = RandomIndependantnation[randomNumber];
            table.remove(RandomIndependantnation, randomNumber)
            if (pPlayer:IsMajor() and numberOfMajorKilled ~= NumOfMajorToKill) or (not pPlayer:IsMajor() and numberOfMinorKilled ~= NumOfMinorToKill) then
                if pPlayer:IsMajor() then
                    numberOfMajorKilled = numberOfMajorKilled +1
                else
                    numberOfMinorKilled = numberOfMinorKilled +1
                end
        
                local PlayerID = pPlayer:GetID() 
                local playerContinentPlots;
                local SameContinentPlayer = {}
                if SameContinent then
                    for _, pUnit in  pPlayer:GetUnits():Members() do
                        if not playerContinentPlots then
                            local playerContinent = Map.GetPlot(pUnit:GetX(), pUnit:GetY()):GetContinentType()
                            if not  HumanPlayerContinent[playerContinent] then
                                playerContinentPlots = Map.GetContinentPlots(playerContinent)
                            end
                        end
                    end
                end
                SetColonialNations(PlayerID);
                if playerContinentPlots and SameContinent then
                    local AlreadyIn = {}
                    for k, plotID in pairs(playerContinentPlots) do
                        local pPlot       = Map.GetPlotByIndex(plotID)
                        local unitsInPlot = Units.GetUnitsInPlot(pPlot:GetX(), pPlot:GetY())
                        if #unitsInPlot > 0 then
                            local pUnit = unitsInPlot[1]
                            for key, CanIndependantPlayer in ipairs(RandomIndependantnation) do
                                if pUnit:GetOwner() == CanIndependantPlayer:GetID() and not AlreadyIn[key] then
                                    table.insert(SameContinentPlayer, key)
                                    AlreadyIn[key] = true
                                    break;
                                elseif AlreadyIn[key] then
                                    break;
                                end
                            end
                        end
                    end
                    for _, key in ipairs(SameContinentPlayer) do
                        local pPlayer = RandomIndependantnation[key];
                        table.remove(RandomIndependantnation, key)
                        if (pPlayer:IsMajor() and numberOfMajorKilled ~= NumOfMajorToKill) or (not pPlayer:IsMajor() and numberOfMinorKilled ~= NumOfMinorToKill) then
                            if pPlayer:IsMajor() then
                                numberOfMajorKilled = numberOfMajorKilled +1
                            else
                                numberOfMinorKilled = numberOfMinorKilled +1
                            end
                            local PlayerID = pPlayer:GetID() 
                            SetColonialNations(PlayerID); 
                        end
                    end
                end
            end
        end
    elseif option == "OtherContinents" then
        local playerContinent   = {}
        local sameContinent     = {}
        local plotContinent     = {}
        local continent         = {}
        for plotID = 0, Map.GetPlotCount() -1 do
            local pPlot = Map.GetPlotByIndex(plotID)
            if not pPlot:IsWater() then
                local adjacentPlot = GetAdjacentPlot(plotID)
                local anyAdjacentContinent = false
                for _, pPlot2 in ipairs(adjacentPlot) do
                    local plot2ID = pPlot2:GetIndex()
                    if plotContinent[plot2ID] then
                        anyAdjacentContinent = true
                        if plotContinent[plotID] and plotContinent[plotID] ~= plotContinent[plot2ID] then
                            local continent1ID = plotContinent[plotID]
                            local continent2ID = plotContinent[plot2ID]
                            if sameContinent[continent1ID] < sameContinent[continent2ID] then
                                sameContinent[continent2ID] = sameContinent[continent1ID]
                            else
                                sameContinent[continent1ID] = sameContinent[continent2ID]
                            end
                        else
                            plotContinent[plotID] = plotContinent[plot2ID]
                            table.insert(continent[plotContinent[plotID]], plotID)
                        end
                    end
                end
                if not anyAdjacentContinent then
                    table.insert(continent, {})
                    plotContinent[plotID] = #continent
                    table.insert(continent[plotContinent[plotID]], plotID)
                    sameContinent[plotContinent[plotID]] = plotContinent[plotID]
                end
            end
            local unitsInPlot = Units.GetUnitsInPlot(pPlot:GetX(), pPlot:GetY())
            if #unitsInPlot > 0 then
                local pUnit = unitsInPlot[1]
                playerContinent[pUnit:GetOwner()] = plotContinent[plotID]
            end
        end
        local localPlayerContinentID = sameContinent[playerContinent[Game:GetLocalPlayer()]]
        playerContinent[Game:GetLocalPlayer()] = nil
        for playerID, playerContinentID in pairs(playerContinent) do
            if sameContinent[playerContinentID] ~= sameContinent[localPlayerContinentID] then
                 SetColonialNations(playerID);
            end
        end
    elseif option == "OnlyCertainsPlayers" then
        local kPlayers	                         :table = PlayerManager.GetAlive();
        for _, pPlayer in pairs(kPlayers) do
            local playerID      = pPlayer:GetID()
            local leaderName    = PlayerConfigurations[playerID]:GetCivilizationTypeName();
            if pPlayer:IsMajor() then
                leaderName = PlayerConfigurations[playerID]:GetLeaderTypeName()
            end
            for _, leaderName2 in ipairs(SelectedPlayer) do
                if leaderName == leaderName2 then
                    SetColonialNations(playerID);
                    break;
                end
            end
        end
    else
        for _, playerID in ipairs(SelectedPlayer) do
            SetColonialNations(playerID);
        end
    end
end

function OnLoadScreenClose()
    if not GameConfiguration.GetValue("AlreadyCreatedIndependentColonialNation")  then
        
        local HowToKill_Table = {
    
                {"Random","Random"},
                {"Other Continents","OtherContinents"},
                {"Only Certains players","OnlyCertainsPlayers"},
                {"Only Certains alive players","OnlyCertainsAlivePlayers"}
            };

        Controls.OkButton:RegisterCallback( Mouse.eLClick, function() OnSelecetedPlayerToKill("Random") end)

        local MajorPlayersNumber = PlayerManager.GetAliveMajorsCount() -1
        local MinorPlayersNumber = PlayerManager.GetAliveMinorsCount() -1

        Controls.OptionSliderMajor:SetValue(0.3)
        NumOfMajorToKill = Round(0.3*MajorPlayersNumber)
        Controls.OptionValueMajor:SetText(NumOfMajorToKill)
        Controls.OptionSliderMajor:RegisterSliderCallback(function(value)
                NumOfMajorToKill = Round(value * MajorPlayersNumber)
                Controls.OptionValueMajor:SetText(NumOfMajorToKill)
            end)
        Controls.OptionSliderMinor:SetValue(0.3)
        NumOfMinorToKill = Round(0.3*MinorPlayersNumber)
        Controls.OptionValueMinor:SetText(NumOfMinorToKill)
        Controls.OptionSliderMinor:RegisterSliderCallback(function(value)
                NumOfMinorToKill = Round(value * MinorPlayersNumber)
                Controls.OptionValueMinor:SetText(NumOfMinorToKill)
        
        end)
        Controls.CheckBoxSameContinent:RegisterCallback(Mouse.eLClick, function()
                local selected = not Controls.CheckBoxSameContinent:IsSelected();
                Controls.CheckBoxSameContinent:SetSelected(selected);
                SameContinent = selected
            end);
        Controls.CivChoiceScrollPanel:SetHide(true);



        PopulateComboBox(Controls.OptionPullDown, HowToKill_Table, "Random", function(option) 
            m_CivChoicesInst:ResetInstances()
            Controls.MajorSlider:SetHide(true)
            Controls.MinorSlider:SetHide(true)
            Controls.CheckBoxSameContinent:SetHide(true)
            Controls.CivChoiceScrollPanel:SetHide(false)
            SelectedPlayer = {}
            Controls.OkButton:RegisterCallback( Mouse.eLClick, function() OnSelecetedPlayerToKill(option) end)
            if option == "Random" then
                Controls.MajorSlider:SetHide(false)
                Controls.MinorSlider:SetHide(false)
                Controls.CheckBoxSameContinent:SetHide(false)
                Controls.CivChoiceScrollPanel:SetHide(true)
            elseif option == "OtherContinents" then
                Controls.CivChoiceScrollPanel:SetHide(true)
            elseif option == "OnlyCertainsPlayers" then
                
                local Count     = 0
                local instance  = m_CivChoicesInst:GetInstance()
                for ColorsData in GameInfo.PlayerColors() do
                    if ColorsData.Usage ~= "Major" and ColorsData.Type ~= "LEADER_FREE_CITIES" and ColorsData.Type ~= "CIVILIZATION_BARBARIAN" then
                        Count = Count+1
                        local selectControl = instance["Selected"..Count]
                        local leaderName    = "LOC_"..ColorsData.Type.."_NAME"
                        instance["Choose"..Count]:SetHide(false)
                        selectControl:SetHide(true)
                        instance["Choose"..Count]:RegisterCallback( Mouse.eLClick, function() 
                                selectControl:SetHide(not selectControl:IsHidden())
                                if selectControl:IsHidden() then
                                    for key, leaderName2 in pairs(SelectedPlayer) do
                                        if leaderName2 == ColorsData.Type then
                                            table.remove(SelectedPlayer, key)
                                            return;
                                        end
                                    end
                                    selectControl:SetHide(false)
                                    table.insert(SelectedPlayer, ColorsData.Type)
                                else
                                    table.insert(SelectedPlayer, ColorsData.Type)
                                end
                            end );
                        instance["ColorImage"..Count]:SetColor(0x00FFFFFF)
                        instance["Icon"..Count]:SetColor(0xFFFFFFFF)
                        instance["Icon"..Count]:SetIcon("ICON_"..ColorsData.Type)
                        instance["Name"..Count]:SetText(Locale.Lookup(leaderName))
                        if Count == 2 then
                            Count = 0
                            instance  = m_CivChoicesInst:GetInstance()
                        end
                    end
                end
                Count = Count +1
                for i = Count, 2 do
                    instance["Choose"..i]:SetHide(true)
                end
            else
                local Count              = 0
                local instance           = m_CivChoicesInst:GetInstance()
                local kPlayers	:table   = PlayerManager.GetWasEverAlive();
                for _, pPlayer in ipairs(kPlayers) do
                    local playerID                      = pPlayer:GetID();
                    if playerID < 60 then
                        local playerConfig                  = PlayerConfigurations[playerID]
                        local playerName                    = Locale.Lookup(playerConfig:GetCivilizationDescription());
                        local BackColor, FrontColor         = UI.GetPlayerColors(playerID);
                        Count = Count+1
                        local selectControl = instance["Selected"..Count]
                        instance["Choose"..Count]:SetHide(false)
                        selectControl:SetHide(true)
                        instance["Choose"..Count]:RegisterCallback( Mouse.eLClick, function() 
                                selectControl:SetHide(not selectControl:IsHidden())
                                if selectControl:IsHidden() then
                                    for key, player2ID in pairs(SelectedPlayer) do
                                        if player2ID == playerID then
                                            table.remove(SelectedPlayer, key)
                                            return;
                                        end
                                    end
                                    selectControl:SetHide(false)
                                    table.insert(SelectedPlayer, playerID)
                                else
                                    table.insert(SelectedPlayer, playerID)
                                end
                            end );
                        instance["ColorImage"..Count]:SetColor(BackColor)
                        instance["Icon"..Count]:SetColor(FrontColor)
                        instance["Icon"..Count]:SetIcon("ICON_" .. playerConfig:GetCivilizationTypeName() )
                        instance["Name"..Count]:SetText(Locale.Lookup(playerName))
                        if Count == 2 then
                            Count = 0
                            instance  = m_CivChoicesInst:GetInstance()
                        end
                    end
                end
                Count = Count +1
                for i = Count, 2 do
                    instance["Choose"..i]:SetHide(true)
                end
            end   
        end)
        Controls.SetColonialNation:SetHide(false);
    end
end
Events.LoadScreenClose.Add(OnLoadScreenClose);





function SetCityLoyalty(owner: number, cityID : number, cityX : number, cityY : number )
        local cityKey           = cityX.."."..cityY;
        if Loyalty[owner][cityKey] == nil then
            Loyalty[owner][cityKey] = {}
            Loyalty[owner][cityKey].ReligionStability                        = {};
            Loyalty[owner][cityKey].ReligionStability.Amount                 = 0;
            Loyalty[owner][cityKey].ReligionStability.tooltip                = "";
            
            Loyalty[owner][cityKey].LastRevoltTurn                           = -40;
            Loyalty[owner][cityKey].CurrentChanceOfRevolt                    = 0;
        
            Loyalty[owner][cityKey].Separatism                               = {};
            Loyalty[owner][cityKey].Separatism.Amount                        = 0;
            Loyalty[owner][cityKey].Separatism.tooltipOnSet                  = "";
            Loyalty[owner][cityKey].Separatism.tooltipPerTurn                = "";
            Loyalty[owner][cityKey].Separatism.NeedTest                      = false;
            
            Loyalty[owner][cityKey].ColonialRiotAmount                          = loadSlot("ColonialRiotAmount"..owner.."."..cityKey) and Round(loadSlot("ColonialRiotAmount"..owner.."."..cityKey)/3, 1)  or 0
            
            SaveToSlot( "LastRevoltTurn"..owner.."."..cityKey, Loyalty[owner][cityKey].LastRevoltTurn);
            SaveToSlot( "SeparatismAmount"..owner.."."..cityKey, 0)
            SaveToSlot( "ColonialRiotAmount"..owner.."."..cityKey, Loyalty[owner][cityKey].ColonialRiotAmount );
        
            local pPlayerCapital               = Players[owner]:GetCities():GetCapitalCity();
            if pPlayerCapital == nil and GameConfiguration.GetValue("CapitalCity"..owner) then
                pPlayerCapital = GetCity(GameConfiguration.GetValue("CapitalCity"..owner));
            elseif pPlayerCapital == nil and not GameConfiguration.GetValue("CapitalCity"..owner) then
                SaveToSlot("CapitalCity"..owner, cityKey)
                pPlayerCapital = GetCity(cityKey);
            end
            local DistancewithCapital       = 0;
            if pPlayerCapital ~= nil then
                DistancewithCapital         = Map.GetPlotDistance(cityX, cityY, pPlayerCapital:GetX(), pPlayerCapital:GetY());
            end
            if DistancewithCapital and DistancewithCapital >= MinimumDistanceForColonialRiot and owner == Game:GetLocalPlayer() and ReadyForPhase then 
                local CityName = Locale.Lookup(CityManager.GetCity(owner, cityID):GetName()) and Locale.Lookup(CityManager.GetCity(owner, cityID):GetName()) or "This city";
                SetDefaultNotificationTable(notifid, Currentturn(), Game:GetLocalPlayer());
                local NewColonialCity = {};
                for k,func in pairs (DefaultNotification) do
                    NewColonialCity[k] = func;
                end
                NewColonialCity.GetTypeName         = function() return "NOTIFICATION_CUSTOM_New_Colonial_City"; end
                NewColonialCity.GetIconName         = function() return "ICON_NOTIFICATION_GENERIC"; end
                NewColonialCity.GetMessage          = function() return "ATTENTION"; end
                NewColonialCity.GetSummary          = function() return CityName.." is too far from capital, this city could take independance in the futur"; end
                NewColonialCity.IsTargetValid       = function() return true; end
                NewColonialCity.GetTarget           = function() return owner, cityID, PlayerComponentTypes.CITY; end
                LuaEvents.CustomNotification_OnDefaultAddNotification(NewColonialCity)
            end
        
            if not Loyalty[cityKey] then
                Loyalty[cityKey]                                                    = {}; 
                Loyalty[cityKey].Heretics                                           = {}
                Loyalty[cityKey].Culture                                            = Loyalty[owner].Culture;
        
                Loyalty[cityKey].Migration                                          = {}                    -- ideal city is not at war and have a positive loyalty per turn
                Loyalty[cityKey].Migration.FleeWarLeaving                           = {}                      -- will search ideal city
                Loyalty[cityKey].Migration.ReligionLeaving                          = {}                      -- will search ideal city with ideal religion
                Loyalty[cityKey].Migration.GovernmentLeaving                        = {}                      -- will search ideal city with a different government
                Loyalty[cityKey].Migration.SeparatistLeaving                        = {}                      -- will search ideal city in his original country
                Loyalty[cityKey].Migration.FleeWarArrival                           = {}                      
                Loyalty[cityKey].Migration.ReligionArrival                          = {}                     
                Loyalty[cityKey].Migration.GovernmentArrival                        = {}                      
                Loyalty[cityKey].Migration.SeparatistArrival                        = {}      
                Loyalty[cityKey].Migration.currentMigration                         = 0                 
                Loyalty[cityKey].Migration.FleeWarTooltip                           = ""                      
                Loyalty[cityKey].Migration.ReligionTooltip                          = ""                     
                Loyalty[cityKey].Migration.GovernmentTooltip                        = ""                      
                Loyalty[cityKey].Migration.SeparatistTooltip                        = ""  
            
                SaveToSlot( "Culture"..cityKey, Loyalty[cityKey].Culture);
                SaveToSlot( "currentMigration"..cityKey, Loyalty[cityKey].Migration.currentMigration);
            end
        end
end

-- ===========================================================================
--  Usefull Function
-- ===========================================================================

function InitializeEachTurn(playerID)
    for _,pCity in Players[playerID]:GetCities():Members() do
        local citykey = pCity:GetX().."."..pCity:GetY();
        AllCityPlots[citykey] = Map.GetCityPlots():GetPurchasedPlots( pCity);
    end
    ActivePlayerID = playerID;
    if lastLoadTurn == nil then
        lastLoadTurn = Game.GetCurrentGameTurn();
    end
    if type(Loyalty[playerID].NeedSeparatismTest) == "number" then
        OnMakePeaceSetSeparatism(Loyalty[playerID].NeedSeparatismTest, playerID);
        Loyalty[playerID].NeedSeparatismTest = false;
        SaveToSlot("NeedSeparatismTest"..playerID, Loyalty[playerID].NeedSeparatismTest)
    end
    if playerID == 0 then
        local Obstacleplot      = {}
        local FalseObstacleplot = {}
        for k, UnitData in pairs(UnitToImmobilize) do
            local pUnit = UnitManager.GetUnit(UnitData.Owner, UnitData.GetUnitID)
            if pUnit and UnitData.GetUnitID then
                IsInTerritory[UnitData.GetUnitID] = true
                if  pUnit:GetX() > 0 and pUnit:GetY() > 0 and Map.GetPlot(pUnit:GetX(),pUnit:GetY()):GetOwner() ~= UnitData.where and UnitData.GetUnitID == pUnit:GetID() then
                    IsInTerritory[UnitData.GetUnitID] = false
                    local FoundTheWay = 0     
                    while FoundTheWay < 20 do
                        LuaEvents.GetUnitLocation(UnitData.Owner, UnitData.GetUnitID)
                        local UnitX = LastUnitLocationX
                        local UnitY = LastUnitLocationY
                        local path = MakepathToTerritory(UnitX, UnitY, UnitData.where, Obstacleplot, FalseObstacleplot) 
                        for Count, plotID in ipairs(path) do
                            local pPlot     = Map.GetPlotByIndex(plotID)
                            local x         = pPlot:GetX()
                            local y         = pPlot:GetY()
                            for i=0 , 2 do
                                LuaEvents.MoveUnitToLocation(UnitData.Owner, UnitData.GetUnitID, x, y);
                                if pUnit:GetX() == x and pUnit:GetY() == y then
                                    break;
                                end
                            end
                            if not UnitMoved then
                                Obstacleplot[plotID]         = true
                                if i ~= #path then
                                    for i = Count+1 ,#path do
                                        Obstacleplot[path[i]]        = false
                                        FalseObstacleplot[path[i]]   = false
                                    end
                                end
                                break;
                            elseif pPlot:GetOwner() == UnitData.where then
                                Obstacleplot[plotID]    = true
                                FoundTheWay             = 30
                                IsInTerritory[UnitData.GetUnitID] = true
                                for i = Count+1 ,#path do
                                    Obstacleplot[path[i]]        = false
                                    FalseObstacleplot[path[i]]   = false
                                end
                                break;
                            end
                        end
                        FoundTheWay             = FoundTheWay +1
                        if FoundTheWay > 20 then
                            break
                        end
                    end
                    for plotID, bool  in pairs(Obstacleplot) do
                        if FalseObstacleplot[plotID] then
                            Obstacleplot[plotID] = false
                        end
                    end
                    FalseObstacleplot = {}
                end
            end
        end
        UnitToImmobilize = {}
    end
    if CurrentEra ~= Game.GetEras():GetCurrentEra() then
        LastEraUnit             = {}
        WaterRiotUnit           = {}
        CurrentEra              = Game.GetEras():GetCurrentEra()
        for UnitData in GameInfo.Units() do
            local LastEraType = GameInfo.Eras[CurrentEra -1] and GameInfo.Eras[CurrentEra -1].EraType  or GameInfo.Eras[CurrentEra].EraType;
            if ((UnitData.PrereqTech and GameInfo.Technologies[UnitData.PrereqTech].EraType == LastEraType) or (UnitData.PrereqCivic and GameInfo.Civics[UnitData.PrereqCivic].EraType  == LastEraType)) and not UnitData.TraitType and UnitData.Combat > 1 then
                if  UnitData.Domain == "DOMAIN_LAND" then
                    table.insert(LastEraUnit, UnitData.UnitType)
                elseif UnitData.Domain == "DOMAIN_SEA" then
                    table.insert(WaterRiotUnit, UnitData.UnitType)
                end
            end
        end
    end
end
function UnitMovedOrNot(bool)
    UnitMoved = bool
end
LuaEvents.UnitMoved.Add(UnitMovedOrNot)
function SetUnitLocation(x,y)
    LastUnitLocationX = x
    LastUnitLocationY = y
end
LuaEvents.SetUnitLocation.Add(SetUnitLocation)
function MakepathToTerritory(UnitX, UnitY, where, Obstacleplot, FalseObstacleplot)
    local closestDistanceCity;
    local closestCity;
    for _, pCity in Players[where]:GetCities():Members() do
        local DistanceWithCity = Map.GetPlotDistance(pCity:GetX(), pCity:GetY(), UnitX, UnitY)
        if not closestDistanceCity or closestDistanceCity > DistanceWithCity then
            closestCity         = pCity 
            closestDistanceCity = DistanceWithCity
        end
    end
        
    local closestPlot   = Map.GetPlot(closestCity:GetX(), closestCity:GetY());
    local closestPlotID = closestPlot:GetIndex();
    local closestPlotX  = closestCity:GetX();
    local closestPlotY  = closestCity:GetY();
    local path          = {};
    local x             = UnitX;
    local y             = UnitY;
    for i = 0, 100 do
        local UnitLocationX = x;
        local UnitLocationY = y;
        x,y = GetNextPlotToTarget(UnitLocationY, closestPlotY, closestPlotX, UnitLocationX, Obstacleplot, FalseObstacleplot);                
        local plotID = Map.GetPlot(x,y):GetIndex();
        for key ,plot2ID in ipairs(path) do
            if plot2ID == plotID then
                while path[key] do
             --       Obstacleplot[path[key]]         = true
             --       FalseObstacleplot[path[key]]    = true
                    table.remove(path,key)            
                end
            end
        end
        table.insert(path, plotID)
        Obstacleplot[plotID]        = true
        FalseObstacleplot[plotID]   = true
        if closestPlotID == plotID or Map.GetPlotByIndex(plotID):GetOwner() == where then
            break;
        end
    end
    return path;
end
function GetAdjacentPlot(plotID)
    local pPlot = Map.GetPlotByIndex(plotID)
    local x   = pPlot:GetX()            
    local y   = pPlot:GetY() 
    local adjacentPlotID = {}
    if y % 2 == 0  then
        if Map.GetPlot(x +1, y) then
            table.insert(adjacentPlotID, Map.GetPlot(x +1, y))
        end
        if Map.GetPlot(x -1, y) then
            table.insert(adjacentPlotID, Map.GetPlot(x -1, y))
        end
        if Map.GetPlot(x, y +1) then
            table.insert(adjacentPlotID, Map.GetPlot(x, y +1))
        end
        if Map.GetPlot(x, y -1) then
            table.insert(adjacentPlotID, Map.GetPlot(x, y -1))
        end
        if Map.GetPlot(x -1, y +1) then
            table.insert(adjacentPlotID, Map.GetPlot(x -1, y +1))
        end
        if Map.GetPlot(x -1, y -1) then
            table.insert(adjacentPlotID, Map.GetPlot(x -1, y -1))
        end
    else
        if Map.GetPlot(x +1, y) then
            table.insert(adjacentPlotID, Map.GetPlot(x +1, y))
        end
        if Map.GetPlot(x -1, y) then
            table.insert(adjacentPlotID, Map.GetPlot(x -1, y))
        end
        if Map.GetPlot(x, y +1) then
            table.insert(adjacentPlotID, Map.GetPlot(x, y +1))
        end
        if Map.GetPlot(x, y -1) then
            table.insert(adjacentPlotID, Map.GetPlot(x, y -1))
        end
        if Map.GetPlot(x +1, y +1) then
            table.insert(adjacentPlotID, Map.GetPlot(x +1, y +1))
        end
        if Map.GetPlot(x +1, y -1) then
            table.insert(adjacentPlotID, Map.GetPlot(x +1, y -1))
        end
    end
    return adjacentPlotID;
end

function GetNextPlotToTarget(UnitLocationY, targetY, targetX, UnitLocationX, Obstacleplot, FalseObstacleplot)
    local UnitLocationPlotID         = Map.GetPlot(UnitLocationX, UnitLocationY):GetIndex()     
    local UnitLocationAdjacentPlotID = GetAdjacentPlot(UnitLocationPlotID)
    local x;
    local y;
    local CloserDistanceWithPlot;
    for _, pPlot in ipairs(UnitLocationAdjacentPlotID) do
         local plotID = pPlot:GetIndex()
         if pPlot:GetX() == targetX and pPlot:GetY() == targetY then
            x = pPlot:GetX();
            y = pPlot:GetY();
            break;
         end
         if pPlot:IsImpassable() or pPlot:IsWater() then
            Obstacleplot[plotID] = true
         end
         local DistanceWithPlot = Map.GetPlotDistance(pPlot:GetX(), pPlot:GetY(), targetX, targetY)
         if not Obstacleplot[plotID] and (not CloserDistanceWithPlot or DistanceWithPlot < CloserDistanceWithPlot) then
            CloserDistanceWithPlot = DistanceWithPlot;
            x = pPlot:GetX();
            y = pPlot:GetY();
         end
    end
        CloserDistanceWithPlot = nil
    if not x or not y then
        for _, pPlot in ipairs(UnitLocationAdjacentPlotID) do
            local plotID = pPlot:GetIndex()
            if FalseObstacleplot[plotID] then
                Obstacleplot[UnitLocationPlotID] = true
                FalseObstacleplot[UnitLocationPlotID] = false
                FalseObstacleplot[plotID]        = false
                Obstacleplot[plotID]             = false
            end
            local DistanceWithPlot = Map.GetPlotDistance(pPlot:GetX(), pPlot:GetY(), targetX, targetY)
            if not Obstacleplot[plotID] and (not CloserDistanceWithPlot or DistanceWithPlot < CloserDistanceWithPlot) then
                CloserDistanceWithPlot = DistanceWithPlot;
                x = pPlot:GetX();
                y = pPlot:GetY();
            end
        end
    end
    return x,y
end


local lastLoadTurn = 0;
function Currentturn ()                         
    local CurrentTurn = Game.GetCurrentGameTurn();   
    return CurrentTurn;
end

function deepcompare(t1,t2,ignore_mt)
local ty1 = type(t1);
local ty2 = type(t2);
if ty1 ~= ty2 then return false; end
-- non-table types can be directly compared
if ty1 ~= 'table' and ty2 ~= 'table' then return t1 == t2; end
-- as well as tables which have the metamethod __eq
local mt = getmetatable(t1)
if not ignore_mt and mt and mt.__eq then return t1 == t2; end
for k1,v1 in pairs(t1) do
local v2 = t2[k1];
if v2 == nil or not deepcompare(v1,v2) then return false; end
end
for k2,v2 in pairs(t2) do
local v1 = t1[k2];
if v1 == nil or not deepcompare(v1,v2) then return false; end
end
return true
end

function WhatDif(t1,t2)
    for k1,v1 in pairs(t1) do
        local bEqual = false;
        for k2,v2 in pairs(t2) do 
            if v1 == v2 then
                bEqual = true;
            end
        end
        if not bEqual then
            return v1, false, k1;
        end
    end
    for k2,v2 in pairs(t2) do
        local bEqual = false;
        for k1,v1 in pairs(t1) do 
            if v1 == v2 then
                bEqual = true;
            end
        end
        if not bEqual then
            return v2, true;
        end
    end
    return false;
end

function SetDiplomacyPeace(player1ID,player2ID)
    SaveToSlot(player1ID..".Atwarwith."..player2ID, false)
    SaveToSlot(player2ID..".Atwarwith."..player1ID, false)
end
function SetDiplomacyWar(player1ID,player2ID)
    SaveToSlot(player1ID..".Atwarwith."..player2ID, true)
    SaveToSlot(player2ID..".Atwarwith."..player1ID, true)
end

function GetEraModifier(ModifierType)
   local currentEra:number      = Game.GetEras():GetCurrentEra();  
   local currentEraName:string  = GameInfo.Eras[currentEra].Name;
   local eraModifier          = 0;

    if currentEraName == "LOC_ERA_ANCIENT_NAME" then                     -- set era modifier
        if ModifierType == "eraeraReligionMultiplier" then 
            eraModifier = 1;
        elseif ModifierType == "eraWarExhaustionModifier" then
            eraModifier = -5;
        elseif ModifierType == "eraMigrationDistance" then
            eraModifier = 10;
        end
        
    elseif currentEraName == "LOC_ERA_CLASSICAL_NAME" then
        if ModifierType == "eraReligionMultiplier" then 
            eraModifier = 1;
        elseif ModifierType == "eraWarExhaustionModifier" then
            eraModifier = -10;
        elseif ModifierType == "eraMigrationDistance" then
            eraModifier = 15;
        end
        
    elseif currentEraName == "LOC_ERA_MEDIEVAL_NAME" then
        if ModifierType == "eraReligionMultiplier" then 
            eraModifier = 1.5;
        elseif ModifierType == "eraWarExhaustionModifier" then
            eraModifier = -15;
        elseif ModifierType == "eraMigrationDistance" then
            eraModifier = 20;
        end
        
    elseif currentEraName == "LOC_ERA_RENAISSANCE_NAME" then
        if ModifierType == "eraReligionMultiplier" then 
            eraModifier = 1.5;
        elseif ModifierType == "eraWarExhaustionModifier" then
            eraModifier = -20;
        elseif ModifierType == "eraMigrationDistance" then
            eraModifier = 25;
        end
        
    elseif currentEraName == "LOC_ERA_INDUSTRIAL_NAME" then
        if ModifierType == "eraReligionMultiplier" then 
            eraModifier = 1;
        elseif ModifierType == "eraWarExhaustionModifier" then
            eraModifier = -30;
        elseif ModifierType == "eraMigrationDistance" then
            eraModifier = 30;
        end
        
    elseif currentEraName == "LOC_ERA_MODERN_NAME" then
        if ModifierType == "eraReligionMultiplier" then 
            eraModifier = 0.5;
        elseif ModifierType == "eraWarExhaustionModifier" then
            eraModifier = -35;
        elseif ModifierType == "eraMigrationDistance" then
            eraModifier = 35;
        end
        
    elseif currentEraName == "LOC_ERA_ATOMIC_NAME" then
        if ModifierType == "eraReligionMultiplier" then 
            eraModifier = 0.5;
        elseif ModifierType == "eraWarExhaustionModifier" then
            eraModifier = -40;
        elseif ModifierType == "eraMigrationDistance" then
            eraModifier = 40;
        end
        
    elseif currentEraName == "LOC_ERA_INFORMATION_NAME" then
        if ModifierType == "eraReligionMultiplier" then 
            eraModifier = 0.1;
        elseif ModifierType == "eraWarExhaustionModifier" then
            eraModifier = -40;
        elseif ModifierType == "eraMigrationDistance" then
            eraModifier = 50;
        end
        
    elseif type(currentEraName) == "string" then
        print("Error unknow era "..currentEraName);
        eraModifier = 0;
    else
        print("Error  currentEraName is "..type(currentEraName));
        eraModifier = 0;      
    end
    if eraModifier == 0 then
        if ModifierType == "eraReligionMultiplier" then 
            eraModifier = 1;
        elseif ModifierType == "eraWarExhaustionModifier" then
            eraModifier = -20;
        elseif ModifierType == "eraMigrationDistance" then
            eraModifier = 50;
        end
    end
    return eraModifier
end

function GetCity(cityKey)
    local Dot = 3
    for i = string.len(cityKey), 1, -1 do
        if string.sub(cityKey,i,i) == "." then
            Dot = i
        end
    end

    local plotX = string.sub(cityKey, 0, Dot -1)
    local plotY = string.sub(cityKey, Dot +1)
    local pCity = CityManager.GetCityAt(plotX, plotY);
    return pCity
end

function GetCityOwner(cityKey)
    return loadSlot("CityOwner"..cityKey);
end

function GetAmountMigration(tMigration, migrantType) 
    local Amount = 0
        for migrantTypeName,tMigrantType in pairs(tMigration) do 
            if type(tMigrantType) == "table" and (migrantTypeName == migrantType or migrantType == "Total" or (migrantType == "Arrival" and string.find(migrantTypeName, "Arrival")) or (migrantType == "Leaving" and string.find(migrantTypeName, "Leaving") )) then 
                for _,MigrantAmount in pairs(tMigrantType) do 
                    Amount = Amount + MigrantAmount
                end 
            end
        end
    return Amount;
end 

function GetLoyaltyModPerTurn(cityKey, playerID)
    return Loyalty[playerID].GovernmentStability.Amount + Loyalty[playerID].WarExhaustion.Amount + Loyalty[playerID][cityKey].ReligionStability.Amount + Loyalty[playerID][cityKey].Separatism.Amount;
end

function AddSortString ( stringtosort, addstring, addafter, secondadd )

    local sortedAddString = stringtosort
    local stringtosort2   = sortedAddString 
    local _, after   = string.find(addstring, addafter)
    local iToSort    = tonumber(string.match(addstring,"%d+", after) )
    local there = 0
    while sortedAddString == stringtosort2 do
        local here , after   = string.find(stringtosort, addafter)
        if here ~= nil then
            local sortwith   = tonumber(string.match(stringtosort,"%d+", after) )
            there = - #(string.sub(stringtosort,after)) - #(addafter) - #(secondadd)
  

            if sortwith   < iToSort    then
                  sortedAddString = string.sub(sortedAddString, 0,there)..addstring..secondadd..string.sub(stringtosort,here)

            else
               stringtosort = string.sub(stringtosort,after)
            end
        else
             sortedAddString = sortedAddString..addstring
        end
    end
    return sortedAddString
end

function CountAndCut(stringtocut, stringadd1, stringadd2, stringadd3, whereCut, whatToCount)
    local CuttedString = stringtocut
    local Count = 0
    local Count2 = 0
    local numberof = 0
    local where  = 0
    while string.find(stringtocut, whatToCount) do
        here, after = string.find(stringtocut, whatToCount)
        Count = Count + 1
        stringtocut = string.sub(stringtocut, after)
        if Count > whereCut then
            if where == 0 then 
                where = - #(stringtocut) - #(whatToCount) - 1
            end
            numberof = numberof + tonumber(string.match(stringtocut ,"%d+") )
            Count2 = Count2 +1
        end
    end
    if Count2 > 1 then
        CuttedString = string.sub(CuttedString, 0, where)..stringadd1..numberof ..stringadd2..Count2..stringadd3
    end
    return CuttedString;
end

function spairs(t, order)
    -- collect the keys
    local keys = {}
    for k in pairs(t) do keys[#keys+1] = k end

    -- if order function given, sort by it by passing the table and keys a, b,
    -- otherwise just sort the keys 
    if order then
        table.sort(keys, function(a,b) return order(t, a, b) end)
    else
        table.sort(keys)
    end

    -- return the iterator function
    local i = 0
    return function()
        i = i + 1
        if keys[i] then
            return keys[i], t[keys[i]]
        end
    end
end

-- ===========================================================================
--  War Exhaustion
-- ===========================================================================
 

function SetWarExhaustion(playerID,Value)                    
    Loyalty[playerID].WarExhaustion.Amount    = Loyalty[playerID].WarExhaustion.Amount + Value;
    if Loyalty[playerID].WarExhaustion.Amount <= -300 then -- war exhaustion level can't be less than -300 
        Loyalty[playerID].WarExhaustion.Amount = -300;
    elseif Loyalty[playerID].WarExhaustion.Amount >= 0 then -- war exhaustion level can't be more more than 0
        Loyalty[playerID].WarExhaustion.Amount = 0;  
    end
    SaveToSlot("WarExhaustionAmount"..playerID, Loyalty[playerID].WarExhaustion.Amount)
    LuaEvents.LoyaltyChanged(playerID);
end
  
function SetWarExhaustionTooltip (playerID)
    local tooltip = "[ICON_DECLARE_RECONQUEST_WAR]War Exhaustion [NEWLINE][NEWLINE]";
    if Loyalty[playerID].WarExhaustion.WarDeclarationTurn and Loyalty[playerID].WarExhaustion.WarDeclarationTurn + 10 > Currentturn() then
        tooltip = tooltip..Loyalty[playerID].WarExhaustion.WarmongerTooltip;
    end
    if Loyalty[playerID].WarExhaustion.WarExhaustionPerTurnTooltip  then
        tooltip = tooltip..Loyalty[playerID].WarExhaustion.WarExhaustionPerTurnTooltip;
    end
    if Loyalty[playerID].WarExhaustion.WarEventTooltip[Currentturn()] then
        tooltip = tooltip.."[NEWLINE][NEWLINE]Event of This turn:";
        tooltip = tooltip..Loyalty[playerID].WarExhaustion.WarEventTooltip[Currentturn()];
    end
    
    if Loyalty[playerID].WarExhaustion.WarEventTooltip[Currentturn()-1] and Loyalty[playerID].WarExhaustion.WarEventTooltip[Currentturn()-1] ~= "" then
        tooltip = tooltip.."[NEWLINE][NEWLINE]previous turn event:";
        tooltip = tooltip..Loyalty[playerID].WarExhaustion.WarEventTooltip[Currentturn()-1];
    end
    Loyalty[playerID].WarExhaustion.WarEventTooltip[Currentturn()-2] = nil
    return tooltip;
end

function SetWarExhaustionOnDeclareWar( eAttackingPlayerID, eDefendingPlayerID ) -- Gain War Exhaustion when declaring war depending on warmonger
        if Loyalty[eAttackingPlayerID].WarExhaustion.WarcountTurn  == nil then
            Loyalty[eAttackingPlayerID].WarExhaustion.WarcountTurn = Currentturn() -1;
        end
        local eraModifier               = GetEraModifier("eraWarExhaustionModifier");
        local tooltip                   = "";
        SetWarExhaustion(eAttackingPlayerID, eraModifier);
    
        if Loyalty[eAttackingPlayerID].WarExhaustion.WarDeclarationTurn and Loyalty[eAttackingPlayerID].WarExhaustion.WarDeclarationTurn + 10 > Currentturn() then
            Loyalty[eAttackingPlayerID].WarExhaustion.WarmongerTooltip    = tooltip..Loyalty[eAttackingPlayerID].WarExhaustion.WarmongerTooltip;
        else
            Loyalty[eAttackingPlayerID].WarExhaustion.WarmongerTooltip    = tooltip;
        end
        Loyalty[eAttackingPlayerID].WarExhaustion.WarDeclarationTurn      = Currentturn();
        SaveToSlot("WarExhaustionWarDeclarationTurn"..eAttackingPlayerID, Loyalty[eAttackingPlayerID].WarExhaustion.WarDeclarationTurn)
        SaveToSlot("WarExhaustionWarcountTurn"..eAttackingPlayerID, Loyalty[eAttackingPlayerID].WarExhaustion.WarcountTurn)
end

function IsAtWarWithWho(playerID)                                   -- return with who the player is at war with
    local pPlayersAtWarWith = {};
    local count             = 0;
    local kPlayers	 :table = PlayerManager.GetWasEverAlive();
    for _, pOtherPlayer in ipairs(kPlayers) do
        local otherPlayerID = pOtherPlayer:GetID();
        if otherPlayerID ~= playerID then
            if loadSlot(playerID..".Atwarwith."..otherPlayerID) then
                count = count + 1
                pPlayersAtWarWith[count] = otherPlayerID
            end
        end    
	end
    if count == 0 then
        return false;
    else
        return pPlayersAtWarWith;
    end
end

function AddWarExhaustionlevel (playerID)                              -- War exhaustion per turn from war or peace and occupied and besieged city
                local pPlayer1          = Players[playerID];
                local WarExhaustion2    = Loyalty[playerID].WarExhaustion.Amount;
                local tooltip           = "[NEWLINE]Loyalty per turn:";
                if  IsAtWarWithWho(playerID) then  -- war exhaustion level can't be less than -300 
                    if Loyalty[playerID].WarExhaustion.WarcountTurn == nil then
                        Loyalty[playerID].WarExhaustion.WarcountTurn = Currentturn() - 1;
                        SaveToSlot("WarExhaustionWarcountTurn"..playerID, Loyalty[playerID].WarExhaustion.WarcountTurn)
                    end
                    local WarDurationMultiplier = Round((Loyalty[playerID].WarExhaustion.WarcountTurn - Currentturn())/30,1);
                    SetWarExhaustion(playerID, -WarDurationMultiplier);  -- war exhaustion per turn from war
                    local enemiesID = IsAtWarWithWho(playerID);
                    local count = 0;
                    for i,EnemyID in pairs (enemiesID) do
                        local pEnemy    = Players[EnemyID];
                        local CityCount = 0
                        for _, pCity in pEnemy:GetCities():Members() do
                            CityCount = CityCount +1
                            if pCity ~= nil and pCity:IsOccupied() and pCity:GetOwnerBeforeOccupation() == playerID then  -- war exhaustion per turn per city occupied by the enemy
                                SetWarExhaustion(playerID,-1);
                                count = count -1;
                            end
                        end
                        if CityCount == 0 then
                            for _, enemy2ID in ipairs(IsAtWarWithWho(EnemyID)) do
                                GameConfiguration.SetValue(playerID..".Atwarwith."..enemy2ID, false)
                                GameConfiguration.SetValue(enemy2ID..".Atwarwith."..playerID, false)
                            end
                        end
                    end
                    if WarDurationMultiplier ~= 0 then
                        tooltip = tooltip.."[NEWLINE][ICON_PressureDown]"..WarDurationMultiplier.." Cause of [ICON_Razed][ICON_Turn]War Duration (".. Currentturn() - Loyalty[playerID].WarExhaustion.WarcountTurn .." turn)";
                    else
                        WarDurationMultiplier = 0.1
                        tooltip = tooltip.."[NEWLINE][ICON_PressureDown]"..WarDurationMultiplier.." Cause of [ICON_Razed][ICON_Turn]War Duration (".. Currentturn() - Loyalty[playerID].WarExhaustion.WarcountTurn .." turn)";
                    end
                    if count == -1 then
                        tooltip = tooltip.."[NEWLINE][ICON_PressureDown]-1 Because one of your city is [ICON_Occupied]Occupied ";
                    elseif count < -1 then
                        tooltip = tooltip.."[NEWLINE][ICON_PressureDown]"..count.." Because you have "..-count.." Cities [ICON_Occupied]Occupied "; 
                    end
                    local count = 0;    
                    for _, pCity in pPlayer1:GetCities():Members() do
                        if pCity ~= nil then
                            local cityDistricts = pCity:GetDistricts();
                            for i,district in cityDistricts:Members() do
                                local districtInfo:table = GameInfo.Districts[district:GetType()];
                                local districtName = districtInfo.Name;
                                if districtName == "LOC_DISTRICT_CITY_CENTER_NAME" and district:IsUnderSiege() then -- war exhaustion per turn per city under siege
                                    SetWarExhaustion(playerID,-1);
                                    count = count -1;
                                end
                            end
                        end
                    end
                    if count == -1 then
                        tooltip = tooltip.."[NEWLINE][ICON_PressureDown]-1 Because one of your city is [ICON_UnderSiege]Under Siege "; 
                    elseif count < -1 then
                        tooltip = tooltip.."[NEWLINE][ICON_PressureDown]"..count.." Because you have "..-count.." Cities [ICON_UnderSiege]Under Siege "; 
                    end
                elseif  (not IsAtWarWithWho(playerID)) then 
                    SetWarExhaustion(playerID,3);                             -- war exhaustion per turn from peace
                    tooltip = tooltip.."[NEWLINE][ICON_PressureUp]+3 due to [ICON_MAKE_PEACE]peace";
                    if Loyalty[playerID].WarExhaustion.WarcountTurn ~= nil then
                        Loyalty[playerID].WarExhaustion.WarcountTurn = nil;
                        SaveToSlot("WarExhaustionWarcountTurn"..playerID, nil)
                    end
                end
                Loyalty[playerID].WarExhaustion.WarExhaustionPerTurnTooltip = tooltip;        
end  
        

function OnCombat( combatResult )                           -- add war exhaustion after combat 
    local attacker                  = combatResult[CombatResultParameters.ATTACKER];
    local defender                  = combatResult[CombatResultParameters.DEFENDER];
    local attackerid                = attacker[CombatResultParameters.ID].player; -- get attacker player ID
    local defenderid                = defender[CombatResultParameters.ID].player; -- get defender player ID
    local pPlayer1                  = Players[attackerid]; 
    local pPlayer2                  = Players[defenderid];
    local AttackerDamageDone        = defender[CombatResultParameters.DAMAGE_TO]; -- damge done by attacker
    local DefenderDamageDone        = attacker[CombatResultParameters.DAMAGE_TO]; -- damge done by Defender
    local AttackerWarExhaustionLoss = Round (-DefenderDamageDone/15,0);
    local DefenderWarExhaustionLoss = Round (-AttackerDamageDone/15,0); -- damagetaken/15
    local TooltipAttacker           = "";
    local TooltipDefender           = "";
    local AttackerHPBeforeAttack    = attacker[CombatResultParameters.MAX_HIT_POINTS] - attacker[CombatResultParameters.FINAL_DAMAGE_TO] + attacker[CombatResultParameters.DAMAGE_TO];
    local DefenderHPBeforeAttack    = defender[CombatResultParameters.MAX_HIT_POINTS] - defender[CombatResultParameters.FINAL_DAMAGE_TO] + defender[CombatResultParameters.DAMAGE_TO]; 

    if (attacker[CombatResultParameters.ID].type == ComponentType.UNIT) and (attacker[CombatResultParameters.FINAL_DAMAGE_TO] >= attacker[CombatResultParameters.MAX_HIT_POINTS]) then
        AttackerWarExhaustionLoss = Round (-AttackerHPBeforeAttack/15,0) - 3;
        SetWarExhaustion(attackerid, AttackerWarExhaustionLoss );  -- war exhaustion per turn from unit killed for attacker
        TooltipAttacker = "[NEWLINE][ICON_PressureDown]".. AttackerWarExhaustionLoss.." Because you lost a [ICON_Unit][ICON_UnderSiege]Unit which had "..AttackerHPBeforeAttack .."hp"
    elseif AttackerWarExhaustionLoss ~= 0 then
         SetWarExhaustion(attackerid, AttackerWarExhaustionLoss );  -- war exhaustion per turn from combat
         TooltipAttacker = "[NEWLINE][ICON_PressureDown]"..AttackerWarExhaustionLoss.." Because one of your [ICON_Unit][ICON_Damaged]units lost "..DefenderDamageDone.."hp";
    end
    
    if (defender[CombatResultParameters.ID].type == ComponentType.UNIT) and (defender[CombatResultParameters.FINAL_DAMAGE_TO] >= defender[CombatResultParameters.MAX_HIT_POINTS]) then
        DefenderWarExhaustionLoss = Round (-DefenderHPBeforeAttack/15,0) - 3;
        SetWarExhaustion(defenderid, DefenderWarExhaustionLoss);  -- war exhaustion per turn from unit killed for defender
        TooltipDefender = "[NEWLINE][ICON_PressureDown]".. DefenderWarExhaustionLoss.." Because you lost a [ICON_Unit][ICON_UnderSiege]Unit which had "..DefenderHPBeforeAttack.."hp";
    elseif DefenderWarExhaustionLoss ~= 0 then
        SetWarExhaustion(defenderid, DefenderWarExhaustionLoss );  -- war exhaustion per turn from combat)
        TooltipDefender = "[NEWLINE][ICON_PressureDown]"..DefenderWarExhaustionLoss.." Because one of your [ICON_Unit][ICON_Damaged]units lost "..AttackerDamageDone.."hp";
    end
    if Loyalty[attackerid].WarExhaustion.WarEventTooltip[Currentturn()] == nil then
        Loyalty[attackerid].WarExhaustion.WarEventTooltip[Currentturn()] = ""; 
    end
    Loyalty[attackerid].WarExhaustion.WarEventTooltip[Currentturn()] = Loyalty[attackerid].WarExhaustion.WarEventTooltip[Currentturn()]..TooltipAttacker;
    if Loyalty[defenderid].WarExhaustion.WarEventTooltip[Currentturn()] == nil then
        Loyalty[defenderid].WarExhaustion.WarEventTooltip[Currentturn()] = ""; 
    end
    Loyalty[defenderid].WarExhaustion.WarEventTooltip[Currentturn()] = Loyalty[defenderid].WarExhaustion.WarEventTooltip[Currentturn()]..TooltipDefender;

end




function exhaustionOnUnitCaptured (currentUnitOwner, unit, owningPlayer, capturingPlayer)  -- add war exhaustion if your unit get captured
    local OldOwner      = Players[currentUnitOwner]; 
    SetWarExhaustion(currentUnitOwner, -3 ); -- war exhaustion per turn from unit captured for currentowner
    if Loyalty[currentUnitOwner].WarExhaustion.WarEventTooltip[Currentturn()] then
        Loyalty[currentUnitOwner].WarExhaustion.WarEventTooltip[Currentturn()] = Loyalty[currentUnitOwner].WarExhaustion.WarEventTooltip[Currentturn()].."[NEWLINE][ICON_PressureDown]-3 One of your [ICON_Unit][ICON_Citizen]unit has been captured by the enemy";
    else
        Loyalty[currentUnitOwner].WarExhaustion.WarEventTooltip[Currentturn()] = "[NEWLINE][ICON_PressureDown]-3 One of your [ICON_Unit][ICON_Citizen]unit has been captured by the enemy";
    end
        

end




-- ===========================================================================
--  Religion Stability
-- ===========================================================================

function SetReligionStability(Value, playerID, cityKey)                    -- send ReligionMod value to Script and add ReligionModUI 
    Loyalty[playerID][cityKey].ReligionStability.Amount =  Value;
end

function SetReligion(playerID, cityKey)
    if playerID and cityKey then
        SetReligionModPerHeretics(playerID, cityKey) 
    elseif playerID then
        for _, pCity in Players[playerID]:GetCities():Members() do
            local cityKey   = pCity:GetX().."."..pCity:GetY(); 
            SetReligionModPerHeretics(playerID, cityKey) 
        end
    elseif cityKey then
        local playerID  = GetCity(cityKey):GetOwner()
        SetReligionModPerHeretics(playerID, cityKey) 
    else
        local kPlayers	:table = PlayerManager.GetWasEverAlive();
        for _, pPlayer in ipairs(kPlayers) do
            for _, pCity in pPlayer:GetCities():Members() do
                local playerID  = pPlayer:GetID()
                local cityKey   = pCity:GetX().."."..pCity:GetY(); 
                SetReligionModPerHeretics(playerID, cityKey) 
            end
        end
    end
end

function SetReligionModPerHeretics(playerID, cityKey)                           -- Is surely x2 too long but work :D

   local Your                   = " His ";
   local a                      = " a ";
   local you                    = "he";
   local eramultiplier          = GetEraModifier("eraReligionMultiplier");
   
   if playerID and cityKey then
    local pPlayer = Players[playerID]
    if pPlayer ~= nil then 
        local playerCities          = pPlayer:GetCities(); 
        local GovernmentMultiplier  = Loyalty[playerID].GovernmentStability.ReligionMultiplier;
        if GovernmentMultiplier == nil then
                GovernmentMultiplier = 1;
        end
        local TotalReligionMultiplier = GovernmentMultiplier * eramultiplier;
        local pCity                   = GetCity(cityKey)
        if pCity ~= nil then
                
            Loyalty[cityKey].Heretics   = {}
            local Value                 = 0;
            local tooltip               = "";
            local pCityName             = pCity:GetName();
            local CityID                = pCity:GetID();
            local pCityReligion         = pCity:GetReligion();
            local pPlayerReligion       = pPlayer:GetReligion();
            
            if pCityReligion ~= nil then
                local religionsInCity   = pCityReligion:GetReligionsInCity();  
                local MajorReligion     = pCity:GetReligion():GetMajorityReligion();
                local MajorPlayerReligion, CityMajorReligionTooltip = GetPlayerMajorReligion(playerID);
                if playerID == Game.GetLocalPlayer() then
                    Your    = " Your ";
                    you     = "you";
                end
                if Players[Game.GetLocalPlayer()]:GetReligion():GetReligionTypeCreated() == MajorPlayerReligion and MajorPlayerReligion ~= -1 then
                    a       = " Your ";
                end
                local ownPlayerReligion             = -5;
                local OwnPlayerReligionName         = "";
                local MajorPlayerReligionexeptpagan = -6;
                if pPlayerReligion ~= nil then
                    local OwnPlayerReligionType	= pPlayerReligion:GetReligionTypeCreated();
                        
                    if OwnPlayerReligionType ~= -1 then
                        ownPlayerReligion       = OwnPlayerReligionType;
                        OwnPlayerReligionName   = Game.GetReligion():GetName(ownPlayerReligion);
                     
                    end
        
                    tooltip = tooltip.."Era multiplier is "..eramultiplier.." [ICON_Government]Government multiplier is "..GovernmentMultiplier.."[NEWLINE]Your current Multiplier is"..TotalReligionMultiplier.."[NEWLINE]"; 
                    if MajorPlayerReligion == -10 then
                        tooltip = tooltip.."[NEWLINE]Religious unity of"..Your.."empire is too low, this results in great instability in all"..Your.."cities[NEWLINE]"..CityMajorReligionTooltip;
                    elseif ownPlayerReligion ~= -5 and MajorPlayerReligion ~= ownPlayerReligion then
                        local MajorPlayerReligionName = Game.GetReligion():GetName(MajorPlayerReligion) ~= "" and Game.GetReligion():GetName(MajorPlayerReligion) or "pagans"
                        tooltip = tooltip.."[NEWLINE]"..Your.."Empire Follow"..a.."[ICON_Faith]religion called "..MajorPlayerReligionName..CityMajorReligionTooltip.." and"..Your.."religion is "..Game.GetReligion():GetName(ownPlayerReligion)..","..Your.."Cities who do not follow this [ICON_Faith]religion are considered Heretical";
                    elseif ownPlayerReligion ~= -5 and MajorPlayerReligion == ownPlayerReligion then
                        tooltip = tooltip.."[NEWLINE]"..Your.."Empire Follow"..Your.."[ICON_Faith]religion called "..OwnPlayerReligionName..CityMajorReligionTooltip..","..Your.."Cities who do not follow this [ICON_Faith]religion are considered Heretical:";
                    elseif MajorPlayerReligion ~= -1 then
                        MajorPlayerReligionexeptpagan = MajorPlayerReligion
                        tooltip = tooltip.."[NEWLINE]"..Your.."Empire Follow"..a.."[ICON_Faith]religion called "..Game.GetReligion():GetName(MajorPlayerReligion)..CityMajorReligionTooltip..","..Your.."Cities who do not follow this [ICON_Faith]religion are considered Heretical:";
                    else
                        tooltip = tooltip.."[NEWLINE]"..Your.."Empire is Pagan: All [ICON_Faith]religions are considered heretical ";
                    end
                end
                    
                local MajorReligionExeptPagan   = -7;
                local MajorReligionName         = "";
                if MajorReligion ~= nil then
                     MajorReligionName = Game.GetReligion():GetName(MajorReligion);
                    if MajorReligionName ~= "" then
                        MajorReligionExeptPagan = MajorReligion;
                    end
                end
                if MajorReligion ~= MajorPlayerReligion and MajorReligionExeptPagan ~= ownPlayerReligion   then
                    Value = Value - 50 * TotalReligionMultiplier;
                    Loyalty[cityKey].CityIsHeretic = true
                    if MajorReligionName ~= "" then
                        tooltip = tooltip.."[NEWLINE][ICON_PressureDown]".. -50 * TotalReligionMultiplier .." This city Follows"..a.."[ICON_Faith]religion called "..MajorReligionName;
                    else
                        tooltip = tooltip.."[NEWLINE][ICON_PressureDown]".. -50 * TotalReligionMultiplier .." This city is pagan ";
                    end
                end
                if MajorReligionExeptPagan == MajorPlayerReligionexeptpagan or MajorReligionExeptPagan == ownPlayerReligion  then
                    Value = Value + 50 * TotalReligionMultiplier;
                    Loyalty[cityKey].CityIsHeretic = false
                    tooltip = tooltip.."[NEWLINE][ICON_PressureUp]+".. 50 * TotalReligionMultiplier .." This city is not considered Heretical cause it Follows a [ICON_Faith]religion called "..MajorReligionName;
                end 
                            
                if Players[Game.GetLocalPlayer()]:GetReligion():GetReligionTypeCreated() == MajorReligionExeptPagan then
                    a = " Your ";
                end     
                if MajorReligionName ~= "" and  OwnPlayerReligionName == MajorReligionName then
                        tooltip = tooltip.."[NEWLINE][NEWLINE]"..Your.."city follow"..Your.."[ICON_Faith]religion called "..OwnPlayerReligionName..", all other [ICON_Faith]religions and pagans are considered heretical:";
                elseif MajorReligionName ~= "" and OwnPlayerReligionName ~= "" then
                        tooltip = tooltip.."[NEWLINE][NEWLINE]"..Your.."city follow"..a.."[ICON_Faith]religion called "..MajorReligionName.." and "..you.." created a [ICON_Faith]religion called "..OwnPlayerReligionName..", all other religions and pagans are considered heretical: ";
                elseif MajorReligionName ~= "" then
                    tooltip = tooltip.."[NEWLINE][NEWLINE]"..Your.."city follow"..a.."[ICON_Faith]religion called "..MajorReligionName..", all other religions and pagans are considered heretical: ";
                else
                        tooltip = tooltip.."[NEWLINE][NEWLINE]"..Your.."city is pagan, all [ICON_Faith]religion are considered heretical: ";  
                end   
                for CityReligionid, CityReligion in pairs(religionsInCity) do
                                
                    local Followers         = CityReligion.Followers;
                    local pressure          = CityReligion.Pressure;
                    local ReligionID        = CityReligion.Religion;
                    local ReligionIDName    = Game.GetReligion():GetName(ReligionID);
                    local thereAre          = " There are ";
                    a                       = " a ";
                    if Players[Game.GetLocalPlayer()]:GetReligion():GetReligionTypeCreated() == ReligionID then
                        a                   = " Your ";
                    elseif ReligionIDName == OwnPlayerReligionName then
                        a                   = " his ";
                    end  
                    if Followers == 1 then
                        thereAre            = " There is ";         
                    end
                                 
                                
                    if ReligionID ~= MajorReligion and ReligionID ~= ownPlayerReligion and Followers ~= 0  then -- Loyalty lost per turn for every Heretics
                        Value = Value + Followers * -10 * TotalReligionMultiplier;
                        Loyalty[cityKey].Heretics[ReligionID] = Followers
                        if ReligionIDName ~= "" then
                            tooltip = tooltip.."[NEWLINE][ICON_PressureDown]"..Followers * -10 * TotalReligionMultiplier ..thereAre..Followers.."[ICON_Citizen]Heretics who follow"..a.."[ICON_Faith]religion called "..ReligionIDName;
                        else
                            tooltip = tooltip.."[NEWLINE][ICON_PressureDown]"..Followers * -10 * TotalReligionMultiplier ..thereAre..Followers.."[ICON_Citizen]pagans ";
                        end
                    end
                    if (ReligionID == MajorReligion or ReligionID == ownPlayerReligion) and ReligionIDName ~= "" and Followers ~= 0 then 
                    -- Loyalty Gain per turn for every Follower of good religion
                        Value = Value + Followers * 10 * TotalReligionMultiplier;
                        if ReligionID == ownPlayerReligion then
                            tooltip = tooltip.."[NEWLINE][ICON_PressureUp]+"..Followers * 10 * TotalReligionMultiplier ..thereAre..Followers.."[ICON_Citizen]Followers of"..Your.."[ICON_Faith]religion "..ReligionIDName;
                        else
                            tooltip = tooltip.."[NEWLINE][ICON_PressureUp]+"..Followers * 10 * TotalReligionMultiplier ..thereAre..Followers.."[ICON_Citizen]Followers of Dominant [ICON_Faith]religion in City "..ReligionIDName;
                        end    
                    end
                end
                            
                SetReligionStability(Value, playerID, cityKey);
                Loyalty[playerID][cityKey].ReligionStability.tooltip = tooltip;
            end
        end  
    end
   end
end




-- ===========================================================================
--  Revolt Type/Chance
-- ===========================================================================

function GetFreeWorkedPlot(pCityPlots, pCity)
    local tFreePlots  = {};
    for _, plotID in ipairs(pCityPlots) do
        local pPlot         = Map.GetPlotByIndex(plotID);
        local x             = pPlot:GetX();
        local y             = pPlot:GetY();
        local plot          = pCity:GetCitizens():IsPlotWorked(x,y);
        local plotDistrict  = GameInfo.Districts[pPlot:GetDistrictType()]
        if plot and #(Units.GetUnitsInPlot(pPlot)) == 0 and not pPlot:IsCity() and not (plotDistrict and plotDistrict.DistrictType == "DISTRICT_ENCAMPMENT") then 
            table.insert(tFreePlots, pPlot)
        end
    end
    return tFreePlots;
end

function RevoltType(  playerID, Nodice  )                                                      -- chance of revolt + chose revolt type function
    local playerConfig           = PlayerConfigurations[playerID];
    local pPlayername            = playerConfig:GetCivilizationDescription();
    local NotificationTurn      = Currentturn();
    local playerwarexhaustion   = Loyalty[playerID].WarExhaustion.Amount;                                       -- player WEP
    local pPlayer               = Players[playerID];
    local ReligionMOdValue      = 0;
    local LastRevoltTurn       = -40;
    local PlayerGovernmentMod   = Loyalty[playerID].GovernmentStability.Amount ;
    local Separatismlvl         = 0;
    
    
    for _, pCity in pPlayer:GetCities():Members() do                                            
        if pCity ~= nil then
           if playerID == 62 and math.random(0,10) > 8  then
                OnFreeCityRevolt(pCity:GetX(), pCity:GetY())
                return;
            end
            
            local sameTurn      = false
            local CityName      = pCity:GetName();
            local CityId        = pCity:GetID();
            local cityKey       = pCity:GetX().."."..pCity:GetY();
            if playerID == Game.GetLocalPlayer() then
                if Triggerturn[cityKey] == Currentturn() then
                    Triggerthisturn[cityKey]           = Triggerthisturn[cityKey] + 1
                elseif Triggerthisturn[cityKey] then
                    LastTurnNumberOfTrigger[cityKey]   = Triggerthisturn[cityKey]
                    Triggerthisturn[cityKey]           = 1
                    Triggerturn[cityKey]               = Currentturn()
                else
                    LastTurnNumberOfTrigger[cityKey]   = 20
                    Triggerthisturn[cityKey]           = 1
                    Triggerturn[cityKey]               = Currentturn()
                end
            end
            local pCityData     = GetCityData( pCity );
            ReligionMOdValue    = Loyalty[playerID][cityKey].ReligionStability.Amount;                          -- City Religion stability                              
            Separatismlvl       = Loyalty[playerID][cityKey].Separatism.Amount;                                 -- City Separatism lvl
            if type(ReligionMOdValue) ~= "number" then                                                              
                    ReligionMOdValue            = 0;
                    Loyalty[playerID][cityKey].ReligionStability.Amount   = 0;
            end
       
            
            
            if type(playerwarexhaustion) ~= "number" then                                   
                    playerwarexhaustion     = 0;
                    Loyalty[playerID].WarExhaustion.Amount   = 0;
            end
            
            
            
                LastRevoltTurn = Loyalty[playerID][cityKey].LastRevoltTurn;                                   -- City last revolt turn
             if type(LastRevoltTurn) ~= "number" then
                LastRevoltTurn                 = -40;
                Loyalty[playerID][cityKey].LastRevoltTurn    = -40;           
            end
            
            if type(PlayerGovernmentMod) ~= "number" then
                PlayerGovernmentMod     = 0;
                Loyalty[playerID].GovernmentStability.Amount   = 0;          
            end
            if type(Separatismlvl) ~= "number" then
                Separatismlvl           = 0;
                Loyalty[playerID][cityKey].Separatism.Amount = 0;
            end
            if bRevolt == nil then
                bRevolt = {};
            end
            
            local pPlayerCapital               = pPlayer:GetCities():GetCapitalCity();
            if pPlayerCapital == nil and GameConfiguration.GetValue("CapitalCity"..playerID) then
                pPlayerCapital = GetCity(GameConfiguration.GetValue("CapitalCity"..playerID));
            end
            local DistancebtweenCities       = 0;
            if pPlayerCapital ~= nil then
                DistancebtweenCities         = Map.GetPlotDistance(pCity:GetX(), pCity:GetY(), pPlayerCapital:GetX(), pPlayerCapital:GetY());
            end
            
            if not Nodice then
                local HasGarnison = 0
                local unitsInPlot       = Units.GetUnitsInPlot(Map.GetPlot(pCity:GetX(), pCity:GetY()));
                if #unitsInPlot > 0 then
                    for _, pUnit in ipairs(unitsInPlot) do
                        if pUnit:GetCombat() > 0 then
                            HasGarnison = pUnit:GetCombat() * 10 +100
                            break;
                        end
                    end
                end
                local DistrictNumber    = pCity:GetDistricts():GetCount()
                local Amenities         = pCity:GetGrowth():GetAmenities() 
                local hab               = pCity:GetPopulation()
                SetColonialRiot(playerID, cityKey, DistancebtweenCities, HasGarnison, DistrictNumber, Amenities, hab)
            end
            
            local ColonialRiot = Loyalty[playerID][cityKey].ColonialRiotAmount;
                
            
            
            if LastRevoltTurn + 30 < Currentturn() or (bRevolt[cityKey] and LastRevoltTurn + 20 < Currentturn()) then   
                local pCityCulturalIdentity     = pCity:GetCulturalIdentity(); 
                -- City current Loyalty per turn
                local LoyaltyPerTurn            = pCityCulturalIdentity:GetLoyaltyPerTurn() + playerwarexhaustion + ReligionMOdValue + PlayerGovernmentMod + Separatismlvl + ColonialRiot; 
                local Cityloyalty               = pCityCulturalIdentity:GetLoyalty();                                                                         -- City CurrentLoyalty
                if LoyaltyPerTurn < 0 or bRevolt[cityKey] then
                    local ChanceOfRevolt        = -LoyaltyPerTurn / Cityloyalty * 1000;                         -- Chance of revolt
                    local dice                  = math.random(0,1000);                                                      -- Dice   
                    local ArmyPower             = -LoyaltyPerTurn;
                    
                        local TypeOfRevolt                 = 4;
                        local TypeOfRevoltName             = "[ICON_Citizen][ICON_Pillaged]Populace";
                        local typeOfRevoltNotificationIcon = "ICON_NOTIFICATION_REBELLION";
                        local TypeOfRevoltNotificationType = "NOTIFICATION_CUSTOM_NEGATIVE_LOYALTY_POPULACE"
                    
                        
                        if pCity ~= pPlayerCapital and ( Separatismlvl < 0 or ColonialRiot < 0 or pCity:IsOccupied())  then 
                            -- Revolt Type 1
                            TypeOfRevolt                    = 1;
                            TypeOfRevoltName                = "[ICON_Razed][ICON_Pillaged]Separatist";
                            TypeOfRevoltNotificationType    = "NOTIFICATION_CUSTOM_NEGATIVE_LOYALTY_SEPARATIST";
                            typeOfRevoltNotificationIcon    = "ICON_NOTIFICATION_SPY_ENEMY_RECRUIT_PARTISANS";
                        elseif ReligionMOdValue < -50 then                                                                                     
                            -- Revolt Typre 2 
                             TypeOfRevolt                   = 2;    
                            TypeOfRevoltName                = "[ICON_Faith][ICON_Pillaged]Religious";
                            TypeOfRevoltNotificationType    = "NOTIFICATION_CUSTOM_NEGATIVE_LOYALTY_RELIGIOUS";
                            typeOfRevoltNotificationIcon    = "ICON_NOTIFICATION_REBELLION";
                        elseif playerwarexhaustion <= -50 or PlayerGovernmentMod <= -50 then                                                    
                            -- Revolt Type 3   
                            TypeOfRevolt                        = 3;
                            if PlayerGovernmentMod <= -50 then
                                TypeOfRevoltName                = "[ICON_Government][ICON_Pillaged]Government";
                                TypeOfRevoltNotificationType    = "NOTIFICATION_CUSTOM_NEGATIVE_LOYALTY_GOVERNMENT";
                                typeOfRevoltNotificationIcon    = "ICON_NOTIFICATION_REBELLION";
                            else
                                TypeOfRevoltName                = "[ICON_MAKE_PEACE][ICON_Pillaged]War Exhaustion";
                                TypeOfRevoltNotificationType    = "NOTIFICATION_CUSTOM_NEGATIVE_LOYALTY_WAR_EXHAUSTION";
                                typeOfRevoltNotificationIcon    = "ICON_NOTIFICATION_REBELLION";
                            end
                        end   
                    if not Nodice and (dice <= ChanceOfRevolt or bRevolt[cityKey])  then
                        
                        bRevolt[cityKey]           = false;

                        Loyalty[playerID][cityKey].LastRevoltTurn    = Currentturn();                                    -- set last revolt for city
                        LastRevoltTurn                 = Currentturn();
                        local pCityPlots                = Map.GetCityPlots():GetPurchasedPlots( pCity);
                        local CityPopulation            = pCity:GetPopulation();                                      -- Citypop
                        LuaEvents.restoreLoyalty( playerID, CityName );                                     -- restoreLoyalty   
                        GameConfiguration.SetValue(             "LastRevoltTurn"..playerID.."."..cityKey, Loyalty[playerID][cityKey].LastRevoltTurn);
                        GameConfiguration.SetValue(cityKey.."TypeOfRevolt",  TypeOfRevolt)
                        for Barbarianid,pBarbarian in pairs(Players) do  
                            if pBarbarian:IsBarbarian() then 
                                local otherPlayerID;
                                local kPlayers	:table = PlayerManager.GetWasEverAlive();
                                    for _,pPlayer2 in pairs(kPlayers) do 
                                        local player2ID = pPlayer2:GetID()
                                        if Loyalty[player2ID] and Loyalty[player2ID].Culture ==  Loyalty[cityKey].Culture then
                                            otherPlayerID = player2ID
                                            break;
                                        end
                                    end
                                if loadSlot(playerID..".Atwarwith."..otherPlayerID) == true then
                                    pBarbarian = Players[otherPlayerID]
                                end
                                local tFreePlots = GetFreeWorkedPlot(pCityPlots, pCity);    
                                local UnitCount = 0
                                
                                local EliteUnitNumber       = 0
                                local MaxEliteUnitNumber    = #tFreePlots * ArmyPower / 500
                                for _,WorkedPlot in pairs(tFreePlots) do                                    -- For each worked plot 1 barbare spawn
                                    if WorkedPlot then
                                        local BarbarianLocationx = WorkedPlot:GetX();
                                        local BarbarianLocationy = WorkedPlot:GetY();
                                        if WorkedPlot:IsWater() then 
                                            LuaEvents.LittleRevolt(Barbarianid,BarbarianLocationx,BarbarianLocationy, WaterRiotUnit[math.random(1,#WaterRiotUnit)], false);
                                        elseif EliteUnitNumber < MaxEliteUnitNumber then
                                            UnitCount               = UnitCount + 1
                                             LuaEvents.LittleRevolt(Barbarianid,BarbarianLocationx,BarbarianLocationy, LastEraUnit[math.random(1,#LastEraUnit)], true, cityKey, UnitCount);   -- spawn an elite barbarian
                                            EliteUnitNumber = EliteUnitNumber +1
                                            local UnitData          = {}
                                            UnitData.GetUnitID      = GameConfiguration.GetValue(cityKey..".siegeUnitID."..UnitCount)
                                            UnitData.Owner          = 63
                                            UnitData.where          = playerID
                                            table.insert(UnitToImmobilize, UnitData)
                                        else
                                            UnitCount               = UnitCount + 1
                                            LuaEvents.LittleRevolt(Barbarianid,BarbarianLocationx,BarbarianLocationy, "UNIT_WARRIOR", true, cityKey, UnitCount);   -- spawn barbarian
                                            local UnitData          = {}
                                            UnitData.GetUnitID      = GameConfiguration.GetValue(cityKey..".siegeUnitID."..UnitCount)
                                            UnitData.Owner          = 63
                                            UnitData.where          = playerID
                                            table.insert(UnitToImmobilize, UnitData)
                                        end
                                    end
                                end
                                GameConfiguration.SetValue(cityKey.."totalUnits", UnitCount )
                                GameConfiguration.SetValue(cityKey.."SiegeUnitCount",  UnitCount )
                                GameConfiguration.SetValue(cityKey..".IsDead."..UnitCount, false )
                                local CityResistance = 10 - UnitCount
                                for _,district in pCity:GetDistricts():Members() do
                                    CityResistance = CityResistance + district:GetDefenseStrength()/5
                                end
                                if CityResistance < 10 then
                                    CityResistance = 10
                                elseif CityResistance > 25 then
                                    CityResistance = 25
                                end
                                GameConfiguration.SetValue(cityKey.."SiegeTurnLeft", Round(CityResistance) )
                                sameTurn = true
                            end
                        end
                        local pPlayerCapital        =   pPlayer:GetCities():GetCapitalCity();
                        local DistancebtweenCities  = Map.GetPlotDistance(pCity:GetX(), pCity:GetY(), pPlayerCapital:GetX(), pPlayerCapital:GetY());
                        

                        if TypeOfRevolt == 1 then    -- Revolt Type 1
                            
                            
                        elseif TypeOfRevolt == 2 then                                                                                        -- Revolt Typre 2 
                            local MajorReligion     = pCity:GetReligion():GetMajorityReligion();
                            local MajorReligionName = Game.GetReligion():GetName(MajorReligion);
                            if MajorReligionName ~= "" then
                                LuaEvents.RevoltType2(CityName,playerID, 400);
                            else
                                -- no idea for now?
                            end
                            
                            
                            
                        elseif TypeOfRevolt == 3 then                                                       -- Revolt Type 3
                             for _, pCity2 in pPlayer:GetCities():Members() do  
                                local DistancebtweenCities2 = Map.GetPlotDistance(pCity:GetX(), pCity:GetY(), pCity2:GetX(), pCity2:GetY());
                                if DistancebtweenCities2 <= 10 then
                                    local cityKey2 = pCity2:GetX().."."..pCity2:GetY();
                                    local ReligionMOdValue2 = Loyalty[playerID][cityKey2].ReligionStability.Amount;
                                    local Separatismlvl2    = Loyalty[playerID][cityKey2].Separatism.Amount
                                    local ColonialRiot2     = Loyalty[playerID][cityKey2].ColonialRiotAmount
                                    local LoyaltyPerTurn2   = pCity2:GetCulturalIdentity():GetLoyaltyPerTurn() + playerwarexhaustion + ReligionMOdValue2 + PlayerGovernmentMod + Separatismlvl2 + ColonialRiot2;
                                    if LoyaltyPerTurn2 < 0 then
                                        bRevolt[cityKey2] = true;
                                    end  
                                end
                             end                           
                        end  
                    elseif Game.GetLocalPlayer() == playerID then
                        local ChanceOfRevoltSummary                       = Locale.Lookup(CityName).." Has "..Round(ChanceOfRevolt/10, 1).."% chance to have a "..TypeOfRevoltName.." revolt on next turn"
                            
                        SetDefaultNotificationTable(notifid, Currentturn(), Game:GetLocalPlayer());
                        local LosingLoyaltyNotification = {};
                        for k,func in pairs (DefaultNotification) do
                            LosingLoyaltyNotification[k] = func;
                        end  
                            
                        LosingLoyaltyNotification.GetTypeName         = function() return TypeOfRevoltNotificationType; end
                        LosingLoyaltyNotification.GetIconName         = function() return typeOfRevoltNotificationIcon; end
                        LosingLoyaltyNotification.GetType             = function() return 888889; end
                        LosingLoyaltyNotification.GetEventOnActivate= "ON_REVOLT_NOTIF_ACTIVATED" 
                        LosingLoyaltyNotification.GetMessage          = function() return "Attention!"; end
                        LosingLoyaltyNotification.GetSummary          = function() return ChanceOfRevoltSummary; end
                        LosingLoyaltyNotification.IsLocationValid     = function() return true; end
                        LosingLoyaltyNotification.GetLocation         = function() return pCity:GetX(), pCity:GetY(); end
                        LosingLoyaltyNotification.GetTarget           = function() return playerID, CityId, PlayerComponentTypes.CITY; end
                        table.insert(NotifTable, LosingLoyaltyNotification)
                        
                    elseif not Nodice then
                        if Cityloyalty + LoyaltyPerTurn < 500 then
                                local To500 = 500 - Cityloyalty - LoyaltyPerTurn;              -- City can not have less than 500 loyalty
                                LuaEvents.ChangeLoyaltyScript(To500, playerID, CityName);
                        end
                        local ModLoyaltyPerTurn = LoyaltyPerTurn - pCityCulturalIdentity:GetLoyaltyPerTurn(); 
                        LuaEvents.ChangeLoyaltyScript(ModLoyaltyPerTurn, playerID, CityName);
                        LuaEvents.LoyaltyChanged(playerID, CityId);
                    end
                elseif not Nodice then
                    local ModLoyaltyPerTurn = LoyaltyPerTurn - pCityCulturalIdentity:GetLoyaltyPerTurn(); 
                    LuaEvents.ChangeLoyaltyScript(ModLoyaltyPerTurn, playerID, CityName);
                    LuaEvents.LoyaltyChanged(playerID, CityId);
                end 
            elseif not Nodice then 
                LuaEvents.restoreLoyalty( playerID, CityName);
                bRevolt[cityKey] = false;
            end 
            if LastRevoltTurn + 31 > Currentturn() then
                local GoldLoss      = (LastRevoltTurn - Currentturn() + 31 ) * pCityData.GoldPerTurn /30;
                local FaithLoss     = (LastRevoltTurn - Currentturn() + 31 ) * pCityData.FaithPerTurn /30;
                local ScienceLoss   = (LastRevoltTurn - Currentturn() + 31 ) * pCityData.SciencePerTurn /30; 
                local CulturalLoss  = (LastRevoltTurn - Currentturn() + 31 ) * pCityData.CulturePerTurn /30;
                local LossString    = "[NEWLINE]-"..Round(GoldLoss,1).." [ICON_Gold]Gold, ";
                if not Nodice then
                    LuaEvents.NoMoreTax( -GoldLoss, playerID);                                     -- loss gold per turn if recent revolt
                end
                if ReligionMOdValue < -50 then
                    LossString     = LossString.."-"..Round(FaithLoss,1).." [ICON_Faith]faith, ";
                    if not Nodice then
                        LuaEvents.NoMoreFaith( -FaithLoss, playerID);                             -- loss faith per turn if recent ReligionRevolt
                    end
                end
                if playerwarexhaustion <= -50 or PlayerGovernmentMod <= -50 then            -- loss science and culture if recent WEP or Government rebelion revolt
                    LossString    = LossString.."-"..Round(ScienceLoss,1).." [ICON_Science]science, ";
                    LossString    = LossString.."-"..Round(CulturalLoss,1).." [ICON_Culture]Culture";
                    if not Nodice then
                        LuaEvents.NoMoreScience( -ScienceLoss, playerID);                        -- all effect can be stacked at same time
                        LuaEvents.NoMoreCulture( -CulturalLoss, playerID);  
                    end
                end
       --         GameConfiguration.SetValue(cityKey.."SiegeTurnLeft", -10)
                if GameConfiguration.GetValue(cityKey.."SiegeTurnLeft") and GameConfiguration.GetValue(cityKey.."SiegeTurnLeft") > -1 and not sameTurn  and not Nodice then
                    local NewCount = 0
                    for UnitCount = 1, GameConfiguration.GetValue(cityKey.."totalUnits") do
                        if not GameConfiguration.GetValue(cityKey..".IsDead."..UnitCount ) then
                            local pUnit = UnitManager.GetUnit(63, GameConfiguration.GetValue(cityKey..".siegeUnitID."..UnitCount))
                            if pUnit and pUnit:GetX() > 0 and  pUnit:GetY() > 0 and GameConfiguration.GetValue(cityKey..".siegeUnitID."..UnitCount) == pUnit:GetID() and IsInTerritory[pUnit:GetID()] ~= false then
                                NewCount                = NewCount + 1
                                local UnitData          = {}
                                UnitData.GetUnitID      = pUnit:GetID()
                                UnitData.Owner          = pUnit:GetOwner()
                                UnitData.where          = playerID
                                table.insert(UnitToImmobilize, UnitData)
                            else
                                GameConfiguration.SetValue(cityKey..".IsDead."..UnitCount, true )
                            end
                        end
                    end
                    GameConfiguration.SetValue(cityKey.."SiegeTurnLeft", GameConfiguration.GetValue(cityKey.."SiegeTurnLeft") + GameConfiguration.GetValue(cityKey.."SiegeUnitCount") - NewCount - 1  ) 
                    GameConfiguration.SetValue(cityKey.."SiegeUnitCount", NewCount)
                    if GameConfiguration.GetValue(cityKey.."SiegeTurnLeft") <= 0 and NewCount ~= 0 then
                        local TypeOfRevolt = GameConfiguration.GetValue(cityKey.."TypeOfRevolt")
                        if TypeOfRevolt == 1 then
                            local UnitsID = {}
                            for UnitCount = 1, GameConfiguration.GetValue(cityKey.."totalUnits") do
                                if not GameConfiguration.GetValue(cityKey..".IsDead."..UnitCount ) then                  
                                    table.insert(UnitsID,  GameConfiguration.GetValue(cityKey..".siegeUnitID."..UnitCount));
                                end
                            end
                            GameConfiguration.SetValue(cityKey.."OwnerBeforeUprise", playerID)
                            LuaEvents.RevoltType1(CityId, playerID, UnitsID, 63)
                            
                             for _, pCity2 in pPlayer:GetCities():Members() do  
                                local DistancebtweenCities2 = Map.GetPlotDistance(pCity:GetX(), pCity:GetY(), pCity2:GetX(), pCity2:GetY());
                                if DistancebtweenCities2 <= 15 then
                                    local cityKey2 = pCity2:GetX().."."..pCity2:GetY();
                                    local ReligionMOdValue2 = Loyalty[playerID][cityKey2].ReligionStability.Amount;
                                    local Separatismlvl2    = Loyalty[playerID][cityKey2].Separatism.Amount
                                    local ColonialRiot2     = Loyalty[playerID][cityKey2].ColonialRiotAmount
                                    local LoyaltyPerTurn2   = pCity2:GetCulturalIdentity():GetLoyaltyPerTurn() + playerwarexhaustion + ReligionMOdValue2 + PlayerGovernmentMod + Separatismlvl2 + ColonialRiot2;
                                    if Separatismlvl2 <= -1 or ColonialRiot2 < -1 or ( ColonialRiot2 < 0 and LoyaltyPerTurn2 < 0) then
                                        bRevolt[cityKey2] = true;
                                    end  
                                end
                            end   
                            
                        elseif TypeOfRevolt == 2 then
                            local MajorReligion     = pCity:GetReligion():GetMajorityReligion();
                            local MajorReligionName = Game.GetReligion():GetName(MajorReligion);
                            if MajorReligionName ~= "" then
                                LuaEvents.RevoltType2(CityName,playerID, 800);
                            else
                                -- no idea for now?
                            end
                        elseif TypeOfRevolt == 3 then
                            
                            for _, pCity2 in pPlayer:GetCities():Members() do  
                                local DistancebtweenCities2 = Map.GetPlotDistance(pCity:GetX(), pCity:GetY(), pCity2:GetX(), pCity2:GetY());
                                if DistancebtweenCities2 <= 15 then
                                    local cityKey2 = pCity2:GetX().."."..pCity2:GetY();
                                    local ReligionMOdValue2 = Loyalty[playerID][cityKey2].ReligionStability.Amount;
                                    local Separatismlvl2    = Loyalty[playerID][cityKey2].Separatism.Amount
                                    local ColonialRiot2     = Loyalty[playerID][cityKey2].ColonialRiotAmount
                                    local LoyaltyPerTurn2   = pCity2:GetCulturalIdentity():GetLoyaltyPerTurn() + playerwarexhaustion + ReligionMOdValue2 + PlayerGovernmentMod + Separatismlvl2 + ColonialRiot2;
                                    if LoyaltyPerTurn2 < 100 or playerwarexhaustion < 50 or PlayerGovernmentMod < 50 then
                                        bRevolt[cityKey2] = true;
                                    end  
                                end
                            end   
                            
                        elseif TypeOfRevolt == 4 then
                            for _, pCity2 in pPlayer:GetCities():Members() do  
                                local DistancebtweenCities2 = Map.GetPlotDistance(pCity:GetX(), pCity:GetY(), pCity2:GetX(), pCity2:GetY());
                                if DistancebtweenCities2 <= 10 then
                                    local cityKey2 = pCity2:GetX().."."..pCity2:GetY();
                                    local ReligionMOdValue2 = Loyalty[playerID][cityKey2].ReligionStability.Amount;
                                    local Separatismlvl2    = Loyalty[playerID][cityKey2].Separatism.Amount
                                    local ColonialRiot2     = Loyalty[playerID][cityKey2].ColonialRiotAmount
                                    local LoyaltyPerTurn2   = pCity2:GetCulturalIdentity():GetLoyaltyPerTurn() + playerwarexhaustion + ReligionMOdValue2 + PlayerGovernmentMod + Separatismlvl2 + ColonialRiot2;
                                    if LoyaltyPerTurn2 < 100 then
                                        bRevolt[cityKey2] = true;
                                    end  
                                end
                            end   
                        end
                        GameConfiguration.SetValue(cityKey.."SiegeTurnLeft", -10)
                    elseif  30 < Currentturn() - LastRevoltTurn - GameConfiguration.GetValue(cityKey.."SiegeTurnLeft") or NewCount == 0 then
                        GameConfiguration.SetValue(cityKey.."SiegeTurnLeft", -10)
                    end
                end
                if  Game.GetLocalPlayer() == playerID and GameConfiguration.GetValue(cityKey.."SiegeTurnLeft") and GameConfiguration.GetValue(cityKey.."SiegeTurnLeft") > -1 then
                    
                    local TypeOfRevolt = GameConfiguration.GetValue(cityKey.."TypeOfRevolt")
                    local RevotypeResult =   "neighbor city could join them"
                    if TypeOfRevolt == 1 then
                        RevotypeResult =   "this city will be free"
                    elseif TypeOfRevolt == 2 then
                        RevotypeResult =   "Your citizen will impose their religion to neighbor city"
                    end
                    local summary = " your citizens besiege this city, You have "..GameConfiguration.GetValue(cityKey.."SiegeTurnLeft").." [Icon_Turn]turn to kill all partisans of the uprising or else "..RevotypeResult..", patisan left:".. GameConfiguration.GetValue(cityKey.."SiegeUnitCount");
                    
                    SetDefaultNotificationTable(notifid, NotificationTurn, Game:GetLocalPlayer());
                    local RecentRevoltNotificationTable = {};
                    for k,func in pairs (DefaultNotification) do
                        RecentRevoltNotificationTable[k] = func;
                    end
                    RecentRevoltNotificationTable.GetTypeName         = function() return "NOTIFICATION_CUSTOM_SIEGE_IN_PROGRESS"; end
                    RecentRevoltNotificationTable.GetIconName         = function() return "ICON_NOTIFICATION_SPY_ENEMY_RECRUIT_PARTISANS"; end
                    RecentRevoltNotificationTable.GetType             = function() return 888889; end
                    RecentRevoltNotificationTable.GetEventOnActivate  = "ON_REVOLT_NOTIF_ACTIVATED" 
                    RecentRevoltNotificationTable.GetMessage          = function() return Locale.Lookup(CityName); end
                    RecentRevoltNotificationTable.GetSummary          = function() return summary; end
                    RecentRevoltNotificationTable.IsLocationValid     = function() return true; end
                    RecentRevoltNotificationTable.GetLocation         = function() return pCity:GetX(), pCity:GetY(); end
                    RecentRevoltNotificationTable.GetTarget           = function() return playerID, CityId, PlayerComponentTypes.CITY; end 
                    table.insert(NotifTable, RecentRevoltNotificationTable)
                elseif Game.GetLocalPlayer() == playerID  then
                    SetDefaultNotificationTable(notifid, NotificationTurn, Game:GetLocalPlayer());
                    local RecentRevoltNotificationTable = {};
                    for k,func in pairs (DefaultNotification) do
                        RecentRevoltNotificationTable[k] = func;
                    end
                    RecentRevoltNotificationTable.GetTypeName           = function() return "NOTIFICATION_CUSTOM_RECENT_REVOLT"; end
                    RecentRevoltNotificationTable.GetIconName           = function() return "ICON_NOTIFICATION_SPY_ENEMY_SABOTAGED_PRODUCTION"; end
                    RecentRevoltNotificationTable.GetType               = function() return 888889; end
                    RecentRevoltNotificationTable.GetEventOnActivate    = "ON_REVOLT_NOTIF_ACTIVATED" 
                    RecentRevoltNotificationTable.GetMessage            = function() return Locale.Lookup(CityName); end
                    RecentRevoltNotificationTable.GetSummary            = function() return "Your city [ICON_Pillaged]revolted recently and needs [Icon_Turn]time to recover from it : "..LossString.." per turn"; end
                    RecentRevoltNotificationTable.IsLocationValid       = function() return true; end
                    RecentRevoltNotificationTable.GetLocation           = function() return pCity:GetX(), pCity:GetY(); end
                    RecentRevoltNotificationTable.GetTarget             = function() return playerID, CityId, PlayerComponentTypes.CITY; end 
                    table.insert(NotifTable, RecentRevoltNotificationTable)
                end
            end
        end
    end
end
   
function MakeNotification()
    if ReadyForPhase then
        local UniqueCityNotif = {}
        for _, pNotification in ipairs(NotifTable) do
            local playerID, CityId = pNotification:GetTarget()
            if pNotification.CanDouble then
                UniqueCityNotif[pNotification.GetTypeName().."."..playerID.."."..CityId] = pNotification
            else
                UniqueCityNotif[playerID.."."..CityId] = pNotification
            end
        end
        local numero = 1
        for _, pNotification in pairs(UniqueCityNotif) do
            --LuaEvents.CustomNotification_OnDefaultAddNotification(pNotification); 
            numero = numero +1
        end
        NotifTable = {}
    end
end
function LauchNotifTimer(playerID)
    if playerID == Game:GetLocalPlayer() then
        Controls.NotificationCreateTimer:SetToBeginning();
        Controls.NotificationCreateTimer:Play();
    end
end
Controls.NotificationCreateTimer:RegisterEndCallback(MakeNotification);

GameEvents.PlayerTurnStartComplete.Add( LauchNotifTimer );
function OnLoyaltyChanged(playerID, cityID)
    RevoltType(playerID, true);
    if Players[Game.GetLocalPlayer()]:IsTurnActive() then
        RealizeLoyalty()
    end
end


-- ===========================================================================
--	Government Stability
-- ===========================================================================

function SetGovernmentMod(playerID,value)                            -- send GovernmentMod value to Script and add GovernmentMod to playerUI
         
        Loyalty[playerID].GovernmentStability.Amount  = Loyalty[playerID].GovernmentStability.Amount  + value;
    if Loyalty[playerID].GovernmentStability.Amount  < -100 then                         -- GovernmentMod can't be less than -100 
        Loyalty[playerID].GovernmentStability.Amount  = -100;
    elseif Loyalty[playerID].GovernmentStability.Amount  > 100 then                        -- GovernmentMod can't be less more than 100
        Loyalty[playerID].GovernmentStability.Amount  = 100;     
    end
    SaveToSlot("GovernmentStabilityAmount"..playerID, Loyalty[playerID].GovernmentStability.Amount)
    LuaEvents.LoyaltyChanged(playerID);
end

function SetGovernmentModTooltip(playerID)
    local tooltip = "";
    local GovernmentStabilityTootip = Loyalty[playerID].GovernmentStability.Tootip;
    if GovernmentStabilityTootip ~= nil then
        tooltip = tooltip..GovernmentStabilityTootip.."[NEWLINE][NEWLINE]";
    end
    if setUIGovernmentchangedturn == nil then
            setUIGovernmentchangedturn = {};
    end
    local lastEventTurn = setUIGovernmentchangedturn[playerID];
    if lastEventTurn and lastEventTurn +10 > Currentturn()    then
        tooltip = tooltip.."[NEWLINE][ICON_PressureDown]-200 Changed [ICON_Government]Government recently";
    end
    if setUIPolicyChangedturn == nil then
            setUIPolicyChangedturn = {};
    end
     local lastEventTurn = setUIPolicyChangedturn[playerID];  
    if lastEventTurn and lastEventTurn +10 > Currentturn()    then
        tooltip = tooltip.."[NEWLINE][ICON_PressureDown]-5 per policies, Changed [ICON_Policy]Policies recently";
    end
    return tooltip;
end

function OnGovernmentChanged( playerID:number )                                            -- lose loyalty when changing Government
        SetGovernmentMod(playerID,-200); 
        if setUIGovernmentchangedturn == nil then
            setUIGovernmentchangedturn = {};
        end
        setUIGovernmentchangedturn[playerID] = Currentturn(); 
end



function OnPolicyChanged2(playerID)                                                        -- lose loyalty for every policies in government when change policies
    SetGovernmentMod(playerID,-5); 
    if setUIPolicyChangedturn == nil then
        setUIPolicyChangedturn = {};
    end
    setUIPolicyChangedturn[playerID] = Currentturn(); 
end



function GovernmentFeature(playerID)                                     -- Government feature depending on current Government and era
    local pPlayer                   = Players[playerID];
    local governmentId              = pPlayer:GetCulture():GetCurrentGovernment();
    Loyalty[playerID].GovernmentID  = governmentId
    local pPlayerMajorReligion      = pPlayer:GetReligion():GetReligionInMajorityOfCities();
    local enemiesID                 = IsAtWarWithWho(playerID);                                     -- id of player at war with pPlayer
    local pPlayerAtWarMajorReligion = -5;
    local dice                      = math.random(0,1000);
    local dice2                     = math.random(0,1000);
    local tooltip                   = "";
    local WEtooltip                 = "";
    local iWEtooltip                = 0;
    local bCrusade                  = false;
    local tEnemiesReligions         = {};
    if enemiesID then
        for i,EnemyID in pairs (enemiesID) do
            local pPlayerAtWar          = Players[EnemyID];
            pPlayerAtWarMajorReligion   = pPlayerAtWar:GetReligion():GetReligionInMajorityOfCities();
            tEnemiesReligions[i]        = pPlayerAtWarMajorReligion;
        end
    end
    if governmentId ~= -1 then
		local kCurrentGovernment    = GameInfo.Governments[governmentId];
		local kGovernmentName       = kCurrentGovernment.Name;	
        local localGovernmentName   = Locale.Lookup(kGovernmentName);
        local tooltip2              = "[ICON_Government] Government is "..localGovernmentName..":[NEWLINE][NEWLINE]Event during this [ICON_Turn]turn:[NEWLINE]";
        if kGovernmentName == "LOC_GOVERNMENT_CHIEFDOM_NAME" then
            SetWarExhaustion(playerID,1);                                                        -- ChiefDom  reduced WEP 1
            iWEtooltip = 1;
            Loyalty[playerID].GovernmentStability.ReligionMultiplier = 1.5;                                               -- SetGovernmentReligionMultiplier to 1.5
            WEtooltip = "[NEWLINE][ICON_DECLARE_SURPRISE_WAR]War Exhaustion from your [ICON_Government]Government [NEWLINE]+"..iWEtooltip.." per turn, due to Barbarian chief";
            if dice < 100 then                                                                         -- moyenne = 5.25 gain per turn
                SetGovernmentMod(playerID,15);   
                tooltip = tooltip.."[ICON_PressureUp] +15 Your chief was admirable";
            elseif dice < 750 then
                SetGovernmentMod(playerID,10);
                tooltip = tooltip.."[ICON_PressureUp] +10 Your chief is alive and rule"; 
            elseif dice < 850 then
                SetGovernmentMod(playerID,-5);   
                tooltip = tooltip.."[ICON_PressureDown]  -5 Your chief was lamentable";
            elseif dice < 900 then
                SetGovernmentMod(playerID,-10); 
                tooltip = tooltip.."[ICON_PressureDown] -10 Your chief [ICON_UnderSiege]died";    
            elseif dice < 950 then
                SetGovernmentMod(playerID,-15); 
                tooltip = tooltip.."[ICON_PressureDown] -15 Your chief has been killed"; 
            else 
                SetGovernmentMod(playerID,-20); 
                tooltip = tooltip.."[ICON_PressureDown]-20 Your chief took power by [ICON_Pillaged]force"; 
            end
        elseif kGovernmentName == "LOC_GOVERNMENT_AUTOCRACY_NAME" then                                     -- autocracy
            Loyalty[playerID].GovernmentStability.ReligionMultiplier = 1;                                                     -- SetGovernmentReligionMultiplier to 1
            if dice < 100 then                                                                             -- moyenne = 2.5 gain per turn        
                SetGovernmentMod(playerID,15);   
                tooltip = tooltip.."[ICON_PressureUp] +15 Your leader was admirable"; 
            elseif dice < 750 then
                SetGovernmentMod(playerID,6);  
                tooltip = tooltip.."[ICON_PressureUp]  +6 Your leader is alive and rule"; 
            elseif dice < 900 then
                SetGovernmentMod(playerID,-10);   
                tooltip = tooltip.."[ICON_PressureDown] -10 Your leader was lamentable";
            elseif dice < 940 then
                SetGovernmentMod(playerID,-20);   
                tooltip = tooltip.."[ICON_PressureDown] -20 Your leader [ICON_UnderSiege]died and your [ICON_Citizen]citizens liked him";
            else
                SetGovernmentMod(playerID,-10);   
                tooltip = tooltip.."[ICON_PressureDown]  -10 Your leader [ICON_UnderSiege]died but your [ICON_Citizen]citizens did not like him";
            end
        elseif kGovernmentName == "LOC_GOVERNMENT_OLIGARCHY_NAME" then
            SetWarExhaustion(playerID,0.1);                                                          -- oligarchy  reduced WEP 0.1 
            iWEtooltip = 0.1;
            Loyalty[playerID].GovernmentStability.ReligionMultiplier = 1;                                                     -- SetGovernmentReligionMultiplier to 1
            if dice < 100 then                                                                             -- moyenne = 2.8 gain per turn
                SetGovernmentMod(playerID,15);   
                tooltip = tooltip.."[ICON_PressureUp] +15 Your leaders were admirable"; 
            elseif dice < 450 then
                SetGovernmentMod(playerID,8);   
                tooltip = tooltip.."[ICON_PressureUp]  +8 Your leaders are alive and rule"; 
            elseif dice < 600 then
                SetGovernmentMod(playerID,-5);   
                tooltip = tooltip.."[ICON_PressureDown]  -5 Your leaders were lamentable";
            elseif dice < 850 then
                SetGovernmentMod(playerID,-4);   
                tooltip = tooltip.."[ICON_PressureDown]  -4 one of Your leaders [ICON_UnderSiege]died and your [ICON_Citizen]citizens liked him";
            else
                SetGovernmentMod(playerID,-1);   
                tooltip = tooltip.."[ICON_PressureDown]  -1 one of Your leaders [ICON_UnderSiege]died but your [ICON_Citizen]citizens did not like him";
            end
            
        elseif kGovernmentName == "LOC_GOVERNMENT_CLASSICAL_REPUBLIC_NAME" then                            -- classical republic
            Loyalty[playerID].GovernmentStability.ReligionMultiplier = 1;                                                     -- SetGovernmentReligionMultiplier to 1
            if dice < 800 then                                                                             -- moyenne = 9 - 0.65 = 8.35 gain per turn
                SetGovernmentMod(playerID,15);   
                tooltip = tooltip.."[ICON_PressureUp]+15 the election was not rigged[NEWLINE]"; 
            else
                SetGovernmentMod(playerID,-15);   
                tooltip = tooltip.."[ICON_PressureDown]-15 the election was rigged[NEWLINE]"; 
            end
            if dice2 < 475 then                                                                         
                SetGovernmentMod(playerID,5);   
                tooltip = tooltip.."[ICON_PressureUp]+5 Your leader was admirable"; 
            elseif dice2 < 950 then
                SetGovernmentMod(playerID,-5);   
                tooltip = tooltip.."[ICON_PressureDown]-5 Your leader was lamentable"; 
            elseif dice2 < 990 then
                SetGovernmentMod(playerID,-15);   
                tooltip = tooltip.."[ICON_PressureDown]-10 Your leader was [ICON_UnderSiege]killed while he was governing"; 
            else
                SetGovernmentMod(playerID,-5);   
                tooltip = tooltip.."[ICON_PressureDown]-5 Your leader [ICON_UnderSiege]died while he was governing"; 
            end
            
        elseif kGovernmentName == "LOC_GOVERNMENT_MONARCHY_NAME" then
            for i,EnemyReligion in pairs (tEnemiesReligions) do
                if pPlayerMajorReligion ~= EnemyReligion then                                  -- Monarchy if religion is different then reduced WEP 0.3
                    bCrusade = true;
                end
            end
            if bCrusade then
                iWEtooltip = "0.3";
                SetWarExhaustion(playerID,0.3);
            end
            Loyalty[playerID].GovernmentStability.ReligionMultiplier = 1.5;                                             -- SetGovernmentReligionMultiplier to 1.5
            if dice < 90 then                                                                            -- moyenne = 4.63  gain per turn
                SetGovernmentMod(playerID,20);   
                tooltip = tooltip.."[ICON_PressureUp]+20 Your King was admirable"; 
            elseif dice < 100 then
                SetGovernmentMod(playerID,15);   
                tooltip = tooltip.."[ICON_PressureUp]+15 Your Queen was admirable"; 
            elseif dice < 730 then
                SetGovernmentMod(playerID,10);  
                tooltip = tooltip.."[ICON_PressureUp]+10 Your King is alive and rule"; 
            elseif dice < 800 then
                SetGovernmentMod(playerID,5);   
                tooltip = tooltip.."[ICON_PressureUp]+5 Your Queen is alive and rule"; 
            elseif dice < 890 then
                SetGovernmentMod(playerID,-10);   
                tooltip = tooltip.."[ICON_PressureDown]-10 Your King was Lamentable"; 
            elseif dice < 900 then
                SetGovernmentMod(playerID,-20);   
                tooltip = tooltip.."[ICON_PressureDown]-20 Your Queen was Lamentable"; 
            elseif dice < 950 then
                SetGovernmentMod(playerID,-25); 
                tooltip = tooltip.."[ICON_PressureDown]-25 Your monarch [ICON_UnderSiege]died and had an heir";    
            elseif dice < 960 then
                SetGovernmentMod(playerID,-35); 
                tooltip = tooltip.."[ICON_PressureDownLarge]-35 Your monarch [ICON_UnderSiege]died but had no heir";  
            elseif dice < 994 then
                SetGovernmentMod(playerID,-30); 
                tooltip = tooltip.."[ICON_PressureDownLarge]-30 Your monarch has been [ICON_UnderSiege]killed and had an heir"; 
            elseif dice <= 999 then
                SetGovernmentMod(playerID,-40); 
                tooltip = tooltip.."[ICON_PressureDownLarge]-40 Your monarch has been [ICON_UnderSiege]killed but had no heir"; 
            else 
                SetGovernmentMod(playerID,-50); 
                tooltip = tooltip.."[ICON_PressureDownLarge]-50 Your monarch took power by [ICON_Pillaged]force or has no legitimacy"; 
            end
        elseif kGovernmentName == "LOC_GOVERNMENT_THEOCRACY_NAME" then
            for i,EnemyReligion in pairs (tEnemiesReligions) do
                if pPlayerMajorReligion ~= EnemyReligion then                                  -- Theocracy if religion is different then reduced WEP 0.5
                    bCrusade = true;
                end
            end
            if bCrusade then
                iWEtooltip = "0.5";
                SetWarExhaustion(playerID,0.5);
            end
            Loyalty[playerID].GovernmentStability.ReligionMultiplier = 2;                                                     -- SetGovernmentReligionMultiplier to 2
            if dice < 100 then                                                                             -- moyenne = 4.9 gain per turn 
                SetGovernmentMod(playerID,25);   
                tooltip = tooltip.."[ICON_PressureUp]+25 Your leader was admirable"; 
            elseif dice < 650 then
                SetGovernmentMod(playerID,17);   
                tooltip = tooltip.."[ICON_PressureUp]+17 Your leader is alive and rule"; 
            elseif dice < 800 then
                SetGovernmentMod(playerID,-5);   
                tooltip = tooltip.."[ICON_PressureDown]-5 Your leader was lamentable";
            elseif dice < 980 then
                SetGovernmentMod(playerID,-30);   
                tooltip = tooltip.."[ICON_PressureDownLarge]-30 Your leader [ICON_UnderSiege]died";
            else
                SetGovernmentMod(playerID,-40);   
                tooltip = tooltip.."[ICON_PressureDownLarge]-40 Your leader has been [ICON_UnderSiege]killed";
            end
        elseif kGovernmentName == "LOC_GOVERNMENT_MERCHANT_REPUBLIC_NAME" then
            for i,EnemyReligion in pairs (tEnemiesReligions) do
                if pPlayerMajorReligion ~= EnemyReligion then                                  -- MERCHANT REPUBLIC if religion is different then reduced WEP 0.1
                    bCrusade = true;
                end
            end
            if bCrusade then
                iWEtooltip = "0.1";
                SetWarExhaustion(playerID,0.1);
            end
            Loyalty[playerID].GovernmentStability.ReligionMultiplier = 1;                                                    -- SetGovernmentReligionMultiplier to 1
            if dice < 800 then                                                                             -- moyenne = 9 - 0.65 = 8.35 gain per turn
                SetGovernmentMod(playerID,15);   
                tooltip = tooltip.."[ICON_PressureUp]+15 the election was not rigged[NEWLINE]"; 
            else
                SetGovernmentMod(playerID,-15);   
                tooltip = tooltip.."[ICON_PressureDown]-15 the election was rigged[NEWLINE]"; 
            end
            if dice2 < 475 then                                                                         
                SetGovernmentMod(playerID,5);   
                tooltip = tooltip.."[ICON_PressureUp]+5 Your leader was admirable";
            elseif dice2 < 950 then
                SetGovernmentMod(playerID,-5);   
                tooltip = tooltip.."[ICON_PressureDown]-5 Your leader was lamentable"; 
            elseif dice2 < 990 then
                SetGovernmentMod(playerID,-15);   
                tooltip = tooltip.."[ICON_PressureDown]-10 Your leader was [ICON_UnderSiege]killed while he was governing"; 
            else
                SetGovernmentMod(playerID,-5);   
                tooltip = tooltip.."[ICON_PressureDown]-5 Your leader [ICON_UnderSiege]died while he was governing"; 
            end
        elseif kGovernmentName == "LOC_GOVERNMENT_FASCISM_NAME" then                                 
            SetWarExhaustion(playerID,0.5);                                                          -- facism reduced WEP 0.5
            iWEtooltip = 0.5;
            Loyalty[playerID].GovernmentStability.ReligionMultiplier = 1;                                                     -- SetGovernmentReligionMultiplier to 1
            if dice < 200 then                                                                             -- moyenne = 2.575 gain per turn
                SetGovernmentMod(playerID,20);   
                tooltip = tooltip.."[ICON_PressureUp]+20 Your leader was admirable"; 
            elseif dice < 750 then
                SetGovernmentMod(playerID,3);   
                tooltip = tooltip.."[ICON_PressureUp]+3 Your leader is alive and rule"; 
            elseif dice < 900 then
                SetGovernmentMod(playerID,-15);   
                tooltip = tooltip.."[ICON_PressureDown]-15 Your leader was lamentable";
            elseif dice < 935 then
                SetGovernmentMod(playerID,-5);   
                tooltip = tooltip.."[ICON_PressureDown]-5 Your leader [ICON_UnderSiege]died";
            else
                SetGovernmentMod(playerID,-10);   
                tooltip = tooltip.."[ICON_PressureDown]-10 Your leader has been [ICON_UnderSiege]killed";
            end
        elseif kGovernmentName == "LOC_GOVERNMENT_COMMUNISM_NAME" then                                     -- communism
            Loyalty[playerID].GovernmentStability.ReligionMultiplier = 1;                                                     -- SetGovernmentReligionMultiplier to 1
            if dice < 200 then                                                                             -- moyenne = 2.575 gain per turn
                SetGovernmentMod(playerID,20);   
                tooltip = tooltip.."[ICON_PressureUp]+20 Your leader was admirable"; 
            elseif dice < 750 then
                SetGovernmentMod(playerID,3);   
                tooltip = tooltip.."[ICON_PressureUp]+3 Your leader is alive and rule"; 
            elseif dice < 900 then
                SetGovernmentMod(playerID,-15);   
                tooltip = tooltip.."[ICON_PressureDown]-15 Your leader was lamentable";
            elseif dice < 935 then
                SetGovernmentMod(playerID,-5);   
                tooltip = tooltip.."[ICON_PressureDown]-5 Your leader [ICON_UnderSiege]died";
            else
                SetGovernmentMod(playerID,-10);   
                tooltip = tooltip.."[ICON_PressureDown]-10 Your leader has been [ICON_UnderSiege]killed";
            end
        elseif kGovernmentName == "LOC_GOVERNMENT_DEMOCRACY_NAME" then                                     -- democracy
            Loyalty[playerID].GovernmentStability.ReligionMultiplier = 1;                                                     -- SetGovernmentReligionMultiplier to 1
            if dice < 950 then                                                                             -- moyenne = 13.5 - 0.295 = 13.205 gain per turn
                SetGovernmentMod(playerID,15);   
                tooltip = tooltip.."[ICON_PressureUp]+15 the election was not rigged[NEWLINE]"; 
            else
                SetGovernmentMod(playerID,-15);   
                tooltip = tooltip.."[ICON_PressureDown]-15 the election was rigged[NEWLINE]"; 
            end
            if dice2 < 490 then                                                                         
                SetGovernmentMod(playerID,5);   
                tooltip = tooltip.."[ICON_PressureUp]+5 Your leader was admirable"; 
            elseif dice2 < 980 then
                SetGovernmentMod(playerID,-5);   
                tooltip = tooltip.."[ICON_PressureDown]-5 Your leader was lamentable"; 
            elseif dice2 <= 999 then
                SetGovernmentMod(playerID,-15);   
                tooltip = tooltip.."[ICON_PressureDown]-15 Your leader was [ICON_UnderSiege]killed while he was governing"; 
            else
                SetGovernmentMod(playerID,-10);   
                tooltip = tooltip.."[ICON_PressureDown]-10 Your leader [ICON_UnderSiege]died while he was governing"; 
            end
        elseif kGovernmentName == "LOC_GOVERNMENT_ANARCHY_NAME" then                                         -- anarchy
            Loyalty[playerID].GovernmentStability.ReligionMultiplier = 1.5;                                                     -- SetGovernmentReligionMultiplier to 1.5
            SetGovernmentMod(playerID,-15);                                                                   -- moyenne = -15 loss per turn
            tooltip         = tooltip.."[ICON_PressureDown][ICON_PressureDown]-15 ANARCHY"; 
        end
        Loyalty[playerID].GovernmentStability.HistoryTooltip[Currentturn()] = tooltip;
        local tooltip = tooltip.."[NEWLINE][NEWLINE]Events of the last 5 [ICON_Turn]Turns:";
        for i =-1 , -5,-1 do
            if Loyalty[playerID].GovernmentStability.HistoryTooltip[Currentturn()+i] ~= nil then
                tooltip = tooltip.."[NEWLINE]"..Loyalty[playerID].GovernmentStability.HistoryTooltip[Currentturn()+i]; 
            end
        end
        Loyalty[playerID].GovernmentStability.HistoryTooltip[Currentturn()+6] = nil;
        
        if type(iWEtooltip) == "string" then
            WEtooltip = "[NEWLINE][ICON_DECLARE_SURPRISE_WAR]War Exhaustion from your [ICON_Government]Government [NEWLINE]+"..iWEtooltip.." per turn thanks to the crusade";
        elseif iWEtooltip ~= 0 and WEtooltip == "" then
            WEtooltip = "[NEWLINE][ICON_DECLARE_SURPRISE_WAR]War Exhaustion from your [ICON_Government]Government [NEWLINE]+"..iWEtooltip.." per turn, due to propaganda";
        end
        
        
        tooltip                             = tooltip2..tooltip;
        Loyalty[playerID].GovernmentStability.Tootip   = tooltip;
        if Loyalty[playerID].WarExhaustion.WarExhaustionPerTurnTooltip  then
            Loyalty[playerID].WarExhaustion.WarExhaustionPerTurnTooltip  = Loyalty[playerID].WarExhaustion.WarExhaustionPerTurnTooltip ..WEtooltip;
        else
            Loyalty[playerID].WarExhaustion.WarExhaustionPerTurnTooltip  = WEtooltip;
        end
	end
end


-- ===========================================================================
--	Separatism 
-- ===========================================================================

function SetSeparatism(playerID, cityID, Value) 
    local pCity         = Players[playerID]:GetCities():FindID(cityID)
    local cityKey  = pCity:GetX().."."..pCity:GetY();
    if Loyalty[playerID][cityKey].Separatism.Amount then
        Loyalty[playerID][cityKey].Separatism.Amount = Loyalty[playerID][cityKey].Separatism.Amount + Value;
    else
        Loyalty[playerID][cityKey].Separatism.Amount = Value;
    end
    if Loyalty[playerID][cityKey].Separatism.Amount >= 0 then                 
        Loyalty[playerID][cityKey].Separatism.Amount = 0;
        if Loyalty[cityKey].Culture ~= Loyalty[playerID].Culture then
            Loyalty[cityKey].Culture = Loyalty[playerID].Culture;
            GameConfiguration.SetValue( "Culture"..cityKey, Loyalty[cityKey].Culture );
        end
        if Loyalty[playerID][cityKey].Separatism.tooltipOnSet ~= nil then
            Loyalty[playerID][cityKey].Separatism.tooltipOnSet = nil;
        end
        if Loyalty[playerID][cityKey].Separatism.tooltipPerTurn ~= nil then
            Loyalty[playerID][cityKey].Separatism.tooltipPerTurn = nil;
        end
    end
    SaveToSlot("SeparatismAmount"..playerID.."."..cityKey, Loyalty[playerID][cityKey].Separatism.Amount) 
    LuaEvents.LoyaltyChanged(playerID);
end
function OnPlayerDefeat(player1ID:number, player2ID:number)
    local DefeatedPlayerAtWarWith = IsAtWarWithWho(player1ID)
    for _,playerID in pairs(DefeatedPlayerAtWarWith) do
        Loyalty[playerID].NeedSeparatismTest = player1ID  
        SaveToSlot("NeedSeparatismTest"..playerID, Loyalty[playerID].NeedSeparatismTest)
        SaveToSlot(player1ID..".Atwarwith."..player2ID, false)
        SaveToSlot(player2ID..".Atwarwith."..player1ID, false)
    end
end
function OnMakePeaceSetSeparatism( player1ID:number, player2ID:number )
    local pPlayer1  = Players[player1ID];
    local pPlayer2  = Players[player2ID];
    for _, pCity in pPlayer1:GetCities():Members() do
        local cityKey       = pCity:GetX().."."..pCity:GetY();
        local cityOldOwner  = loadSlot("CityOldOwner"..cityKey);
        if Loyalty[player1ID][cityKey].Separatism.Amount == 0 and( Loyalty[cityKey].Culture == Loyalty[player2ID].Culture or ( cityOldOwner == player2ID and Loyalty[cityKey].Culture ~= Loyalty[player1ID].Culture )) then
            local Value = -15 * (pCity:GetPopulation() + GetCityData(pCity).CulturePerTurn); 
            if Value > -100 then
                Value   = -100;
            elseif Value < -500 then
                Value   = -500;
            end
            Loyalty[player1ID][cityKey].Separatism.tooltipOnSet = "this city has a "..Loyalty[cityKey].Culture.." culture[NEWLINE]".."[ICON_PressureDown]"..Value.." city has "..pCity:GetPopulation().."[ICON_Citizen]Citizens and produces "..GetCityData(pCity).CulturePerTurn.."[ICON_Culture]Culture per turn[NEWLINE]";
            SetSeparatism( player1ID, pCity:GetID(), Value);
        end
    end
    for _, pCity in pPlayer2:GetCities():Members() do
        local cityKey       = pCity:GetX().."."..pCity:GetY();
        local cityOldOwner  = loadSlot("CityOldOwner"..cityKey);
        if Loyalty[player2ID][cityKey].Separatism.Amount == 0  and( Loyalty[cityKey].Culture == Loyalty[player1ID].Culture or ( cityOldOwner == player1ID and Loyalty[cityKey].Culture ~= Loyalty[player2ID].Culture)) then
            local Value = -15 * (pCity:GetPopulation() + GetCityData(pCity).CulturePerTurn);
            if Value > -100 then
                Value = -100;
            elseif Value < -500 then
                Value = -500;
            end
            Loyalty[player2ID][cityKey].Separatism.tooltipOnSet = "this city has a "..Loyalty[cityKey].Culture.." culture[NEWLINE]".."[ICON_PressureDown]"..Value.." city has "..pCity:GetPopulation().."[ICON_Citizen]Citizens and produces "..GetCityData(pCity).CulturePerTurn.."[ICON_Culture]Culture per turn[NEWLINE]";
            SetSeparatism( player2ID, pCity:GetID(), Value);
        end
    end
end

function SetSeparatismPerTurn(playerID)
    for _,pCity in Players[playerID]:GetCities():Members() do
        local cityID            = pCity:GetID();
        local cityKey           = pCity:GetX().."."..pCity:GetY();
        local Value             = 0;
        local playerdivisor     = 1;
        local tooltipPerTurn    = "";
        local cityKey           = pCity:GetX().."."..pCity:GetY()
        if Loyalty[playerID][cityKey].Separatism.Amount and Loyalty[playerID][cityKey].Separatism.Amount < 0 then
            local kPlayers	:table = PlayerManager.GetWasEverAlive();
            for _, pPlayer in ipairs (kPlayers) do
                for _,pCity2 in pPlayer:GetCities():Members() do
                    if cityID ~= pCity2:GetID() then
                        if playerID == pPlayer:GetID() then
                            playerdivisor = 1
                        else
                            playerdivisor = 7 - pPlayer:GetDiplomacy():GetVisibilityOn(playerID) ;
                        end
                        local cityKey2             = pCity2:GetX().."."..pCity2:GetY()
                        local DistancebtweenCities = Map.GetPlotDistance(pCity:GetX(), pCity:GetY(), pCity2:GetX(), pCity2:GetY());
                        if DistancebtweenCities <= 10 then
                            local Valuemodifier = Round( (11 - DistancebtweenCities) * GetCityData(pCity2).CulturePerTurn * pCity2:GetPopulation() / 100 / playerdivisor, 1 );
                            if Loyalty[cityKey].Culture == Loyalty[cityKey2].Culture then
                                Value = Value - Valuemodifier;
                                tooltipPerTurn = tooltipPerTurn.."[NEWLINE][ICON_PressureDown]-"..Valuemodifier.." due to the proximity of the city "..Locale.Lookup(pCity2:GetName())
                            elseif Loyalty[cityKey2].Culture == Loyalty[playerID].Culture then
                                Value = Value + Valuemodifier;
                                tooltipPerTurn = tooltipPerTurn.."[NEWLINE][ICON_PressureUp]"..Valuemodifier.." due to the proximity of the city "..Locale.Lookup(pCity2:GetName())
                            end
                        end
                    end
                end
            end
        local Valuemodifier = -  Round( GetCityData(pCity).CulturePerTurn * pCity:GetPopulation() / 10, 1 );
        Value = Value - Valuemodifier
        tooltipPerTurn = tooltipPerTurn.."[NEWLINE][ICON_PressureDown]"..Valuemodifier.." due to culture pression in "..Locale.Lookup(pCity:GetName())
        if Value < 1 then
            Value = 1;
        end
        local TurnLeftTooltip                       = "[NEWLINE]".. - Round(Loyalty[playerID][cityKey].Separatism.Amount / Value, 1).."[ICON_Turn]Turn remaining before the culture becomes "..Loyalty[playerID].Culture.."[NEWLINE]City Separatism evolve from "..Value.." each [ICON_Turn]turn:";
        Loyalty[playerID][cityKey].Separatism.tooltipPerTurn = TurnLeftTooltip..tooltipPerTurn;
        SetSeparatism(playerID, cityID, Value);
        end
    end
end

function SetSeparatismTooltip( playerID, cityID )
    local pCity = Players[playerID]:GetCities():FindID(cityID)
    local cityKey = pCity:GetX().."."..pCity:GetY();
    if Loyalty[playerID][cityKey].Separatism.tooltipOnSet == nil and Loyalty[playerID][cityKey].Separatism.tooltipPerTurn == nil then
        tooltip = "Separatism information:[NEWLINE]";
    elseif Loyalty[playerID][cityKey].Separatism.tooltipPerTurn == nil then
        tooltip = "Separatism information:[NEWLINE]"..Loyalty[playerID][cityKey].Separatism.tooltipOnSet;
    elseif Loyalty[playerID][cityKey].Separatism.tooltipOnSet == nil then
        tooltip = "Separatism information:[NEWLINE]"..Loyalty[playerID][cityKey].Separatism.tooltipPerTurn;
    else
        tooltip = "Separatism information:[NEWLINE]"..Loyalty[playerID][cityKey].Separatism.tooltipOnSet..Loyalty[playerID][cityKey].Separatism.tooltipPerTurn;
    end
    return tooltip;
end

-- ===========================================================================
--	Migration
-- ===========================================================================

function SetCityMigration(cityKey, Value)
    Loyalty[cityKey].Migration.currentMigration = Loyalty[cityKey].Migration.currentMigration + Value
    deactivatePopulationChangedNotif = true
    local pCity             = GetCity(cityKey)
    local cityID            = pCity:GetID()
    local playerID          = GetCityOwner(cityKey)
    local CityMaxMigration  = GetMaxMigration(cityKey)
    local Summary           = ""
    local Icon              = "ICON_NOTIFICATION_CONSIDER_RAZE_CITY"
    local NotifType         = "NOTIFICATION_CUSTOM_MIGRATION_Gain"
    if Loyalty[cityKey].Migration.currentMigration > CityMaxMigration then
        Loyalty[cityKey].Migration.currentMigration  = Loyalty[cityKey].Migration.currentMigration - CityMaxMigration
        LuaEvents.ChangePopulation(playerID, pCity:GetID(), 1)
        Summary         = "You Gained 1 citizen thanks to migration"
        Icon            = "ICON_NOTIFICATION_CONSIDER_RAZE_CITY"
        NotifType       = "NOTIFICATION_CUSTOM_MIGRATION_Gain"
        
    elseif Loyalty[cityKey].Migration.currentMigration < - CityMaxMigration and GetCity(cityKey):GetPopulation() == 1 then
        Loyalty[cityKey].Migration.currentMigration = - CityMaxMigration
    elseif Loyalty[cityKey].Migration.currentMigration < - CityMaxMigration then
        LuaEvents.ChangePopulation(playerID, pCity:GetID(), -1)
        Loyalty[cityKey].Migration.currentMigration = 0
        Summary         = "You Lost 1 citizen cause of migration"
        Icon            = "ICON_NOTIFICATION_CITY_STARVING"
        NotifType       = "NOTIFICATION_CUSTOM_MIGRATION_Lost"
    end
    if playerID == Game:GetLocalPlayer() and cityID~= nil and Summary ~= "" then       
        SetDefaultNotificationTable(notifid, Currentturn(), Game:GetLocalPlayer());
        local PopulationChangedNotification = {};
        for k,func in pairs (DefaultNotification) do
            PopulationChangedNotification[k] = func;
        end
        -- "ICON_NOTIFICATION_BORDERS_NOW_ENFORCED"
        PopulationChangedNotification.GetTypeName        = function() return NotifType; end
        PopulationChangedNotification.GetType            = function() return 888889; end
        PopulationChangedNotification.GetIconName        = function() return Icon; end
        PopulationChangedNotification.GetMessage         = function() return Locale.Lookup(pCity:GetName()); end
        PopulationChangedNotification.GetSummary         = function() return Summary; end
        PopulationChangedNotification.IsTargetValid      = function() return true; end
        PopulationChangedNotification.GetTarget          = function() return playerID, cityID, PlayerComponentTypes.CITY; end
        PopulationChangedNotification.DissmissOnActivate = true;
        PopulationChangedNotification.GetEventOnActivate = "ON_POPULATION_CHANGED_ACTIVATED" 
        PopulationChangedNotification.CanDouble          = true
        table.insert(NotifTable, PopulationChangedNotification)
    end
    GameConfiguration.SetValue( "currentMigration"..cityKey, Loyalty[cityKey].Migration.currentMigration );
    deactivatePopulationChangedNotif = false
end

function GetMaxMigration(cityKey)
    local pCity         = GetCity(cityKey)
    local MaxMigration  = (pCity:GetPopulation()+1) * (pCity:GetPopulation()+1) * (pCity:GetPopulation()+1) * 200
    return MaxMigration
end

function SetMigrationPerTurn(Player1ID)
      local kPlayers	:table = PlayerManager.GetWasEverAlive();
      local pPlayer1                        = Players[Player1ID]
      local GovernmentID                    = pPlayer1:GetCulture():GetCurrentGovernment();
      for _, pCity in pPlayer1:GetCities():Members() do
        
              
        local tooltipLeaving                    = {}
        local TotalAttractivity                 = {};
        TotalAttractivity.FleeWar               = {};
        TotalAttractivity.Religion              = {};
        TotalAttractivity.Government            = {};
        TotalAttractivity.Separatist            = {};
        local cityAttractivity                  = {}; 
        local cityKey                           = pCity:GetX().."."..pCity:GetY();
        local cityName                          = Locale.Lookup(GetCity(cityKey):GetName())
        local eradistance                       = GetEraModifier("eraMigrationDistance");
        local CityMigration                     = Loyalty[cityKey].Migration
        local FleeWarLeavingFoundIdealCity      = false
        local GovernmentLeavingFoundIdealCity   = false
        local ReligionLeavingFoundIdealCity     = {}
        local bReligionLeavingFoundIdealCity    = false
        local SeparatistLeavingFoundIdealCity   = false
        
        
        if Loyalty[Player1ID].WarExhaustion.Amount < 0 then 
            CityMigration.FleeWarLeaving.Amount = - Loyalty[Player1ID].WarExhaustion.Amount * GetMaxMigration(cityKey) / 3000
            tooltipLeaving.FleeWarLeavingAmount       = "[NEWLINE]"..Round(CityMigration.FleeWarLeaving.Amount).." Migrants Leaving because of war exhaustion:[NEWLINE][NEWLINE]"
            
        else
            CityMigration.FleeWarLeaving.Amount = 0
        end
            
        for GovernmentID2 in pairs(CityMigration.GovernmentLeaving) do
            CityMigration.GovernmentLeaving[GovernmentID2] = 0
        end    
        if Loyalty[Player1ID].GovernmentStability.Amount < 0 then
            CityMigration.GovernmentLeaving[GovernmentID] = - Loyalty[Player1ID].GovernmentStability.Amount * GetMaxMigration(cityKey) / 3000
            tooltipLeaving["GovernmentLeaving"..GovernmentID]       = "[NEWLINE]"..Round(CityMigration.GovernmentLeaving[GovernmentID]).." Migrants Leaving because they do not like the way you govern them:[NEWLINE][NEWLINE]"
        end
            
        for ReligionID in pairs(CityMigration.ReligionLeaving) do    
            CityMigration.ReligionLeaving[ReligionID] = 0
        end
        if Loyalty[Player1ID][cityKey].ReligionStability.Amount < 0 then
            for ReligionID, HereticsAmount in pairs(Loyalty[cityKey].Heretics) do
                if ReligionID ~= pCity:GetReligion():GetMajorityReligion() then
                    local ReligionName    = Game.GetReligion():GetName(ReligionID);
                    if ReligionName ~= "" then
                        ReligionLeavingFoundIdealCity[ReligionID]       = false
                        CityMigration.ReligionLeaving[ReligionID]       = GetMaxMigration(cityKey) / 100 * HereticsAmount;  
                        tooltipLeaving["ReligionLeaving"..ReligionID]   = "[NEWLINE][NEWLINE]"..Round(CityMigration.ReligionLeaving[ReligionID]).." Migrants following "..ReligionName..":[NEWLINE]"; 
                    end
                end
            end
            if Loyalty[cityKey].CityIsHeretic then
                local MajorReligion     = pCity:GetReligion():GetMajorityReligion();
                local ReligionName    = Game.GetReligion():GetName(MajorReligion);
                if ReligionName ~= "" then
                    ReligionLeavingFoundIdealCity[MajorReligion]        = false
                    CityMigration.ReligionLeaving[MajorReligion]        = - Loyalty[Player1ID][cityKey].ReligionStability.Amount * GetMaxMigration(cityKey) / 3000 ;
                    tooltipLeaving["ReligionLeaving"..MajorReligion]    = "[NEWLINE][NEWLINE]"..Round(CityMigration.ReligionLeaving[MajorReligion]).." Migrants following "..ReligionName..":[NEWLINE]";
                end
            end
        end
        if Loyalty[Player1ID][cityKey].Separatism.Amount < 0 then
            CityMigration.SeparatistLeaving.Amount = - Loyalty[Player1ID][cityKey].Separatism.Amount * GetMaxMigration(cityKey) / 10000
            tooltipLeaving.SeparatistLeavingAmount       = "[NEWLINE]"..Round(CityMigration.SeparatistLeaving.Amount).." Migrants Leaving because They want to come back to their original country:[NEWLINE][NEWLINE]"
        else
            CityMigration.SeparatistLeaving.Amount = 0 
        end
        for _, pPlayer2 in ipairs (kPlayers) do
          local Player2ID       = pPlayer2:GetID();
          if not IsAtWarWithWho(Player2ID) then
            local Diplomacymultiplier   = 1;
            if pPlayer2:IsMajor() and pPlayer1:IsMajor() and Player2ID ~= Player1ID and ( pPlayer1:IsAI() or pPlayer2:IsAI() ) then
            
                
               local pPlayerDiplomaticAI 
               if pPlayer1:IsAI() then
                    pPlayerDiplomaticAI = pPlayer1:GetDiplomaticAI(Player2ID);
               else
                    pPlayerDiplomaticAI = pPlayer2:GetDiplomaticAI(Player1ID);
               end
                        
	           local iState : number = pPlayerDiplomaticAI:GetDiplomaticStateIndex(localPlayerID);

	           local kStateEntry = GameInfo.DiplomaticStates[iState];
	           local eState = kStateEntry.Hash;

               if (eState == DiplomaticStates.ALLIED or eState == DiplomaticStates.DECLARED_FRIEND) then 
		           Diplomacymultiplier  = 2;

	           elseif (eState == DiplomaticStates.FRIENDLY or eState == DiplomaticStates.NEUTRAL) then 
		          Diplomacymultiplier   = 1;

                
               elseif (eState == DiplomaticStates.UNFRIENDLY) then
                  Diplomacymultiplier   = 0.5;
               
	           elseif (eState == DiplomaticStates.DENOUNCED) then 
		          Diplomacymultiplier   = 0.1;
	           end
            else
                Diplomacymultiplier     = 1;
            end
            for _, pCity2 in pPlayer2:GetCities():Members() do
                
                local cityKey2  = pCity2:GetX().."."..pCity2:GetY();
                local city2ID   = pCity2:GetID()
                local DistancebtweenCities = Map.GetPlotDistance(pCity:GetX(), pCity:GetY(), pCity2:GetX(), pCity2:GetY());
                if cityKey2 ~= cityKey and DistancebtweenCities <= eradistance then
                 local bGoodCulture          = 0;
                 if Loyalty[cityKey].Culture == Loyalty[cityKey2].Culture then
                     bGoodCulture            = 1;
                 end
                                
                 local cityGrowth       = pCity2:GetGrowth()
                 local city2Data        = GetCityData(pCity2)
                 local pCityDistricts   = pCity2:GetDistricts()
                 local WonderCount      = 0
                 local DistrictCount    = 0
                 local bHolySite        = 0
                 if city2Data.Wonders then
                     WonderCount        = #(city2Data.Wonders)
                 end
                 if pCityDistricts ~= nil then   
                     DistrictCount    = pCityDistricts:GetCount()
                     if pCityDistricts:HasDistrict( GameInfo.Districts["DISTRICT_HOLY_SITE"].Index ) then
                        bHolySite = 25
                     end
                 end
                            
                         
                 local cultureMultiplier     = bGoodCulture                                          * 5;
                 local wonderMultiplier      = WonderCount                                           * 3;
                 local loyaltyMultiplier     = GetLoyaltyModPerTurn(cityKey2, Player2ID)             * 0.1;
                 local districtMultiplier    = DistrictCount                                         * 5;
                 local goldMultiplier        = city2Data.GoldPerTurn                                 * 2;
                 local habitationMultiplier  = (cityGrowth:GetHousing() - pCity2:GetPopulation())    * 6;
                 local foodMultiplier        = cityGrowth:GetFoodSurplus()                           * 5;
                 local HapinessMultiplier    = cityGrowth:GetAmenities()                             * 7;
                 local DistanceMultiplier    = (DistancebtweenCities / eradistance - 1)              * - 200;
                            
                 cityAttractivity[cityKey2]              = {};
                 cityAttractivity[cityKey2].FleeWar      = {};
                 cityAttractivity[cityKey2].Religion     = {};
                 cityAttractivity[cityKey2].Government   = {};
                 cityAttractivity[cityKey2].Separatist   = {};
                        
                 local defaultCityAttractivity  = ( cultureMultiplier + wonderMultiplier + loyaltyMultiplier + districtMultiplier + goldMultiplier +  habitationMultiplier + foodMultiplier + HapinessMultiplier + DistanceMultiplier ) * Diplomacymultiplier;
                    
                 if defaultCityAttractivity > 0 then
                    if Loyalty[Player2ID].WarExhaustion.Amount > -10  and tooltipLeaving.FleeWarLeavingAmount then
                        cityAttractivity[cityKey2].FleeWar.Amount =  defaultCityAttractivity
                        if TotalAttractivity.FleeWar.Amount ~= nil then
                            TotalAttractivity.FleeWar.Amount = TotalAttractivity.FleeWar.Amount + defaultCityAttractivity
                        else
                            TotalAttractivity.FleeWar.Amount = defaultCityAttractivity
                            FleeWarLeavingFoundIdealCity = true
                        end
                    end
                        
                    for ReligionID in pairs (CityMigration.ReligionLeaving) do
                        local bHolyCity = 0;
                        if pPlayer2:GetReligion():GetReligionTypeCreated() ~= -1 and pPlayer2:GetReligion():GetReligionTypeCreated() == ReligionID and pPlayer2:GetReligion():GetHolyCityID() == city2ID then        
                            bHolyCity = 25;                 
                        end
                        if tooltipLeaving["ReligionLeaving"..ReligionID] then
                            if ReligionID == GetPlayerMajorReligion(Player2ID) and pCity2:GetReligion():GetMajorityReligion() == ReligionID then
                                ReligionLeavingFoundIdealCity[ReligionID]       = true
                                cityAttractivity[cityKey2].Religion[ReligionID] = defaultCityAttractivity +  Loyalty[Player2ID][cityKey2].ReligionStability.Amount * 0.2 + bHolySite + bHolyCity;
                                if  TotalAttractivity.Religion[ReligionID] then
                                    TotalAttractivity.Religion[ReligionID]      = TotalAttractivity.Religion[ReligionID] + cityAttractivity[cityKey2].Religion[ReligionID]
                                else
                                    TotalAttractivity.Religion[ReligionID]      = cityAttractivity[cityKey2].Religion[ReligionID]
                                end
                            elseif ReligionID == GetPlayerMajorReligion(Player2ID) or pCity2:GetReligion():GetMajorityReligion() == ReligionID or (ReligionID == pPlayer2:GetReligion():GetReligionTypeCreated() and pPlayer2:GetReligion():GetReligionTypeCreated() ~= -1) then
                                ReligionLeavingFoundIdealCity[ReligionID]       = true
                                cityAttractivity[cityKey2].Religion[ReligionID] = (defaultCityAttractivity + Loyalty[Player2ID][cityKey2].ReligionStability.Amount * 0.2 + bHolySite + bHolyCity) * 0.3;
                                if  TotalAttractivity.Religion[ReligionID] then
                                    TotalAttractivity.Religion[ReligionID]      = TotalAttractivity.Religion[ReligionID] + cityAttractivity[cityKey2].Religion[ReligionID];
                                else
                                    TotalAttractivity.Religion[ReligionID]      = cityAttractivity[cityKey2].Religion[ReligionID];
                                end
                            end
                        end
                    end
                    if Loyalty[Player2ID].GovernmentStability.Amount > -5 and GovernmentID ~= pPlayer2:GetCulture():GetCurrentGovernment() and tooltipLeaving["GovernmentLeaving"..GovernmentID] then
                         GovernmentLeavingFoundIdealCity                        = true
                         cityAttractivity[cityKey2].Government[GovernmentID]    = defaultCityAttractivity +  Loyalty[Player2ID].GovernmentStability.Amount * 0.3;
                         if  TotalAttractivity.Government[GovernmentID] then
                             TotalAttractivity.Government[GovernmentID] = TotalAttractivity.Government[GovernmentID] + cityAttractivity[cityKey2].Government[GovernmentID];
                         else
                             TotalAttractivity.Government[GovernmentID] = cityAttractivity[cityKey2].Government[GovernmentID];
                         end
                    end
   
                    if Loyalty[Player2ID][cityKey2].Separatism.Amount == 0 and tooltipLeaving.SeparatistLeavingAmount and bGoodCulture ~= 0 then     SeparatistLeavingFoundIdealCity                    = true
                        cityAttractivity[cityKey2].Separatist.Amount       = defaultCityAttractivity;
                        if cityAttractivity[cityKey2].Separatist.Amount <= 0 then
                            cityAttractivity[cityKey2].Separatist.Amount = nil;
                        elseif TotalAttractivity.Separatist.Amount ~= nil then
                            TotalAttractivity.Separatist.Amount     = TotalAttractivity.Separatist.Amount  + cityAttractivity[cityKey2].Separatist.Amount
                        else
                            TotalAttractivity.Separatist.Amount     = cityAttractivity[cityKey2].Separatist.Amount
                        end
                    end
                 end                     
                end
            end
          end
        end
        for cityKey2, tMigrantType in pairs (cityAttractivity) do
            for MigrantType, tkey in pairs(tMigrantType) do
                for key, Attractivity in pairs (tkey) do
                    local city2Name                                     = Locale.Lookup(GetCity(cityKey2):GetName());
                    local Value                                         = CityMigration[MigrantType.."Leaving"][key] * Attractivity / TotalAttractivity[MigrantType][key];

                    tooltipLeaving[MigrantType.."Leaving"..key]   = AddSortString(tooltipLeaving[MigrantType.."Leaving"..key],"[ICON_PressureDown]"..Round(Value).." Migrants going to  "..city2Name.."[NEWLINE]","ICON_PressureDown", "[");
                    if Loyalty[cityKey2].Migration[MigrantType.."Tooltip"] and string.find(Loyalty[cityKey2].Migration[MigrantType.."Tooltip"], "Migrants Arrival :") then
                        Loyalty[cityKey2].Migration[MigrantType.."Tooltip"]  = AddSortString( Loyalty[cityKey2].Migration[MigrantType.."Tooltip"], "[ICON_PressureUp]"..Round(Value).." Coming from "..cityName.."[NEWLINE]", "ICON_PressureUp", "[")
                    elseif Loyalty[cityKey2].Migration[MigrantType.."Tooltip"] then
                        Loyalty[cityKey2].Migration[MigrantType.."Tooltip"]  = Loyalty[cityKey2].Migration[MigrantType.."Tooltip"].."[NEWLINE][NEWLINE]Migrants Arrival :[NEWLINE][NEWLINE][ICON_PressureUp]"..Round(Value).." Coming from "..cityName.."[NEWLINE]";
                    else
                        Loyalty[cityKey2].Migration[MigrantType.."Tooltip"]  = "[NEWLINE][NEWLINE]Migrants Arrival :[NEWLINE][NEWLINE][ICON_PressureUp]"..Round(Value).." Coming from "..cityName.."[NEWLINE]";
                    end  
                    if Loyalty[cityKey2].Migration[MigrantType.."Arrival"][key] then
                        Loyalty[cityKey2].Migration[MigrantType.."Arrival"][key] = Loyalty[cityKey2].Migration[MigrantType.."Arrival"][key] + Value; 
                    else
                        Loyalty[cityKey2].Migration[MigrantType.."Arrival"][key] = Value;
                    end
                    SetCityMigration(cityKey2, Value);
                    SetCityMigration(cityKey, - Value);
                end 
            end
        end

        if not FleeWarLeavingFoundIdealCity then
            CityMigration.FleeWarLeaving.Amount = 0
        elseif Loyalty[cityKey].Migration.FleeWarTooltip == "" or not Loyalty[cityKey].Migration.FleeWarTooltip then
            Loyalty[cityKey].Migration.FleeWarTooltip            = CountAndCut(tooltipLeaving.FleeWarLeavingAmount, "[ICON_PressureDown]"," Going to ", " others cities", 5, "ICON_PressureDown")
        else
            Loyalty[cityKey].Migration.FleeWarTooltip            = CountAndCut(tooltipLeaving.FleeWarLeavingAmount, "[ICON_PressureDown]"," Going to ", " others cities", 5, "ICON_PressureDown")..Loyalty[cityKey].Migration.FleeWarTooltip 
        end
        
        if not GovernmentLeavingFoundIdealCity then
            for GovernmentID in pairs(CityMigration.GovernmentLeaving) do
                CityMigration.GovernmentLeaving[GovernmentID] = 0
            end
        elseif Loyalty[cityKey].Migration.GovernmentTooltip == "" or not Loyalty[cityKey].Migration.GovernmentTooltip then
            Loyalty[cityKey].Migration.GovernmentTooltip            = CountAndCut(tooltipLeaving["GovernmentLeaving"..GovernmentID], "[ICON_PressureDown]"," Going to ", " others cities", 5, "ICON_PressureDown")
        else 
            Loyalty[cityKey].Migration.GovernmentTooltip            = CountAndCut(tooltipLeaving["GovernmentLeaving"..GovernmentID], "[ICON_PressureDown]"," Going to ", " others cities", 5, "ICON_PressureDown")..Loyalty[cityKey].Migration.GovernmentTooltip
        end
        
        for TooltipType, tooltip in spairs(tooltipLeaving, function(t,a,b) a = tonumber(string.match(t[a],"%d+")); b = tonumber(string.match(t[b],"%d+")); return a>b end) do 
            if string.find(TooltipType,"ReligionLeaving") and ReligionLeavingFoundIdealCity[tonumber(string.match(TooltipType,"%d+"))] then
                bReligionLeavingFoundIdealCity = true
                if tooltipLeaving.ReligionTooltipLeaving then
                    tooltipLeaving.ReligionTooltipLeaving = tooltipLeaving.ReligionTooltipLeaving..CountAndCut(tooltip, "[ICON_PressureDown]"," Going to ", " others cities", 3, "ICON_PressureDown")
                else
                    tooltipLeaving.ReligionTooltipLeaving = CountAndCut(tooltip, "[ICON_PressureDown]"," Going to ", " others cities", 3, "ICON_PressureDown")
                end
            elseif string.find(TooltipType,"ReligionLeaving") and not ReligionLeavingFoundIdealCity[tonumber(string.match(TooltipType,"%d+"))] then
                CityMigration.ReligionLeaving[tonumber(string.match(TooltipType,"%d+"))] = 0
            end
        end
             
        if not bReligionLeavingFoundIdealCity then
            for ReligionID in pairs(CityMigration.ReligionLeaving) do    
                CityMigration.ReligionLeaving[ReligionID] = 0
            end
        elseif Loyalty[cityKey].Migration.ReligionTooltip == "" or not Loyalty[cityKey].Migration.ReligionTooltip then
            Loyalty[cityKey].Migration.ReligionTooltip            = "[NEWLINE]"..Round(GetAmountMigration(CityMigration, "ReligionLeaving")).." Migrants Leaving because They can't exerce their religion as they would like,"..tooltipLeaving.ReligionTooltipLeaving
        else
            Loyalty[cityKey].Migration.ReligionTooltip            = "[NEWLINE]"..Round(GetAmountMigration(CityMigration, "ReligionLeaving")).." Migrants Leaving because They can't exerce their religion as they would like,"..tooltipLeaving.ReligionTooltipLeaving..Loyalty[cityKey].Migration.ReligionTooltip 
        end
        if not SeparatistLeavingFoundIdealCity then 
            CityMigration.SeparatistLeaving.Amount = 0 
        elseif Loyalty[cityKey].Migration.SeparatistTooltip == "" or not Loyalty[cityKey].Migration.SeparatistTooltip then
            Loyalty[cityKey].Migration.SeparatistTooltip            = CountAndCut(tooltipLeaving.SeparatistLeavingAmount, "[ICON_PressureDown]"," Going to ", " others cities", 5, "ICON_PressureDown")
        else
            Loyalty[cityKey].Migration.SeparatistTooltip            = CountAndCut(tooltipLeaving.SeparatistLeavingAmount, "[ICON_PressureDown]"," Going to ", " others cities", 5, "ICON_PressureDown")..Loyalty[cityKey].Migration.SeparatistTooltip
        end     
      end
end
function ResetPlayersMigrationInfo()
    local kPlayers	:table = PlayerManager.GetWasEverAlive();
    for _, pPlayerToReset in ipairs (kPlayers) do
        for _, pOtherPlayerCities in pPlayerToReset:GetCities():Members() do
            local OtherCityKey                           = pOtherPlayerCities:GetX().."."..pOtherPlayerCities:GetY();
            for MigrantType in pairs(Loyalty[OtherCityKey].Migration) do
                if string.find(MigrantType, "Arrival") then
                    for key in pairs (Loyalty[OtherCityKey].Migration[MigrantType]) do      
                        Loyalty[OtherCityKey].Migration[MigrantType][key]   = 0
                    end
                elseif string.find( MigrantType, "Tooltip" ) then
                    Loyalty[OtherCityKey].Migration[MigrantType]            = "" 
                end
            end
        end
    end
end
Events.LocalPlayerTurnEnd.Add(			ResetPlayersMigrationInfo );

-- ===========================================================================
--	Colonial Revolt
-- ===========================================================================
    
function SetColonialRiot(playerID, cityKey, DistancewithCapital, HasGarnison, DistrictNumber, Amenities, hab)
     Loyalty[playerID][cityKey].ColonialRiotAmount = Loyalty[playerID][cityKey].ColonialRiotAmount < -200 and -200 or Loyalty[playerID][cityKey].ColonialRiotAmount; 
    if DistancewithCapital and DistancewithCapital >= MinimumDistanceForColonialRiot then  
        local AmenitiesModifier     = Amenities*30
        local DistrictModifier      = DistrictNumber*40
        local RiotPower             = DistancewithCapital  * hab^2 /10
        local RevolGainPerTurn      = Round( RiotPower - HasGarnison - DistrictModifier - AmenitiesModifier);
        local GarnisonTooTip        = "";
        if HasGarnison ~= 0 then
            GarnisonTooTip = "[ICON_PressureUp]"..HasGarnison.." Thanks to Garrison[NEWLINE]";
        end
        local RevolGainPerTurnIcon = -RevolGainPerTurn < 0 and "[ICON_PressureDown]" or "[ICON_PressureUp]";
        local AmenitiesIcon = Amenities < 0 and "[ICON_PressureDown]" or "[ICON_PressureUp]";
        Loyalty[playerID][cityKey].ColonialRiotAmount = Loyalty[playerID][cityKey].ColonialRiotAmount - RevolGainPerTurn;
        Loyalty[playerID][cityKey].ColonialRiotToolTip = "This city is too far from its capital… And wants to take its independence[NEWLINE]"..RevolGainPerTurnIcon..-RevolGainPerTurn.." Per turn cause :[NEWLINE][NEWLINE][ICON_PressureDown]".. -RiotPower  .." Because this city is "..DistancewithCapital.." plots away from capital and has "..hab.." citizens[NEWLINE]"..GarnisonTooTip.."[ICON_PressureUp]"..DistrictModifier .." because there are "..DistrictNumber.." districts in this city[NEWLINE]"..  AmenitiesIcon..AmenitiesModifier .." cause of Amenities in city";
        Loyalty[playerID][cityKey].ColonialRiotAmount = Loyalty[playerID][cityKey].ColonialRiotAmount < -1 and Loyalty[playerID][cityKey].ColonialRiotAmount or -1
    elseif Loyalty[playerID][cityKey].ColonialRiotAmount < 0 then
        Loyalty[playerID][cityKey].ColonialRiotAmount = Loyalty[playerID][cityKey].ColonialRiotAmount +2;
        Loyalty[playerID][cityKey].ColonialRiotToolTip = "Your capital is closer now";
    end
    Loyalty[playerID][cityKey].ColonialRiotAmount = Loyalty[playerID][cityKey].ColonialRiotAmount > 0 and 0 or Loyalty[playerID][cityKey].ColonialRiotAmount; 
    Loyalty[playerID][cityKey].ColonialRiotAmount = Loyalty[playerID][cityKey].ColonialRiotAmount < -500 and -500 or Loyalty[playerID][cityKey].ColonialRiotAmount; 
    SaveToSlot( "ColonialRiotAmount"..playerID.."."..cityKey, Loyalty[playerID][cityKey].ColonialRiotAmount );
end
-- ===========================================================================
--	New Owner chooser
-- ===========================================================================

function SetColonialNations(playerID)
    print(PlayerConfigurations[playerID]:GetCivilizationDescription(),"is colonial")
    LuaEvents.KillPlayer(playerID);
    GameConfiguration.SetValue(playerID.."CanTakeHisIndependence", true)
    GameConfiguration.SetValue(playerID.."AlreadyIndependent", false)
    GameConfiguration.SetValue("AlreadyCreatedIndependentColonialNation", true)
end

function GetCityInformation(pCity)
    local cityData          = {}
    local pCityPlots        = Map.GetCityPlots():GetPurchasedPlots(pCity);
    local pCityBuildings    = pCity:GetBuildings();
    local numberOfPlot      = 0;
    local numberOfBuilding  = 0;
    cityData.Plots          = {}
    cityData.buldings       = {}
    for _,plotID in pairs(pCityPlots) do 
        local tBuildingTypes      = pCityBuildings:GetBuildingsAtLocation(plotID);
        for _, buildingtype in ipairs(tBuildingTypes) do
            table.insert(cityData.buldings, buildingtype)
            cityData.buldings[buildingtype.."IsPillaged"] = pCityBuildings:IsPillaged(buildingtype)
        end
        table.insert(cityData.Plots, plotID)
    end    
    cityData.Population = pCity:GetPopulation();
    cityData.Name = pCity:GetName();
    
    cityData.district = {}
    for _,district in pCity:GetDistricts():Members() do
        if district ~= nil and district:IsComplete() then
            local PlotID = Map.GetPlot(district:GetX(), district:GetY()):GetIndex();
			local DistrictType = district:GetType();
            if DistrictType ~= 0 then
                table.insert(cityData.district, DistrictType)
                cityData.district[DistrictType.."location"] = PlotID
            end
        end
    end
    
    cityData.Religion = {}
    local CityReligion      = pCity:GetReligion():GetReligionsInCity()
    for _, CityReligion in pairs(CityReligion) do
            local religionPressure  = CityReligion.Pressure;
            table.insert(cityData.Religion, CityReligion.Religion)
            cityData.Religion[CityReligion.Religion.."religionpressure"] = religionPressure
    end
    return cityData;
end

function OnFreeCityRevolt(CityX, CityY)
    local cityKey = CityX.."."..CityY;
    local cityData = GetCityInformation(GetCity(cityKey))
    local oldOwner = GameConfiguration.GetValue(cityKey.."OwnerBeforeUprise")
    local cityCulturePlayer;
    local LuckyNation = {};
    local IndependentPlayerIDCityOwner;
    local ClosestCity;
    local DistanceToClosestCity = 1000;
    local kPlayers	 :table = PlayerManager.GetWasEverAlive();
    for _, pPlayer in pairs(kPlayers) do
        for _, pCity in pPlayer:GetCities():Members() do
            local DistanceBtweenCities = Map.GetPlotDistance(pCity:GetX(), pCity:GetY(), CityX, CityY);
            if DistanceBtweenCities < MinimumDistanceForColonialRiot and  GameConfiguration.GetValue(pPlayer:GetID().."CanTakeHisIndependence") and oldOwner ~= pPlayer:GetID() and pPlayer:IsMajor() then   
                table.insert(LuckyNation,  pPlayer:GetID())
            end
            if DistanceBtweenCities < DistanceToClosestCity and pPlayer:GetID() ~= oldOwner then
                DistanceToClosestCity = DistanceBtweenCities;
                ClosestCityOwner = pPlayer:GetID();
            end
        end
    end
    if #LuckyNation >= 1 then
        IndependentPlayerIDCityOwner = LuckyNation[Round(math.random(1, #LuckyNation))];
    end
    if Loyalty[cityKey].Culture  ~= Loyalty[oldOwner].Culture then  
        for _, pPlayer in pairs(kPlayers) do
            if  Loyalty[pPlayer:GetID()].Culture == Loyalty[cityKey].Culture then
                cityCulturePlayer = pPlayer:GetID();
            end
        end
    end
    if cityCulturePlayer  then
        LuaEvents.ChangeCityOwnerTo(CityX, CityY, cityCulturePlayer, cityData );
    elseif IndependentPlayerIDCityOwner then
        LuaEvents.ChangeCityOwnerTo(CityX, CityY, IndependentPlayerIDCityOwner, cityData );    
        Loyalty[cityKey].Culture = Loyalty[IndependentPlayerIDCityOwner].Culture
        GameConfiguration.SetValue( "Culture"..cityKey, Loyalty[cityKey].Culture );
    else
        for _, pPlayer in pairs(kPlayers) do
            local IndependentPlayerID = pPlayer:GetID() 
            if GameConfiguration.GetValue(IndependentPlayerID.."CanTakeHisIndependence") and not GameConfiguration.GetValue(IndependentPlayerID.."AlreadyIndependent") then
                GameConfiguration.SetValue(IndependentPlayerID.."AlreadyIndependent", true)
                LuaEvents.ChangeCityOwnerTo(CityX, CityY, IndependentPlayerID, cityData );
                Loyalty[cityKey].Culture = Loyalty[IndependentPlayerID].Culture
                GameConfiguration.SetValue( "Culture"..cityKey, Loyalty[cityKey].Culture );
                GameConfiguration.SetValue("CapitalCity"..IndependentPlayerID, cityKey);
                for kTech in GameInfo.Technologies() do 
                    local iTech         = kTech.Index;
                    local oldOwnerTechs = Players[oldOwner]:GetTechs();
                    if oldOwnerTechs:HasTech(iTech) then
                        LuaEvents.GainTech(iTech, IndependentPlayerID);
                    elseif oldOwnerTechs:GetResearchProgress(iTech) > 0 then
                        LuaEvents.SetResearch( iTech, oldOwnerTechs:GetResearchProgress(iTech), IndependentPlayerID);
                    end
                end
                for kCivic in GameInfo.Civics() do
                    local iCivic            = kCivic.Index;
                    local oldOwnerCulture   = Players[oldOwner]:GetCulture()
                    if oldOwnerCulture:HasCivic(iCivic) then
                        LuaEvents.GainCivic(iCivic, IndependentPlayerID)
                    elseif oldOwnerCulture:GetCulturalProgress(iCivic) > 0 then
                        LuaEvents.SetCivic( iCivic, oldOwnerCulture:GetCulturalProgress(iCivic), IndependentPlayerID)
                    end
                end
                return;
            end
        end
        LuaEvents.ChangeCityOwnerTo(CityX, CityY, ClosestCityOwner  );
        Loyalty[cityKey].Culture = Loyalty[ClosestCityOwner].Culture
        GameConfiguration.SetValue( "Culture"..cityKey, Loyalty[cityKey].Culture );
        
    end
end

function InitializeScripts()
    
    -- Initialize Usefull Function
    GameEvents.PlayerTurnStarted.Add(                   InitializeEachTurn );
    Events.DiplomacyMakePeace.Add(                      SetDiplomacyPeace );
    Events.DiplomacyDeclareWar.Add(	                    SetDiplomacyWar );
    Events.CityAddedToMap.Add(					        SetCityLoyalty );
    
    -- Initialize Revolt Chance/type
    GameEvents.PlayerTurnStarted.Add(                   RevoltType    );
    LuaEvents.LoyaltyChanged.Add(                       OnLoyaltyChanged );
    Events.CityLoyaltyChanged.Add(                      OnLoyaltyChanged );
    
    -- Initialize War Exhaustion
    Events.DiplomacyDeclareWar.Add(	                    SetWarExhaustionOnDeclareWar );  
    GameEvents.PlayerTurnStarted.Add(                   AddWarExhaustionlevel );
    Events.Combat.Add(                                  OnCombat );
    Events.UnitCaptured.Add(                            exhaustionOnUnitCaptured );
    
    --Initialize Religion Stability
    GameEvents.PlayerTurnStarted.Add(                   SetReligion );
    SetReligion()
    
    -- Initialize Government Stability
    Events.GovernmentChanged.Add(                       OnGovernmentChanged );
    Events.GovernmentPolicyChanged.Add(                 OnPolicyChanged2 );
    GameEvents.PlayerTurnStarted.Add(                   GovernmentFeature );
    
    -- Initialize Separatism 
    Events.DiplomacyMakePeace.Add(                      OnMakePeaceSetSeparatism);
    Events.PlayerDefeat.Add(                            OnPlayerDefeat );
    GameEvents.PlayerTurnStarted.Add(                   SetSeparatismPerTurn);
    
    -- Initialize Migration
    GameEvents.PlayerTurnStarted.Add(                   SetMigrationPerTurn);
    
end


-- test zone
-- ===========================================================================
--	NOTIFICATIONS
-- ===========================================================================

function SetDefaultNotificationTable(NotificationID, NotificationAddTurn, LocalPlayer)
    GameConfiguration.SetValue( "notifid", notifid + 1);
    notifid                                 = GameConfiguration.GetValue("notifid");
    DefaultNotification                     = {};
    DefaultNotification.GetTypeName         = function() return "NOTIFICATION_CUSTOM_DEFAULT"; end
    DefaultNotification.GetPlayerID         = function() return LocalPlayer; end
    DefaultNotification.GetID               = function() return NotificationID; end
    DefaultNotification.GetGroup            = function() return NotificationGroups.NONE; end
    DefaultNotification.GetIconName         = function() return "ICON_NOTIFICATION_GENERIC"; end
    DefaultNotification.GetType             = function() return 888888; end
    DefaultNotification.GetEndTurnBlocking  = function() return EndTurnBlockingTypes.NO_ENDTURN_BLOCKING; end
    DefaultNotification.IsIconDisplayable   = function() return true; end
    DefaultNotification.IsValidForPhase     = function() return ReadyForPhase; end
    DefaultNotification.IsAutoNotify        = function() return false; end
    DefaultNotification.GetMessage          = function() return "Default Message"; end
    DefaultNotification.GetSummary          = function() return "Default Summary"; end
    DefaultNotification.CanUserDismiss      = function() return true; end
    DefaultNotification.IsLocationValid     = function() return false; end
    DefaultNotification.GetLocation         = function() return 0, 0; end
    DefaultNotification.IsTargetValid       = function() return false; end
    DefaultNotification.GetTarget           = function() return ; end
    DefaultNotification.IsVisibleInUI       = function() return true; end
    DefaultNotification.Activate            = function(Boolean) end
    DefaultNotification.GetCount            = function() return 1; end
    DefaultNotification.GetAddTurn          = function() return NotificationAddTurn; end
    DefaultNotification.EraseOnStartTurn    = true;
    DefaultNotification.DissmissOnActivate  = false;
    DefaultNotification.GetEventOnActivate  = "Default_Event"
end
------------------------------------------------ -- POP CHANGE NOTIFICATION -- ------------------------------------------------------------------------------


function OnCityPopulationChanged2( playerID: number, cityID : number, ChangeAmount:number )
        local pCity = Players[playerID]:GetCities():FindID(cityID);
        if playerID == Game:GetLocalPlayer() and ChangeAmount > 1 and pCity:GetPopulation() > 1 and playerID ~= nil and cityID~= nil and ReadyForPhase and not deactivatePopulationChangedNotif then       
            SetDefaultNotificationTable(notifid, Currentturn(), Game:GetLocalPlayer());
            local PopulationChangedNotification = {};
            for k,func in pairs (DefaultNotification) do
                PopulationChangedNotification[k] = func;
            end
            -- "ICON_NOTIFICATION_BORDERS_NOW_ENFORCED"
            PopulationChangedNotification.GetTypeName        = function() return "NOTIFICATION_CUSTOM_POPULATION_CHANGED"; end
            PopulationChangedNotification.GetType            = function() return 888889; end
            PopulationChangedNotification.GetIconName        = function() return "ICON_NOTIFICATION_CONSIDER_RAZE_CITY"; end
            PopulationChangedNotification.GetMessage         = function() return Locale.Lookup(pCity:GetName()); end
            PopulationChangedNotification.GetSummary         = function() return "City population[ICON_Citizen] has changed!"; end
            PopulationChangedNotification.IsTargetValid      = function() return true; end
            PopulationChangedNotification.GetTarget          = function() return playerID, cityID, PlayerComponentTypes.CITY; end
            PopulationChangedNotification.DissmissOnActivate = true;
            PopulationChangedNotification.GetEventOnActivate = "ON_POPULATION_CHANGED_ACTIVATED" 
        
            table.insert(NotifTable, PopulationChangedNotification)
        end
end




------------------------------------------------ -- Religion CHANGE NOTIFICATION -- ------------------------------------------------------------------------


function OnCityReligionChanged2(playerID, CityID)
    local pPlayer       = Players[playerID];
    local pCity         = pPlayer:GetCities():FindID(CityID);
    local cityKey       = pCity:GetX().."."..pCity:GetY();
    local OldReligion   = CurrentReligionInCity[cityKey];
    local CityOldOwner  = loadSlot("CityOwner"..cityKey);
    if CityOldOwner == nil then
        SaveToSlot("CityOwner"..cityKey, playerID);
        CityOldOwner    = playerID;
    end
    if OldReligion ~= nil and CityOldOwner == playerID and not bWaitOne then
            local MajorPlayerReligion    = GetPlayerMajorReligion(Game:GetLocalPlayer());
            local LocalPlayer            = Players[Game:GetLocalPlayer()];
            local pLocalPlayerVis:table  = PlayersVisibility[Game.GetLocalPlayer()];
            local LocalPlayerReligion    = LocalPlayer:GetReligion();
            local NewReligion            = pCity:GetReligion():GetMajorityReligion();
            local bStop                  = false;
            for _,religionid in pairs(CurrentReligionInCity) do
                if religionid == NewReligion then
                    bStop                = true;
                end
            end
            if not bStop then
                return;
            end
            if NewReligion == -1 and OldReligion ~= -1 then
                NewReligion = -10;
            end
            local OwnPlayerReligionType	= LocalPlayerReligion:GetReligionTypeCreated();
            if OwnPlayerReligionType == -1 and MajorPlayerReligion ~= -1 then 
                OwnPlayerReligionType   = MajorPlayerReligion;
            elseif OwnPlayerReligionType == -1 then
                OwnPlayerReligionType   = -2;
            end
            if NewReligion ~= OldReligion and ReadyForPhase and  (playerID == Game:GetLocalPlayer() or ((OwnPlayerReligionType == NewReligion or OwnPlayerReligionType == OldReligion) and OwnPlayerReligionType ~= -1) or ((MajorPlayerReligion == NewReligion or MajorPlayerReligion == OldReligion) and MajorPlayerReligion ~= -1)) then
                
                local ReligionStabilityValue = "";
                local loyaltyFontIcon        = "";
            
                if playerID == Game:GetLocalPlayer() then
                    local cityKey      = pCity:GetX().."."..pCity:GetY();
                    SetReligion(playerID, cityKey);
                    ReligionStabilityValue  = Loyalty[playerID][cityKey].ReligionStability.Amount
                    loyaltyFontIcon         = ReligionStabilityValue >= 0 and "[ICON_PressureUp]" or "[ICON_PressureDown]";
                end
                local NotificationTurn =  Game:GetLocalPlayer() < ActivePlayerID and Currentturn() + 1 or Currentturn()
                SetDefaultNotificationTable(notifid, NotificationTurn, Game:GetLocalPlayer());
                local   ReligionChangedNotification = {};
                for k,func in pairs (DefaultNotification) do
                    ReligionChangedNotification[k]  = func;
                end
                ReligionChangedNotification.GetTypeName        = function() return "NOTIFICATION_CUSTOM_RELIGION_CHANGED"; end
                ReligionChangedNotification.GetType            = function() return 888889; end
                ReligionChangedNotification.GetEventOnActivate = "ON_RELIGION_CHANGED_ACTIVATED" 
                ReligionChangedNotification.GetIconName        = function() return "ICON_NOTIFICATION_CHOOSE_RELIGION"; end
                ReligionChangedNotification.GetMessage         = function() return Locale.Lookup(pCity:GetName()).."[ICON_FAITH]Religion has changed!"; end
                ReligionChangedNotification.GetTarget          = function() return playerID, CityID, PlayerComponentTypes.CITY; end
                local NotificationSummary   = "";
                local NewReligionName       = "";
                local OldReligionName       = "";
                if NewReligion == -10 then
                    NewReligionName         = "Multiple religion";
                elseif NewReligion == -1 then
                    NewReligionName         = "paganism";
                else
                    NewReligionName = Game.GetReligion():GetName(NewReligion);
                end
                if type(NewReligionName) ~= "string" then
                    NewReligionName         = "ERORLIGION";
                end
                if type(loyaltyFontIcon) ~= "string" or type(ReligionStabilityValue) ~= "number" then
                    loyaltyFontIcon         = "ERORLIGION";
                    ReligionStabilityValue  = "ERORLIGION";
                end
                if OldReligion == -1 then
                    OldReligionName         = "paganism";
                elseif OldReligion == -10 then
                    OldReligionName         = "Multiple religion";
                else
                    OldReligionName = Game.GetReligion():GetName(OldReligion)
                end
                local heretics              = "";
                if OldReligion == -1 then
                    heretics                = "Pagans";
                else
                    heretics                = "heretics";
                end
                if playerID == Game:GetLocalPlayer() then
                    ReligionChangedNotification.IsLocationValid    = function() return true; end
                    ReligionChangedNotification.GetLocation        = function() return pCity:GetX(), pCity:GetY(); end
                    if OwnPlayerReligionType == NewReligion then
                        if MajorPlayerReligion == OldReligion then
                            NotificationSummary = "Your [ICON_Citizen]Citizens Now Follow your religion called "..NewReligionName.." Your religion stability is now "..loyaltyFontIcon..ReligionStabilityValue.." in this city.";
                        else
                            NotificationSummary = "Your [ICON_Citizen]Citizens are no longer "..heretics..", Now they Follow your religion called "..NewReligionName.." Your religion stability is now "..loyaltyFontIcon..ReligionStabilityValue.." in this city.";
                        end
                    elseif OwnPlayerReligionType == OldReligion then
                        if MajorPlayerReligion   == NewReligion then
                            NotificationSummary = "Your [ICON_Citizen]Citizens no longer follow your religion called "..OldReligionName..", Now they Follow your Major religion called "..NewReligionName.." Your religion stability is now "..loyaltyFontIcon..ReligionStabilityValue.." in this city.";
                        else
                            NotificationSummary = "Your [ICON_Citizen]Citizens no longer follow your religion called "..OldReligionName..", They became heretics, Now they Follow a religion called "..NewReligionName.." Your religion stability is now "..loyaltyFontIcon..ReligionStabilityValue.." in this city.";
                        end
                    elseif MajorPlayerReligion   == NewReligion then
                        NotificationSummary = "Your [ICON_Citizen]Citizens are no longer "..heretics..", Now they Follow your Major religion called "..NewReligionName.." Your religion stability is now "..loyaltyFontIcon..ReligionStabilityValue.." in this city.";
                    elseif MajorPlayerReligion   == OldReligion then
                        NotificationSummary = "Your [ICON_Citizen]Citizens no longer follow your Major religion called "..OldReligionName..", They became heretics, Now they Follow a religion called "..NewReligionName.." Your religion stability is now "..loyaltyFontIcon..ReligionStabilityValue.." in this city.";
                    else
                        NotificationSummary = "Your [ICON_Citizen]Citizens no longer follow a religion called "..OldReligionName..", They remain heretics, Now they Follow a religion called "..NewReligionName.." Your religion stability is now "..loyaltyFontIcon..ReligionStabilityValue.." in this city.";
                    end
                elseif pLocalPlayerVis:IsRevealed(pCity:GetX(), pCity:GetY()) then
                    ReligionChangedNotification.IsLocationValid     = function() return true; end
                    ReligionChangedNotification.GetLocation         = function() return pCity:GetX(), pCity:GetY(); end
                    if OwnPlayerReligionType == NewReligion then
                        NotificationSummary = "Their [ICON_Citizen]Citizens now follow your religion called "..NewReligionName;
                    elseif OwnPlayerReligionType == OldReligion then
                        NotificationSummary = "Their [ICON_Citizen]Citizens no longer follow your religion called "..OldReligionName;
                    elseif MajorPlayerReligion   == NewReligion then
                        NotificationSummary = "Their [ICON_Citizen]Citizens now follow your Major religion called "..NewReligionName;
                    elseif MajorPlayerReligion   == OldReligion then
                        NotificationSummary = "Their [ICON_Citizen]Citizens no longer follow your Major religion called "..OldReligionName;
                    end
                else
                    ReligionChangedNotification.GetType            = function() return 888888; end
                    if OwnPlayerReligionType == NewReligion then
                        ReligionChangedNotification.GetMessage         = function() return "Not revealed City changed religion"; end
                        NotificationSummary = "Their [ICON_Citizen]Citizens now follow your religion called "..NewReligionName;
                    elseif OwnPlayerReligionType == OldReligion then
                        ReligionChangedNotification.GetMessage         = function() return "Not revealed City changed religion"; end
                        NotificationSummary = "Their [ICON_Citizen]Citizens no longer follow your religion called "..OldReligionName;
                    end
                end
                ReligionChangedNotification.GetSummary         = function() return NotificationSummary; end
                LuaEvents.CustomNotification_OnDefaultAddNotification(ReligionChangedNotification);
                SetCurrentReligionInCity(pCity:GetReligion():GetMajorityReligion(), cityKey);
            end
    elseif CityOldOwner ~= playerID then
        SaveToSlot("CityOldOwner"..cityKey, loadSlot("CityOwner"..cityKey, playerID));
        SaveToSlot("CityOwner"..cityKey, playerID);
        bWaitOne                = true;
    elseif bWaitOne then
        bWaitOne        = false;
    else
        SetCurrentReligionInCity(pCity:GetReligion():GetMajorityReligion(), cityKey);
    end
end
function GetPlayerMajorReligion(playerID)
    local pPlayerCities            = Players[playerID]:GetCities();
    local MajorReligionCount       = {};
    local CityReligionCount        = -5;
    local TruePlayerMajorReligion  = -1;
    local CityMajorReligionTooltip = "";
    local PlayerPopulation         = 0;
    local religionNames            = nil;
    local YouHave                  = "You have ";
    local your                     = "your";
    if playerID ~= Game:GetLocalPlayer() then
        YouHave                    = "He has ";
        your                       = "his";
    end
    if type(pPlayerCities) == "table" then
        for _,pCity in pPlayerCities:Members() do
             local religionsInCity  = pCity:GetReligion():GetReligionsInCity();  
             for CityReligionid, CityReligion in pairs(religionsInCity) do
                local ReligionID    = CityReligion.Religion;
                local Followers     = CityReligion.Followers;
                PlayerPopulation    = PlayerPopulation + Followers;
                if MajorReligionCount[ReligionID] == nil then
                     MajorReligionCount[ReligionID] = 1 * Followers;
                else
                     MajorReligionCount[ReligionID] = MajorReligionCount[ReligionID] + 1 * Followers;
                end
             end
            
        end
    end
    for CityMajorReligion, count in pairs (MajorReligionCount) do
        if count > CityReligionCount then
            CityReligionCount           = count;
            TruePlayerMajorReligion     = CityMajorReligion;
            religionPercent             = CityReligionCount / PlayerPopulation * 100;
            CityMajorReligionTooltip    = " because "..YouHave.." "..Round(religionPercent, 1).."% Of "..your.."[ICON_Citizen]citizens following this religion";
            religionNames               = Game.GetReligion():GetName(CityMajorReligion);
        elseif count == CityReligionCount then
            if Game.GetReligion():GetName(CityMajorReligion) == "" then
                religionNames           = religionNames..", Paganism";
            else
                religionNames           = religionNames..", "..Game.GetReligion():GetName(CityMajorReligion);
            end
            religionPercent             = count / PlayerPopulation * 100;
            TruePlayerMajorReligion     = -10;
            CityMajorReligionTooltip    = " because "..YouHave.." "..Round(religionPercent, 1).."% Of "..your.."[ICON_Citizen]citizens following these religions :"..religionNames;
        end
    end
    return TruePlayerMajorReligion, CityMajorReligionTooltip
end



function ReligionFoundedNotification (playerID, religionFounded)
    if playerID ~= Game:GetLocalPlayer() and ReadyForPhase then
        local religionFoundedDef:table  = GameInfo.Religions[religionFounded];
        local PlayerName                = Locale.Lookup(PlayerConfigurations[playerID]:GetCivilizationDescription());
        local HolyCityID                = Players[playerID]:GetReligion():GetHolyCityID();
        local HolyCity                  = CityManager.GetCity(playerID, HolyCityID);
        local HolyCityID                = HolyCity:GetID();
        if type(HolyCityID) ~= "number" then
            for _,pCity in Players[playerID]:GetCities():Members() do
                local CityMajorReligionid   = pCity:GetReligion():GetMajorityReligion();
                if CityMajorReligionid == religionFounded then
                    HolyCityID              = pCity:GetID();
                end   
            end
            if type(HolyCityID) ~= "number" then
            HolyCityID  = Players[playerID]:GetCities():GetCapitalCity():GetID();
            end
        end
        local pLocalPlayerVis:table     = PlayersVisibility[Game.GetLocalPlayer()];
        local NotificationTurn          =  Game:GetLocalPlayer() < playerID and Currentturn() + 1 or Currentturn();
        SetDefaultNotificationTable(notifid, NotificationTurn, Game:GetLocalPlayer());
        local ReligionHasBeenFoundedNotification    = {};
        for k,func in pairs (DefaultNotification) do
            ReligionHasBeenFoundedNotification[k]   = func;
        end
        ReligionHasBeenFoundedNotification.GetTypeName              = function() return "NOTIFICATION_CUSTOM_RELIGION_FOUNDED"; end
        ReligionHasBeenFoundedNotification.GetIconName              = function() return "ICON_NOTIFICATION_CHOOSE_RELIGION"; end
        ReligionHasBeenFoundedNotification.GetMessage               = function() return "religion[ICON_Faith] founded!"; end
        if Players[Game:GetLocalPlayer()]:GetDiplomacy():HasMet(playerID) then
            ReligionHasBeenFoundedNotification.GetSummary           = function() return PlayerName.." has founded "..Locale.Lookup(religionFoundedDef.Name); end
        else
            ReligionHasBeenFoundedNotification.GetSummary           = function() return "Unmet player has founded "..Locale.Lookup(religionFoundedDef.Name); end
        end
        if pLocalPlayerVis:IsRevealed(HolyCity:GetX(), HolyCity:GetY()) then
            ReligionHasBeenFoundedNotification.GetType              = function() return 888889; end
            ReligionHasBeenFoundedNotification.GetEventOnActivate   = "ON_RELIGION_CHANGED_ACTIVATED" 
            ReligionHasBeenFoundedNotification.GetTarget            = function() return playerID, HolyCityID, PlayerComponentTypes.CITY; end
            ReligionHasBeenFoundedNotification.IsLocationValid      = function() return true; end
            ReligionHasBeenFoundedNotification.GetLocation          = function() return HolyCity:GetX(), HolyCity:GetY(); end
        end
        LuaEvents.CustomNotification_OnDefaultAddNotification(ReligionHasBeenFoundedNotification); 
    end
end



------------------------------------------------ -- Barbarian Village Discovered NOTIFICATION -- ------------------------------------------------------------------------

function OnBarbarianVillageDiscovered( locX :number, locY :number, eImprovementType :number, eVisibility :number )
    local key = locX.."."..locY;     
	if ( eVisibility > 0 ) and ReadyForPhase and ( GameInfo.Improvements[eImprovementType].BarbarianCamp ) and not loadSlot("BarbarianVillageAlreadySighted"..key) then
            SaveToSlot("BarbarianVillageAlreadySighted"..key, true)
            local NotificationTurn  =  Game:GetLocalPlayer() < ActivePlayerID and Currentturn() + 1 or Currentturn();
            SetDefaultNotificationTable(notifid, NotificationTurn, Game:GetLocalPlayer());
            local BarbarianVillageDiscoveredNotification    = {};
            for k,func in pairs (DefaultNotification) do
                BarbarianVillageDiscoveredNotification[k]   = func;
            end
                BarbarianVillageDiscoveredNotification.GetTypeName         = function() return "NOTIFICATION_CUSTOM_BARBARIAN_VILLAGE_DISCOVERED"; end
                BarbarianVillageDiscoveredNotification.GetIconName         = function() return "ICON_NOTIFICATION_BARBARIANS_SIGHTED"; end
                BarbarianVillageDiscoveredNotification.GetMessage          = function() return "ATTENTION!"; end
                BarbarianVillageDiscoveredNotification.GetSummary          = function() return "Barbarians village [ICON_Strength]sighted!"; end
                BarbarianVillageDiscoveredNotification.IsLocationValid     = function() return true; end
                BarbarianVillageDiscoveredNotification.GetLocation         = function() return locX, locY; end	
                BarbarianVillageDiscoveredNotification.EraseOnStartTurn    = false;
                
                LuaEvents.CustomNotification_OnDefaultAddNotification(BarbarianVillageDiscoveredNotification);  
	end
end



------------------------------------------------ -- City tile ownership changed NOTIFICATION -- ------------------------------------------------------------------------

function OnCityAddedToMapNotif(playerID, cityID)
    local pCity = Players[playerID]:GetCities():FindID(cityID); 
    if pCity then
        local cityKey  = pCity:GetX().."."..pCity:GetY();
        SetCityPlots[cityKey] = Currentturn();
    end
end




function OnCityTileOwnershipChangedNotification( playerID: number, cityID : number )
    local pCity                     = CityManager.GetCity(playerID, cityID);
    local citykey              = pCity:GetX().."."..pCity:GetY(); 
    
    if SetCityPlots[citykey] == Currentturn() or not AllCityPlots[citykey] then
       AllCityPlots[citykey]   = Map.GetCityPlots():GetPurchasedPlots( pCity);
    end
    if playerID == Game:GetLocalPlayer() and not deepcompare(AllCityPlots[citykey], Map.GetCityPlots():GetPurchasedPlots( pCity)) and ReadyForPhase then
        local plotID, gain, key     = WhatDif(AllCityPlots[citykey], Map.GetCityPlots():GetPurchasedPlots( pCity));
        if gain then
            AllCityPlots[citykey][notifid]     = plotID;
        elseif not gain and key then
            AllCityPlots[citykey][key]         = nil;
        end
        if not WhatDif(AllCityPlots[citykey], Map.GetCityPlots():GetPurchasedPlots( pCity)) then
            AllCityPlots[citykey]  = Map.GetCityPlots():GetPurchasedPlots(pCity);
        end
        local plot                      = Map.GetPlotByIndex(plotID);
        local x                         = plot:GetX();
        local y                         = plot:GetY();
        local NotificationTurn          =  Game:GetLocalPlayer() < ActivePlayerID and Currentturn() + 1 or Currentturn();
        local Summary                   = "";
        local eResourceType    : number = plot:GetResourceType();
        local resource                  = nil;
        if eResourceType ~= -1 then
            resource                    = GameInfo.Resources[eResourceType];
            if (resource.PrereqTech) then
                local tech              = GameInfo.Technologies[resource.PrereqTech];
                if not Players[playerID]:GetTechs():HasTech(tech.Index) then
                    eResourceType       = -1; 
                end
            end
        end
        for yieldInfo in GameInfo.Yields() do			
            if plot:GetYield(yieldInfo.Index) >= 3 then
                if Summary == "" then
                    Summary = " New plot produce "..plot:GetYield(yieldInfo.Index)..yieldInfo.IconString..Locale.Lookup(yieldInfo.Name);
                else
                    Summary = Summary..", "..plot:GetYield(yieldInfo.Index)..yieldInfo.IconString..Locale.Lookup(yieldInfo.Name);
                end
            elseif plot:GetYield(yieldInfo.Index) >= 1 and (yieldInfo.YieldType == "YIELD_SCIENCE" or yieldInfo.YieldType == "YIELD_CULTURE" or yieldInfo.YieldType == "YIELD_FAITH") then
                if Summary == "" and plot:GetYield(yieldInfo.Index) == 1 then
                    Summary = " New plot produce "..yieldInfo.IconString..Locale.Lookup(yieldInfo.Name);
                elseif Summary == "" then
                    Summary = " New plot produce "..plot:GetYield(yieldInfo.Index)..yieldInfo.IconString..Locale.Lookup(yieldInfo.Name);
                elseif plot:GetYield(yieldInfo.Index) == 1 then
                    Summary = Summary..", "..yieldInfo.IconString..Locale.Lookup(yieldInfo.Name);
                else
                    Summary = Summary..", "..plot:GetYield(yieldInfo.Index)..yieldInfo.IconString..Locale.Lookup(yieldInfo.Name);
                end            
            end
        end
        SetDefaultNotificationTable(notifid, NotificationTurn, Game:GetLocalPlayer());
        local CityTileOwnershipChangedNotification = {};
        for k,func in pairs (DefaultNotification) do
            CityTileOwnershipChangedNotification[k] = func;
        end
            CityTileOwnershipChangedNotification.GetTypeName            = function() return "NOTIFICATION_CUSTOM_TILE_OWNERSHIP_CHANGED"; end
            CityTileOwnershipChangedNotification.GetIconName            = function() return "ICON_NOTIFICATION_CHOOSE_CIVIC"; end
            CityTileOwnershipChangedNotification.GetMessage             = function() return string.upper(Locale.Lookup(CityManager.GetCity(playerID, cityID):GetName())); end
            if eResourceType ~= -1 then
                local IconResourceName = resource.ResourceType;
                local resourceName     = Locale.Lookup(resource.Name);
                CityTileOwnershipChangedNotification.GetSummary         = function() return "City borders [ICON_Culture]changed! You found [ICON_"..IconResourceName.."]"..resourceName..Summary; end
            else
                CityTileOwnershipChangedNotification.GetSummary         = function() return "City borders [ICON_Culture]changed!"..Summary; end
            end
            CityTileOwnershipChangedNotification.IsLocationValid        = function() return true; end
            CityTileOwnershipChangedNotification.GetLocation            = function() return x, y; end
            if Summary ~= "" or eResourceType ~= -1 or table.count(AllCityPlots[citykey]) < 10 or not gain then
                LuaEvents.CustomNotification_OnDefaultAddNotification(CityTileOwnershipChangedNotification);  
            end
 
    end
end


------------------------------------------------ -- Deal expired NOTIFICATION -- ------------------------------------------------------------------------

function GetRessourcesFromExpiredDeals()

	local playerID         = Game.GetLocalPlayer();
    if not playerID then
        return;
    end
	local kPlayers	:table = PlayerManager.GetAliveMajors();
	for _, pOtherPlayer in ipairs(kPlayers) do
        local otherID:number = pOtherPlayer:GetID();
		if  otherID ~= playerID then
            if exportedResources[otherID] == nil then
                exportedResources[otherID] = {};
            end
            if importedResources[otherID] == nil then
                importedResources[otherID] = {};
            end
            if Players[otherID]:GetDiplomacy():HasOpenBordersFrom(playerID) then
                exportedResources[otherID].OpenBorders = true;
            else 
                exportedResources[otherID].OpenBorders = false;
            end
            if Players[playerID]:GetDiplomacy():HasOpenBordersFrom(otherID) then
                importedResources[otherID].OpenBorders = true;
            end
			local pDeals		:table  = DealManager.GetPlayerDeals(playerID, otherID);
			
			if pDeals ~= nil then
				for i,pDeal in ipairs(pDeals) do

					local pOutgoingDeal = pDeal:FindItemsByType(DealItemTypes.RESOURCES, DealItemSubTypes.NONE, playerID);
					if pOutgoingDeal ~= nil then
                        local OutCount = 0;
						for i,pDealItem in ipairs(pOutgoingDeal) do
							local duration		:number = pDealItem:GetDuration();
							local remainingTurns:number = duration - (Currentturn() - pDealItem:GetEnactedTurn());
							if (duration ~= 0 and remainingTurns == 0) then
                                OutCount                    = OutCount + 1;
								local resourceType	:number = pDealItem:GetValueType();
                                exportedResources[otherID][OutCount] = resourceType;
								local resourceName = GameInfo.Resources[resourceType].ResourceType;
							end
						end
					end
                    local pGoldOutgoingDeal :table = pDeal:FindItemsByType(DealItemTypes.GOLD, DealItemSubTypes.NONE, playerID);
					if pGoldOutgoingDeal ~= nil then
						for i,pDealItem in ipairs(pGoldOutgoingDeal) do
							local duration		:number = pDealItem:GetDuration();
							local remainingTurns:number = duration - (Currentturn() - pDealItem:GetEnactedTurn());
							if duration ~= 0 and remainingTurns == 0 then
								local gold :number = pDealItem:GetAmount();
                                exportedResources[otherID].Gold = gold;                          
							end
						end
					end

					local pIncomingDeal = pDeal:FindItemsByType(DealItemTypes.RESOURCES, DealItemSubTypes.NONE, otherID);
					if pIncomingDeal ~= nil then
                        local ImportCount = 0;
						for i,pDealItem in ipairs(pIncomingDeal) do
							local duration		:number = pDealItem:GetDuration();
							local remainingTurns:number = duration - (Currentturn() - pDealItem:GetEnactedTurn());
							if (duration ~= 0 and remainingTurns == 0) then
                                ImportCount = ImportCount + 1;
								local resourceType	:number = pDealItem:GetValueType();
                                importedResources[otherID][ImportCount] = resourceType;
								local resourceName = GameInfo.Resources[resourceType].ResourceType;
							end
						end
					end
                    local pGoldIncomingDeal :table	= pDeal:FindItemsByType(DealItemTypes.GOLD, DealItemSubTypes.NONE, otherID);
					if pGoldIncomingDeal ~= nil then
						for i,pDealItem in ipairs(pGoldIncomingDeal) do
							local duration		:number = pDealItem:GetDuration();
							local remainingTurns:number = duration - (Currentturn() - pDealItem:GetEnactedTurn());
							if duration ~= 0 and remainingTurns == 0 then
								local gold :number = pDealItem:GetAmount();
                                importedResources[otherID].Gold = gold;                          
							end
						end
					end
				end							
			end
		end
	end
end



function OnDiplomacyDealExpired(p1, p2)
	
	endTurn = Game.GetCurrentGameTurn();

	if (p1 == Game.GetLocalPlayer()) and ReadyForPhase then
		ProcessEvent(p2);
	end

	if (p2 == Game.GetLocalPlayer()) and ReadyForPhase then
		ProcessEvent(p1);
	end
		
end



function ProcessEvent(otherID)
    
    local playerID           = Game.GetLocalPlayer();
    local pOtherPlayer       = Players[otherID];
    local otherPlayerName    = Locale.Lookup(PlayerConfigurations[otherID]:GetCivilizationDescription());
    local Summary            = "";
    local SendSummary        = "you no longer send ";
    local ReceiveSummary     = "you no longer receive ";
    local BordersSummary     = "";
	if (turnDeal[otherID] ~= endTurn) then
		turnDeal[otherID] = endTurn;
        
        local NotificationTurn          =  Game:GetLocalPlayer() < ActivePlayerID and Currentturn() + 1 or Currentturn()
        SetDefaultNotificationTable(notifid, NotificationTurn, Game:GetLocalPlayer());
        local DealExpiredNotification   = {};
        for k,func in pairs (DefaultNotification) do
            DealExpiredNotification[k]  = func;
        end
        DealExpiredNotification.GetTypeName         = function() return "NOTIFICATION_CUSTOM_DEAL_EXPIRED"; end
        DealExpiredNotification.GetIconName         = function() return "ICON_NOTIFICATION_DIPLO_DEAL_EXPIRED"; end
        DealExpiredNotification.GetMessage          = function() return "Deal with ".. otherPlayerName .." expired"; end
         
        if exportedResources[otherID] == nil then
            exportedResources[otherID] = {};
        end
        if importedResources[otherID] == nil then
            importedResources[otherID] = {};
        end
        if not pOtherPlayer:GetDiplomacy():HasOpenBordersFrom(playerID) and exportedResources[otherID].OpenBorders then
            BordersSummary = " You closed your borders to the "..otherPlayerName;
            exportedResources[otherID].OpenBorders = false;
        end
        if not Players[playerID]:GetDiplomacy():HasOpenBordersFrom(otherID) and importedResources[otherID].OpenBorders then
            BordersSummary = BordersSummary.." you no longer have free passage over the territory of the "..otherPlayerName;
            importedResources[otherID].OpenBorders = false;
        end
	
		for count, resource in pairs(exportedResources[otherID]) do
            if type(count) == "number" then
                local IconResourceName = GameInfo.Resources[resource].ResourceType;
                local resourceName     = Locale.Lookup(GameInfo.Resources[resource].Name);
                SendSummary = SendSummary.."[ICON_"..IconResourceName.."]"..resourceName..", ";
            end
        end
        if exportedResources[otherID].Gold then
                if SendSummary ~= "you no longer send " then
                    SendSummary = SendSummary.."and "..exportedResources[otherID].Gold.."[ICON_Gold]Gold ";
                else
                    SendSummary = SendSummary..exportedResources[otherID].Gold.."[ICON_Gold]Gold ";
                end
        end
        for count, resource in pairs(importedResources[otherID]) do
            if type(count) == "number" then
                local IconResourceName = GameInfo.Resources[resource].ResourceType;
                local resourceName     = Locale.Lookup(GameInfo.Resources[resource].Name);
                ReceiveSummary = ReceiveSummary.."[ICON_"..IconResourceName.."]"..resourceName..", ";
            end
        end
        if importedResources[otherID].Gold then
            if ReceiveSummary ~= "you no longer receive " then
                ReceiveSummary = ReceiveSummary.."and "..importedResources[otherID].Gold.."[ICON_Gold]Gold ";
            else
                ReceiveSummary = ReceiveSummary..importedResources[otherID].Gold.."[ICON_Gold]Gold ";
            end
        end
        if SendSummary ~= "you no longer send " and ReceiveSummary ~= "you no longer receive " then
	       Summary = SendSummary.."to the "..otherPlayerName.." and "..ReceiveSummary.." from the "..otherPlayerName..BordersSummary;
        elseif ReceiveSummary ~= "you no longer receive " then
           Summary = ReceiveSummary.." from the "..otherPlayerName..BordersSummary;
        elseif SendSummary ~= "you no longer send " then
            Summary = SendSummary.."to the "..otherPlayerName..BordersSummary;
        else
            Summary = BordersSummary;
        end
        if Summary ~= "" then
            DealExpiredNotification.GetSummary          = function() return Summary; end
            LuaEvents.CustomNotification_OnDefaultAddNotification(DealExpiredNotification);
        end
         
        exportedResources[otherID] = {};
        importedResources[otherID] = {};
	end
end





-- =======================================================================================
-- Population Changed Handlers
-- =======================================================================================

function OnPopulationChangedActivate(pNotification)
    if UI.GetInterfaceMode() ~= InterfaceModeTypes.CITY_MANAGEMENT then
        LuaEvents.CityPanel_ToggleManageCitizens()
    end  
end

------------------------------------------------ -- Revolt NOTIFICATION Activate-- ------------------------------------------------------------------------
-- ON ACTIVE NOTIFICATION

function OnRevoltNotificationActivate(pNotification)
    playerID, cityID = pNotification:GetTarget()   
    UI.SetInterfaceMode(InterfaceModeTypes.SELECTION);
    UILens.SetActive("Loyalty");
    local banner:table          = GetLoyaltyModInfo( playerID, cityID );
    local loyaltyInfo:table     = banner.m_Instance;
    loyaltyInfo.CulturalIdentityButton:SetHide(true);
    loyaltyInfo.CulturalIdentityExpandedButton:SetHide(false);
end

            
   
------------------------------------------------ -- Religion NOTIFICATION Activate-- ------------------------------------------------------------------------
            
function OnActivateReligionNotification() 
    UI.SetInterfaceMode(InterfaceModeTypes.SELECTION);
    UILens.SetActive("Religion");
end
            



function InitializeNotification()
    
    -- Initialize Popilation Change Notification
    Events.CityPopulationChanged.Add(			            OnCityPopulationChanged2 );
    
    -- Initialize Religion changed Notification
    Events.CityReligionChanged.Add(                         OnCityReligionChanged2 );
    
    -- Initialize ReligionFounded Notification
    Events.ReligionFounded.Add(                             ReligionFoundedNotification );
    
    -- Initialize Barbarian Village Discovered Notification
    Events.ImprovementVisibilityChanged.Add(                OnBarbarianVillageDiscovered );
    
    -- Initialize City Tile Ownership Changed Notification
    Events.CityAddedToMap.Add(                              OnCityAddedToMapNotif );
    Events.CityTileOwnershipChanged.Add(                    OnCityTileOwnershipChangedNotification );
    
    -- Initialize deal expired Notification
    GameEvents.PlayerTurnStarted.Add(                       GetRessourcesFromExpiredDeals );
    Events.DiplomacyDealExpired.Add(                        OnDiplomacyDealExpired );
    
    -- Initialize on activate command
    LuaEvents.ON_REVOLT_NOTIF_ACTIVATED.Add(                OnRevoltNotificationActivate);
    LuaEvents.ON_POPULATION_CHANGED_ACTIVATED.Add(          OnPopulationChangedActivate);
    LuaEvents.ON_RELIGION_CHANGED_ACTIVATED.Add(            OnActivateReligionNotification);
end



-- ===========================================================================
--	Loyalty Mod UI
-- ===========================================================================







function GetLoyaltyModInfo( playerID, cityID )
    if (LoyaltyModInfoInstances[playerID] == nil) then
		return;
	end
	return LoyaltyModInfoInstances[playerID][cityID];
end

function OnRefreshBannerPositions()
	--print("Refreshing banner positions");

	local pLocalPlayerVis = PlayersVisibility[Game.GetLocalPlayer()];
	if (pLocalPlayerVis ~= nil) then
		local players = Game.GetPlayers();
		for i, player in ipairs(players) do
			local playerID = player:GetID();
			local playerCities = players[i]:GetCities();
			for ii, city in playerCities:Members() do
				local cityID		:number = city:GetID();
				local locX			:number = city:GetX();
				local locY			:number = city:GetY();
				local isVisChange	:boolean = false;
				
				if pLocalPlayerVis:IsVisible(locX, locY) then
					OnCityVisibilityChanged(playerID, cityID, PLOT_VISIBLE);
					isVisChange = true;
				elseif pLocalPlayerVis:IsRevealed(locX, locY) then
					OnCityVisibilityChanged(playerID, cityID, PLOT_REVEALED);
					isVisChange = true;
				end

				local LoyaltyModInfo:table = GetLoyaltyModInfo( playerID, cityID );
				if (LoyaltyModInfo ~= nil) then
					LoyaltyModInfo:UpdatePosition();
				end
			end
		end
	end
end

function OnCameraUpdate( vFocusX:number, vFocusY:number, fZoomLevel:number )
	-- If no change in the zoom, no update necessary.
	if (1-fZoomLevel) == zoomMultiplier then
		return;
	end
	zoomMultiplier= 1-fZoomLevel;
	if ( math.abs(zoomMultiplier - m_prevZoomMultiplier) > ZOOM_MULT_DELTA) then
		OnRefreshBannerPositions();
	end
	m_prevZoomMultiplier = zoomMultiplier;
end



function LoyaltyModInfo:UpdatePosition()
    local yOffset = 0;	--offset for 2D strategic view
	local zOffset = 0;	--offset for 3D world view
	
	if (UI.GetWorldRenderView() == WorldRenderView.VIEW_2D) then
		yOffset = 25;
		zOffset = 0;
	else
		yOffset = 0;
		yOffset = -25 + zoomMultiplier * 25;
		zOffset = 36;
	end

	local worldX, worldY, worldZ = UI.GridToWorld( self.m_PlotX, self.m_PlotY  );
	self.m_Instance.Anchor:SetWorldPositionVal( worldX, worldY+yOffset, worldZ+zOffset );
end

function toggleMigrationView()
     MigrationView = not MigrationView
     RealizeLoyalty()   
end
    
function LoyaltyModInfo:new( playerID: number, cityID : number )
	self = LuaClass.new(LoyaltyModInfo);
    
    
    local pCity                 = Players[playerID]:GetCities():FindID(cityID);
    self.m_Player               = Players[playerID];
    self.m_CityID               = cityID;
    
    self.m_InstanceManager      = m_LoyaltyModInst;
    self.m_Instance             = self.m_InstanceManager:GetInstance();
    self.m_IsCurrentlyVisible   = false;
    self.m_IsForceHide          = false;
    self.m_PlotX                = pCity:GetX();
    self.m_PlotY                = pCity:GetY();
    
    
    local toggleLoyaltyMod = function(on)
			return function()
				 self.m_Instance.CulturalIdentityButton:SetHide(on);
				 self.m_Instance.CulturalIdentityExpandedButton:SetHide(not on);
			end
    end
    self.m_Instance.CulturalIdentityButton:RegisterCallback( Mouse.eLClick, toggleLoyaltyMod(true) );
    self.m_Instance.CulturalIdentityExpandedButton:RegisterCallback( Mouse.eLClick, toggleLoyaltyMod(false) );
    
        
    self.m_Instance.SwitchMigrationViewButton:RegisterCallback( Mouse.eLClick, function() toggleMigrationView(); end );
    
    if self.m_LoyaltyBreakdownIM == nil then
        self.m_LoyaltyBreakdownIM = InstanceManager:new("InfluenceLineInstance","Top", self.m_Instance.IdentityBreakdownStack);
    end
    if self.LoyaltyInfo == nil then
        self.LoyaltyInfo = InstanceManager:new("LoyaltyInfosInstance","LoyaltyInfosTop", self.m_Instance.LoyaltyInfosStack);
    end
    
    self:UpdateLoyalty();


	if (LoyaltyModInfoInstances[playerID] == nil) then
	   LoyaltyModInfoInstances[playerID] = {};
	end
    LoyaltyModInfoInstances[playerID][cityID] = self;

	return self;
end
function LoyaltyModInfo:destroy()
	if self.m_LoyaltyBreakdownIM then
		self.m_LoyaltyBreakdownIM:DestroyInstances();
	end
    
	if self.LoyaltyInfo then
        self.LoyaltyInfo:DestroyInstances();
    end
    
	if self.m_InstanceManager then
		if self.m_Instance then
			self.m_InstanceManager:ReleaseInstance( self.m_Instance );
		end
	end
end

function DestroyLoyaltyModInfo( playerID: number, cityID : number )
	local LoyaltyModInfo:table = GetLoyaltyModInfo( playerID, cityID );
	if (LoyaltyModInfo ~= nil) then
		LoyaltyModInfo:destroy();
		LoyaltyModInfoInstances[ playerID ][ cityID ] = nil;
	end	
end

function AddLoyaltyInfoToMap( playerID: number, cityID : number )
	local pPlayer		:table  = Players[playerID];

	local pCity = pPlayer:GetCities():FindID(cityID);
	if (pCity ~= nil) then
			return LoyaltyModInfo:new( playerID, cityID);

	end	
end

function OnCityAddedToMap( playerID: number, cityID : number, cityX : number, cityY : number )
	if (LoyaltyModInfoInstances[ playerID ] ~= nil and
	    LoyaltyModInfoInstances[ playerID ][ cityID ] ~= nil) then
	    return;
    end
	AddLoyaltyInfoToMap( playerID, cityID );
end


function OnCityRemovedFromMap( playerID: number, cityID : number )
	DestroyLoyaltyModInfo(playerID, cityID);
end


function LoyaltyModInfo:GetCity()
	local pCity : table = self.m_Player:GetCities():FindID(self.m_CityID);
	return pCity;
end

function LoyaltyModInfo:UpdateLoyalty()
	local instance:table = self.m_Instance;
	if instance then
      if not m_isLoyaltyLensActive or not self:IsVisible() then
	       instance.Top:SetHide(true);
           return;
      end
        local pCity:table = self:GetCity();
		if pCity then
			local pCityCulturalIdentity:table = pCity:GetCulturalIdentity();
			if pCityCulturalIdentity then
              local ownerID:number = pCity:GetOwner();        
                
              local playerIdentitiesInCity = pCityCulturalIdentity:GetPlayerIdentitiesInCity();
              local cityIdentityPressures = pCityCulturalIdentity:GetCityIdentityPressures();
              local identitySourcesBreakdown = pCityCulturalIdentity:GetIdentitySourcesBreakdown();

			  -- Update owner icon
			  local pOwnerConfig:table = PlayerConfigurations[ownerID];
			  local ownerIcon:string = "ICON_" .. pOwnerConfig:GetCivilizationTypeName();
			  local ownerSecondaryColor, ownerPrimaryColor = UI.GetPlayerColors( ownerID );
			  local ownerCivIconTooltip:string = Locale.Lookup("LOC_LOYALTY_CITY_IS_LOYAL_TO_TT", Locale.Lookup(pOwnerConfig:GetCivilizationDescription()));
			  instance.OwnerCivIcon:SetIcon(ownerIcon);
			  instance.OwnerCivIcon:SetColor(ownerPrimaryColor);
			  instance.OwnerCivIcon:SetToolTipString(ownerCivIconTooltip);
			  instance.OwnerCivIconBacking:SetColor(ownerSecondaryColor);
			  instance.OwnerCivIconExtended:SetIcon(ownerIcon);
			  instance.OwnerCivIconExtended:SetColor(ownerPrimaryColor);
			  instance.OwnerCivIconExtended:SetToolTipString(ownerCivIconTooltip);
			  instance.OwnerCivIconBackingExtended:SetColor(ownerSecondaryColor);    
              instance.OwnerCivIconBacking2:SetColor(ownerSecondaryColor);
              instance.OwnerCivIcon2:SetIcon(ownerIcon);
			  instance.OwnerCivIcon2:SetColor(ownerPrimaryColor);
			  instance.OwnerCivIcon2:SetToolTipString(ownerCivIconTooltip);
			  -- Update potential transfer player icon
			  local transferPlayerID:number = pCityCulturalIdentity:GetPotentialTransferPlayer();
			  if transferPlayerID ~= -1 then
					instance.TopCivIconBacking:SetHide(false);
					instance.TopCivIconBacking2:SetHide(false);
					instance.TopCivIconBackingExtended:SetHide(false);
					local pTopConfig:table = PlayerConfigurations[transferPlayerID];
					local topIcon:string = "ICON_" .. pTopConfig:GetCivilizationTypeName();
					local topSecondaryColor, topPrimaryColor = UI.GetPlayerColors( transferPlayerID );
					local topCivIconTooltip:string = Locale.Lookup("LOC_LOYALTY_CITY_WILL_FALL_TO_TT", Locale.Lookup(pTopConfig:GetCivilizationDescription()));
                    if MigrationView then
                        instance.TopCivIconBacking:SetColor(0xFF000000);
                        instance.TopCivIcon:SetIcon("ICON_CITIZEN");
					    instance.TopCivIcon:SetColor(0xFF4a94ff);
					    instance.TopCivIcon:SetToolTipString("");
                        
                        instance.TopCivIconBacking2:SetColor(-12829636);
                        instance.TopCivIcon2:SetIcon(topIcon);
					    instance.TopCivIcon2:SetColor(-16777025);
					    instance.TopCivIcon2:SetToolTipString(topCivIconTooltip);
                        
                        
					    instance.TopCivIconExtended:SetIcon("ICON_CITIZEN");
					    instance.TopCivIconExtended:SetColor(0xFF4a94ff);
					    instance.TopCivIconBackingExtended:SetColor(0xFF000000);
					    instance.TopCivIconExtended:SetToolTipString("");
                    else
                        instance.TopCivIcon:SetIcon(topIcon);
					    instance.TopCivIcon:SetColor(topPrimaryColor);
					    instance.TopCivIcon:SetToolTipString(topCivIconTooltip);
                        -- 12829636 black 
                        -- 9902853 Yellow white         
                        instance.TopCivIconBacking2:SetColor(0xFF000000);
                        instance.TopCivIcon2:SetIcon("ICON_CITIZEN");
					    instance.TopCivIcon2:SetColor(0xFF4a94ff);
					    instance.TopCivIcon2:SetToolTipString("");
                        
                        instance.TopCivIconBacking:SetColor(topSecondaryColor);
					    instance.TopCivIconExtended:SetIcon(topIcon);
					    instance.TopCivIconExtended:SetColor(topPrimaryColor);
					    instance.TopCivIconBackingExtended:SetColor(topSecondaryColor);
					    instance.TopCivIconExtended:SetToolTipString(topCivIconTooltip);
                    end
			  else

                    instance.TopCivIconBacking2:SetColor(0xFF000000);
                    instance.TopCivIcon2:SetIcon("ICON_CITIZEN");
				    instance.TopCivIcon2:SetColor(0xFF4a94ff);
				    instance.TopCivIcon2:SetToolTipString("");

					instance.TopCivIconBacking:SetHide(true);
					instance.TopCivIconBackingExtended:SetHide(false);
              end
              instance.LoyaltyFillExtended:SetColor(0xFF00FF00)
              instance.LoyaltyFill:SetColor(0xFF00FF00)
              instance.LoyaltyFillExtendedBack:SetColor(0xFF0000FF)
              instance.LoyaltyFillBack:SetColor(0xFF0000FF)
              if MigrationView then
-------------------------------------------------------------------------------------------------------------------------------------------------
                -- My Mod UI
-------------------------------------------------------------------------------------------------------------------------------------------------
                local playerID                  = pCity:GetComponentID().player;
                local cityID                    = pCity:GetID();
                local cityKey                   = pCity:GetX().."."..pCity:GetY();
                local CityMigration             = Loyalty[cityKey].Migration
-------------------------------------------------------------------------------------------------------------------------------------------------
                -- My Mod UI end
------------------------------------------------------------------------------------------------------------------------------------------------- 
                
                local LoyaltyPerTurn            = GetLoyaltyModPerTurn(cityKey, playerID) + pCityCulturalIdentity:GetLoyaltyPerTurn() 
                local loyaltyFontIcon:string    = LoyaltyPerTurn >= 0 and "[ICON_PressureUp]" or "[ICON_PressureDown]";
                local currentLoyalty:number     = pCityCulturalIdentity:GetLoyalty();
				local maxLoyalty:number         = pCityCulturalIdentity:GetMaxLoyalty();
				local loyalPercent:number       = currentLoyalty / maxLoyalty;    
                instance.LoyaltyMigrationFill3:SetPercent(loyalPercent);
                instance.LoyaltyMigrationPressureIcon:SetText(loyaltyFontIcon);
                instance.LoyaltyMigrationFill:SetHide(true);
                instance.LoyaltyMigrationFill2:SetHide(true);
                instance.LoyaltyMigrationFill3:SetHide(false); 
                    
                    
                    
				-- Determine which pressure font icon to use
                local MigrationPerTurn:number     = GetAmountMigration(CityMigration, "Arrival") - GetAmountMigration(CityMigration, "Leaving") 
				local MigrationFontIcon:string    = MigrationPerTurn >= 0 and "[ICON_PressureUp]" or "[ICON_PressureDown]";
				-- Update Migration precentage
				local currentMigration:number = CityMigration.currentMigration;
				local maxMigration:number     = GetMaxMigration(cityKey);
                if currentMigration >= 0 then
				    local MigrationPercent:number = currentMigration / maxMigration;
				    instance.LoyaltyFill:SetPercent(MigrationPercent);
				    instance.LoyaltyFillExtended:SetPercent(MigrationPercent);
                    instance.LoyaltyFillExtended:SetColor(0xFF00FF00)
                    instance.LoyaltyFill:SetColor(0xFF00FF00)
                    instance.LoyaltyFillExtendedBack:SetColor(0xFFFFBF00)
                    instance.LoyaltyFillBack:SetColor(0xFFFFBF00)
                else
                    local MigrationPercent:number = -currentMigration / maxMigration;
				    instance.LoyaltyFill:SetPercent(MigrationPercent);
				    instance.LoyaltyFillExtended:SetPercent(MigrationPercent);
                    instance.LoyaltyFillExtended:SetColor(0xFF0000FF)
                    instance.LoyaltyFill:SetColor(0xFF0000FF)
                    instance.LoyaltyFillExtendedBack:SetColor(0xFF008CFF)
                    instance.LoyaltyFillBack:SetColor(0xFF008CFF)
                end
                
                    

               
                local MigrationFillToolTip:string = "You Have "..Round(GetAmountMigration(CityMigration ,"Arrival")).." Migrants Arrival and "..Round(GetAmountMigration(CityMigration, "Leaving")).." Migrants leaving this city";
                        
				instance.LoyaltyFill:SetToolTipString(MigrationFillToolTip);
				instance.LoyaltyFillExtended:SetToolTipString(MigrationFillToolTip);

				-- Update loyalty percentage string
				local MigrationText:string = "Miragtion: "..Round(currentMigration).."/"..maxMigration.." ("..MigrationFontIcon..Round(MigrationPerTurn)..")";
                instance.LoyaltyPercentageLabel:SetHide(false);   
                instance.LastRevoltTurnTop:SetHide(true);
				instance.LoyaltyPercentageLabel:SetText(MigrationText);
				instance.LoyaltyPercentageLabel:SetToolTipString(MigrationFillToolTip);
				instance.LoyaltyPressureIcon:SetText(MigrationFontIcon);
				instance.LoyaltyPressureIcon:SetToolTipString(MigrationFillToolTip);
                    
                if self.m_LoyaltyBreakdownIM ~= nil then
				    self.m_LoyaltyBreakdownIM:ResetInstances();
                end
        
                   
                   
        
                                    
                    
                self.LoyaltyInfo:ResetInstances();    
				if GetAmountMigration(CityMigration ,"FleeWarArrival") ~= 0 or GetAmountMigration(CityMigration, "FleeWarLeaving") ~= 0 then
                    local instance = self.LoyaltyInfo:GetInstance();
                    local tooltip = ""
                    if Loyalty[cityKey].Migration.FleeWarTooltip then
                     tooltip = string.gsub(CountAndCut(Loyalty[cityKey].Migration.FleeWarTooltip, "[ICON_PressureUp]", " Coming From ", " others cities", 5, "ICON_PressureUp"), "Migrants Arrival", Round(GetAmountMigration(CityMigration ,"FleeWarArrival")).." Migrants Arrival")
                    end
                    SetPressureBreakdownColumn(instance, Round(GetAmountMigration(CityMigration ,"FleeWarArrival") - GetAmountMigration(CityMigration, "FleeWarLeaving")));
                    instance.LoyaltyInfosTop:SetToolTipString(tooltip);
                    instance.LoyaltyInfosTopIcon:SetIcon("ICON_DIPLOACTION_JOINT_WAR")
                end
                    
                if GetAmountMigration(CityMigration ,"ReligionArrival") ~= 0 or GetAmountMigration(CityMigration, "ReligionLeaving") ~= 0 then
                    local instance = self.LoyaltyInfo:GetInstance();
                    local tooltip = string.gsub(CountAndCut(Loyalty[cityKey].Migration.ReligionTooltip, "[ICON_PressureUp]", " Coming From ", " others cities", 5, "ICON_PressureUp"), "Migrants Arrival", Round(GetAmountMigration(CityMigration ,"ReligionArrival")).." Migrants Arrival")
                    SetPressureBreakdownColumn(instance, Round(GetAmountMigration(CityMigration ,"ReligionArrival") - GetAmountMigration(CityMigration, "ReligionLeaving")));                
                    instance.LoyaltyInfosTop:SetToolTipString(tooltip);
                    instance.LoyaltyInfosTopIcon:SetIcon("ICON_RELIGION")
                end
                    
                if GetAmountMigration(CityMigration ,"GovernmentArrival") ~= 0 or GetAmountMigration(CityMigration, "GovernmentLeaving") ~= 0 then
                    local instance = self.LoyaltyInfo:GetInstance();
                    local tooltip = string.gsub(CountAndCut(Loyalty[cityKey].Migration.GovernmentTooltip, "[ICON_PressureUp]", " Coming From ", " others cities", 5, "ICON_PressureUp"), "Migrants Arrival", Round(GetAmountMigration(CityMigration ,"GovernmentArrival")).." Migrants Arrival")
                    SetPressureBreakdownColumn(instance, Round(GetAmountMigration(CityMigration ,"GovernmentArrival") - GetAmountMigration(CityMigration, "GovernmentLeaving")));                
                    instance.LoyaltyInfosTop:SetToolTipString(tooltip);
                    instance.LoyaltyInfosTopIcon:SetIcon("ICON_Government")
                end

                if GetAmountMigration(CityMigration ,"SeparatistArrival") ~= 0 or GetAmountMigration(CityMigration, "SeparatistLeaving") ~= 0 then
                    local instance = self.LoyaltyInfo:GetInstance();
                    local tooltip = string.gsub(CountAndCut(Loyalty[cityKey].Migration.SeparatistTooltip, "[ICON_PressureUp]", " Coming From ", " others cities", 5, "ICON_PressureUp"), "Migrants Arrival", Round(GetAmountMigration(CityMigration ,"SeparatistArrival")).." Migrants Arrival")
                    SetPressureBreakdownColumn(instance, Round(GetAmountMigration(CityMigration ,"SeparatistArrival") - GetAmountMigration(CityMigration, "SeparatistLeaving")));                
                    instance.LoyaltyInfosTop:SetToolTipString(tooltip);
                    instance.LoyaltyInfosTopIcon:SetIcon("ICON_Government")
                end

				-- Update loyalty pressure breakdown
				instance.MainStack:CalculateSize();
				local newSizeY = self.m_Instance.MainStack:GetSizeY();
				instance.CulturalIdentityExpandedButton:SetSizeY(newSizeY + 10);
				instance.Top:SetHide(false);
              else
-------------------------------------------------------------------------------------------------------------------------------------------------
                -- My Mod UI
------------------------------------------------------------------------------------------------------------------------------------------------- 
                local playerID                  = pCity:GetComponentID().player;
                local cityID                    = pCity:GetID();
                    
                local warexhaustionlevel        = Loyalty[playerID].WarExhaustion.Amount;
                local WarExhaustionTooltip      = SetWarExhaustionTooltip(playerID);
                    
                local cityKey                   = pCity:GetX().."."..pCity:GetY();
                 
                SetReligion(playerID, cityKey);    
                local ReligionMOdValue          = Loyalty[playerID][cityKey].ReligionStability.Amount;
                local ReligionStabilityTooltip  = Loyalty[playerID][cityKey].ReligionStability.tooltip;
                local LastRevoltTurn            = Loyalty[playerID][cityKey].LastRevoltTurn;
                local GovernmentMod2            = Loyalty[playerID].GovernmentStability.Amount ;
                local GovernmentTooltip         = SetGovernmentModTooltip(playerID);
                local Separatismlvl             = Loyalty[playerID][cityKey].Separatism.Amount
                local SeparatismTooltip         = SetSeparatismTooltip( playerID, cityID )
                local ColonialRiot              = Loyalty[playerID][cityKey].ColonialRiotAmount;
                local ColonialRiotToolTip       =  Loyalty[playerID][cityKey].ColonialRiotToolTip;

                    
                    if type(ReligionMOdValue) ~= "number" then
                        print ("ReligionMOdValue is "..type(ReligionMOdValue));
                        print (" player is "..playerID.." CityID is "..cityID);
                        ReligionMOdValue            = 0;
                        Loyalty[playerID][cityKey].ReligionStability.Amount   = 0;
                    end
                    if type(warexhaustionlevel) ~= "number" then
                        print ("warexhaustionlevel is "..type(warexhaustionlevel));
                        warexhaustionlevel          = 0;
                        Loyalty[playerID].WarExhaustion.Amount     = 0;
                    end
                    if type(WarExhaustionTooltip) ~= "string" then
                        print ("WarExhaustionTooltip is "..type(WarExhaustionTooltip));
                        print (" player is "..playerID.." CityID is "..cityID);
                        WarExhaustionTooltip        = "WarExhaustionTooltip error";
                    end
                    if type(ReligionStabilityTooltip) ~= "string" then
                        print ("ReligionStabilityTooltip is "..type(ReligionStabilityTooltip));
                        print (" player is "..playerID.." CityID is "..cityID);
                        ReligionStabilityTooltip                 = "No Information";
                        Loyalty[playerID][cityKey].ReligionStability.tooltip    = "";
                    end
                    if  type(LastRevoltTurn) ~= "number" then
                         print ("LastRevoltTurn is "..type(LastRevoltTurn));
                        print (" player is "..playerID.." CityID is "..cityID);
                        LastRevoltTurn                  = -30;
                        Loyalty[playerID][cityKey].LastRevoltTurn    = -30;   
                    end
                    TurnUntilRevoltAgain = LastRevoltTurn +30 - Currentturn(); 
                    if type(GovernmentMod2) ~= "number" then
                         print ("GovernmentMod2 is "..type(GovernmentMod2));
                        print (" player is "..playerID.." CityID is "..cityID);
                        GovernmentMod2              = 0;
                        Loyalty[playerID].GovernmentStability.Amount      = 0;
                    end
                    if type(GovernmentTooltip) ~= "string" then
                        print ("GovernmentTooltip is "..type(GovernmentTooltip));
                        print (" player is "..playerID.." CityID is "..cityID);
                        GovernmentTooltip           = "Government error";
                    end
                    if type(Separatismlvl) ~= "number" then
                        print ("Separatismlvl is "..type(GovernmentTooltip));
                        print (" player is "..playerID.." CityID is "..cityID);
                        Separatismlvl               = 0
                        Loyalty[playerID][cityKey].Separatism.Amount    = 0
                    end
                    if type(SeparatismTooltip) ~= "string" then
                        print ("SeparatismTooltip is "..type(SeparatismTooltip));
                        print (" player is "..playerID.." CityID is "..cityID);
                        SeparatismTooltip           = "sepratism error";
                    end
                    if type(ColonialRiot) ~= "number" then
                        print ("ColonialRiot is "..type(ColonialRiot));
                        print (" player is "..playerID.." CityID is "..cityID);
                        ColonialRiot           = 0;
                        Loyalty[playerID][cityKey].ColonialRiotAmount   = 0;
                    end
                    if type(ColonialRiotToolTip) ~= "string" then
                        print ("ColonialRiot is "..type(ColonialRiotToolTip));
                        print (" player is "..playerID.." CityID is "..cityID);
                        ColonialRiotToolTip           = "This city is too far from its capital... And wants to take his independence";
                        Loyalty[playerID][cityKey].ColonialRiotToolTip   = "This city is too far from its capital... And wants to take his independence";
                    end
-------------------------------------------------------------------------------------------------------------------------------------------------
                    -- My Mod UI end
-------------------------------------------------------------------------------------------------------------------------------------------------
                local CityMigration             = Loyalty[cityKey].Migration
                -- Determine which pressure font icon to use
                local MigrationPerTurn:number     = GetAmountMigration(CityMigration, "Arrival") - GetAmountMigration(CityMigration, "Leaving") 
				local MigrationFontIcon:string    = MigrationPerTurn >= 0 and "[ICON_PressureUp]" or "[ICON_PressureDown]";
				-- Update Migration precentage
				local currentMigration:number = CityMigration.currentMigration;
				local maxMigration:number     = GetMaxMigration(cityKey);
                instance.LoyaltyMigrationFill3:SetHide(true);
                if currentMigration >= 0 then
				    local MigrationPercent:number = currentMigration / maxMigration;
                    instance.LoyaltyMigrationFill2:SetHide(true);
                    instance.LoyaltyMigrationFill:SetHide(false);
                    instance.LoyaltyMigrationFill:SetPercent(MigrationPercent);
                    instance.LoyaltyMigrationPressureIcon:SetText(MigrationFontIcon);
                else
                    local MigrationPercent:number = -currentMigration / maxMigration;
                    instance.LoyaltyMigrationFill2:SetPercent(MigrationPercent);
                    instance.LoyaltyMigrationFill2:SetHide(false);
                    instance.LoyaltyMigrationFill:SetHide(true);
                    instance.LoyaltyMigrationPressureIcon:SetText(MigrationFontIcon);
                end
				-- Determine which pressure font icon to use
                local loyaltyPerTurn:number     = pCityCulturalIdentity:GetLoyaltyPerTurn() + warexhaustionlevel + ReligionMOdValue + GovernmentMod2 + Separatismlvl + ColonialRiot;
				local loyaltyFontIcon:string    = loyaltyPerTurn >= 0 and "[ICON_PressureUp]" or "[ICON_PressureDown]";
				-- Update loyalty precentage
				local currentLoyalty:number = pCityCulturalIdentity:GetLoyalty();
				local maxLoyalty:number     = pCityCulturalIdentity:GetMaxLoyalty();
				local loyalPercent:number   = currentLoyalty / maxLoyalty;
				instance.LoyaltyFill:SetPercent(loyalPercent);
				instance.LoyaltyFillExtended:SetPercent(loyalPercent);
                instance.LoyaltyFillExtended:SetColor("0,255,0,255")
                instance.LoyaltyFill:SetColor("0,255,0,255")
                if TurnUntilRevoltAgain > 0 then
                    local SetMax = Locale.Lookup("", 1000, maxLoyalty, loyaltyFontIcon, Round(loyaltyPerTurn, 1),"aaa");
                    
                    local LastrevoltTurnText = TurnUntilRevoltAgain.."[ICON_Turn] Turn untill this city can revolt again";
                    local tooltip = "This City can't revolt cause of a Recent Revolt";
                        
                    if GameConfiguration.GetValue(cityKey.."SiegeTurnLeft") and  GameConfiguration.GetValue(cityKey.."SiegeTurnLeft") > -1 then
                        LastrevoltTurnText  = GameConfiguration.GetValue(cityKey.."SiegeTurnLeft").."[ICON_Turn] Turn untill The siege end";
                        tooltip             = GameConfiguration.GetValue(cityKey.."SiegeUnitCount").." partisans left";
                    end
                    
                            
                    instance.LoyaltyFillExtended:SetColor("255,255,102,255")
                    instance.LoyaltyFill:SetColor("255,255,102,255")
                            
                    instance.LoyaltyPercentageLabel:SetHide(true);  
                    instance.LoyaltyFill:SetPercent(1);
				    instance.LoyaltyFillExtended:SetPercent(1);
                    instance.LastRevoltTurn:SetText(LastrevoltTurnText); 
                    instance.LastRevoltTurnTop:SetToolTipString(tooltip);
                    instance.LastRevoltTurnTop:SetHide(false);
                else
                    instance.LastRevoltTurnTop:SetHide(true);
                    instance.LoyaltyPercentageLabel:SetHide(false);  
                end
				local loyalStatusTooltip:string = "";
                local loyaltyFillToolTip:string = Locale.Lookup("LOC_LOYALTY_STATUS_TT", loyaltyFontIcon, Round(currentLoyalty,1), maxLoyalty, loyalStatusTooltip).."This City has no chance of revolt next turn";
                local ChanceOfRevoltDice = -loyaltyPerTurn / currentLoyalty * 100;
                if ChanceOfRevoltDice >100 then
                    ChanceOfRevoltDice = 100;
                end
                if ChanceOfRevoltDice > 0 then
                    instance.LoyaltyFillExtended:SetColor("220,20,60,255")
                    instance.LoyaltyFill:SetColor("220,20,60,255")
				    loyaltyFillToolTip = Locale.Lookup("LOC_LOYALTY_STATUS_TT", loyaltyFontIcon, Round(currentLoyalty,1), maxLoyalty, loyalStatusTooltip).."This City have "..Round(ChanceOfRevoltDice,1).."% chance of revolt next turn";
                end
				instance.LoyaltyFill:SetToolTipString(loyaltyFillToolTip);
				instance.LoyaltyFillExtended:SetToolTipString(loyaltyFillToolTip);
				-- Update loyalty percentage string
				local loyaltyText:string = Locale.Lookup("LOC_CULTURAL_IDENTITY_LOYALTY_PERCENTAGE", Round(currentLoyalty, 1), maxLoyalty, loyaltyFontIcon, Round(loyaltyPerTurn, 1));
				instance.LoyaltyPercentageLabel:SetText(loyaltyText);
				instance.LoyaltyPercentageLabel:SetToolTipString(loyaltyFillToolTip);
				instance.LoyaltyPressureIcon:SetText(loyaltyFontIcon);
				instance.LoyaltyPressureIcon:SetToolTipString(GetLoyaltyPressureIconTooltip(loyaltyPerTurn, ownerID));
				--Update Loyalty breakdown
				if self.m_LoyaltyBreakdownIM ~= nil then
					self.m_LoyaltyBreakdownIM:ResetInstances();
					--Populate the breakdown
					local localPlayerID = Game.GetLocalPlayer();
					local pCulturalIdentity = pCity:GetCulturalIdentity();
					local identitiesInCity = pCulturalIdentity:GetPlayerIdentitiesInCity();
					local firstIdentityInCity = next(identitiesInCity);
					if firstIdentityInCity == nil then
						--We have no presences, or we are the only one
						self.m_Instance.IdentityBreakdownStack:SetHide(true);
					else
						self.m_Instance.IdentityBreakdownStack:SetHide(false);
						table.sort(identitiesInCity, function(left, right)
							return left.IdentityTotal > right.IdentityTotal;
						end);
						local numInfluencers = 0;
						for i, playerPresence in ipairs(identitiesInCity) do
							if playerPresence.IdentityTotal ~= nil and playerPresence.IdentityTotal > 0 then
								if numInfluencers < 2 or playerPresence.Player == localPlayerID then
									numInfluencers         = numInfluencers + 1;
									local instance         = self.m_LoyaltyBreakdownIM:GetInstance();
									local localPlayer      = Players[localPlayerID];
									local pPlayerConfig    = PlayerConfigurations[playerPresence.Player];
									local civName          = Locale.Lookup(pPlayerConfig:GetCivilizationShortDescription());
									local lineVal          = (i == 1 and "[ICON_Bolt] " or "") .. Round(playerPresence.IdentityTotal, 1);
									local hasBeenMet       = localPlayer:GetDiplomacy():HasMet(playerPresence.Player) or localPlayerID == playerPresence.Player;
									instance.LineTitle:SetText(hasBeenMet and civName or Locale.Lookup("LOC_LOYALTY_PANEL_UNMET_CIV"));
									instance.LineValue:SetText(lineVal);

									local civIconManager   = CivilizationIcon:AttachInstance(instance.CivilizationIcon);
									civIconManager:UpdateIconFromPlayerID(playerPresence.Player);
								end
							end
						end
					end
					self.m_Instance.MainStack:CalculateSize();
				end

				-- Update loyalty pressure breakdown
                self.LoyaltyInfo:ResetInstances();
				for i, pressure in ipairs(identitySourcesBreakdown) do
                    local instance = self.LoyaltyInfo:GetInstance();
					if pressure[PRESSURE_BREAKDOWN_TYPE_POPULATION_PRESSURE] then
						SetPressureBreakdownColumn(instance, Round(pressure[PRESSURE_BREAKDOWN_TYPE_POPULATION_PRESSURE], 1));
						local tooltip:string  = Locale.Lookup("LOC_CULTURAL_IDENTITY_POPULATION_PRESSURE_TOOLTIP");
						local ownerPlayer     = Players[ownerID];
						if (ownerPlayer ~= nil) then
							if (ownerPlayer:IsMajor()) then
								tooltip = tooltip .. "[NEWLINE][NEWLINE]" .. Locale.Lookup("LOC_CULTURAL_IDENTITY_POPULATION_PRESSURE_TOOLTIP_MAJOR_CIVS");
							else
								tooltip = tooltip .. "[NEWLINE][NEWLINE]" .. Locale.Lookup("LOC_CULTURAL_IDENTITY_POPULATION_PRESSURE_TOOLTIP_MINOR_CIVS");
							end
						end
						instance.LoyaltyInfosTop:SetToolTipString(tooltip);
                        instance.LoyaltyInfosTopIcon:SetIcon("ICON_CITIZEN")
					elseif pressure[PRESSURE_BREAKDOWN_TYPE_GOVERNORS] then
						SetPressureBreakdownColumn(instance, Round(pressure[PRESSURE_BREAKDOWN_TYPE_GOVERNORS], 1));
                        instance.LoyaltyInfosTopIcon:SetIcon("ICON_STAT_GOVERNORS")
                        instance.LoyaltyInfosTop:SetToolTipString(Locale.Lookup("LOC_CULTURAL_IDENTITY_GOVERNORS_PRESSURE_TOOLTIP"));
					elseif pressure[PRESSURE_BREAKDOWN_TYPE_HAPPINESS] then
						SetPressureBreakdownColumn(instance, Round(pressure[PRESSURE_BREAKDOWN_TYPE_HAPPINESS], 1));
                        instance.LoyaltyInfosTopIcon:SetIcon("ICON_AMENITIES")
                        instance.LoyaltyInfosTop:SetToolTipString(Locale.Lookup("LOC_CULTURAL_IDENTITY_HAPPINESS_PRESSURE_TOOLTIP"));
					elseif pressure[PRESSURE_BREAKDOWN_TYPE_OTHER] then
						SetPressureBreakdownColumn(instance, Round(pressure[PRESSURE_BREAKDOWN_TYPE_OTHER], 1));
                        instance.LoyaltyInfosTop:SetToolTipString(tooltip);
                        instance.LoyaltyInfosTopIcon:SetIcon("ICON_STAT_OTHERS")
                        instance.LoyaltyInfosTop:SetToolTipString(Locale.Lookup("LOC_CULTURAL_IDENTITY_OTHER_PRESSURE_TOOLTIP"));    
					elseif pressure[PRESSURE_BREAKDOWN_TYPE_CITY_STATE_BONUS] then
						SetPressureBreakdownColumn(instance, Round(pressure[PRESSURE_BREAKDOWN_TYPE_CITY_STATE_BONUS], 1));
                        instance.LoyaltyInfosTopIcon:SetIcon("ICON_STAT_THEIR_CITIES")
                        instance.LoyaltyInfosTop:SetToolTipString(Locale.Lookup("LOC_CULTURAL_IDENTITY_CITY_STATES_PRESSURE_TOOLTIP"));
					elseif pressure[PRESSURE_BREAKDOWN_TYPE_FREE_CITY_BONUS] then
						SetPressureBreakdownColumn(instance, Round(pressure[PRESSURE_BREAKDOWN_TYPE_FREE_CITY_BONUS], 1));
                        instance.LoyaltyInfosTopIcon:SetIcon("ICON_STAT_INDEPENCE")
                        instance.LoyaltyInfosTop:SetToolTipString(Locale.Lookup("LOC_CULTURAL_IDENTITY_FREE_CITIES_PRESSURE_TOOLTIP"));
					end
                end
-------------------------------------------------------------------------------------------------------------------------------------------------
                    -- My Mod UI 2
-------------------------------------------------------------------------------------------------------------------------------------------------
                    if warexhaustionlevel and warexhaustionlevel ~= 0 then                                         -- War Exhaustion
                        local instance = self.LoyaltyInfo:GetInstance();  
                        SetPressureBreakdownColumn(instance, Round(warexhaustionlevel));                
                        instance.LoyaltyInfosTop:SetToolTipString(Locale.Lookup(WarExhaustionTooltip));
                        instance.LoyaltyInfosTopIcon:SetIcon("ICON_DIPLOACTION_JOINT_WAR")
                    end
                    if ReligionMOdValue then                                                                                    -- Religion
                        local instance = self.LoyaltyInfo:GetInstance();  
                        SetPressureBreakdownColumn(instance, Round(ReligionMOdValue));
                        local tooltip2:string = Locale.Lookup("[ICON_Faith]Religion");
                        if ReligionStabilityTooltip ~= "" then
                        tooltip2 = tooltip2 .. "[NEWLINE][NEWLINE]" .. Locale.Lookup(ReligionStabilityTooltip);           
                        end
                        instance.LoyaltyInfosTop:SetToolTipString(tooltip2);
                        instance.LoyaltyInfosTopIcon:SetIcon("ICON_RELIGION")
                    end
                    if GovernmentMod2 then                                                                                                   -- Government
                        local instance = self.LoyaltyInfo:GetInstance();  
                        SetPressureBreakdownColumn(instance, Round(GovernmentMod2));    
                        instance.LoyaltyInfosTop:SetToolTipString(GovernmentTooltip);
                        instance.LoyaltyInfosTopIcon:SetIcon("ICON_Government")
                    end
                    if Separatismlvl and Separatismlvl < 0 then
                        local instance = self.LoyaltyInfo:GetInstance();  
                        SetPressureBreakdownColumn(instance, Round(Separatismlvl));                
                        instance.LoyaltyInfosTop:SetToolTipString(Locale.Lookup(SeparatismTooltip));
                        instance.LoyaltyInfosTopIcon:SetIcon("ICON_NOTIFICATION_SPY_ENEMY_RECRUIT_PARTISANS")
                    end
                    if ColonialRiot and ColonialRiot < 0  then
                        local instance = self.LoyaltyInfo:GetInstance();  
                        SetPressureBreakdownColumn(instance, Round(ColonialRiot));                
                        instance.LoyaltyInfosTop:SetToolTipString(ColonialRiotToolTip);
                        instance.LoyaltyInfosTopIcon:SetIcon("ICON_NOTIFICATION_REBELLION")
                    end
-------------------------------------------------------------------------------------------------------------------------------------------------
                    -- My Mod UI 2 end
-------------------------------------------------------------------------------------------------------------------------------------------------
				instance.MainStack:CalculateSize();
				local newSizeY = self.m_Instance.MainStack:GetSizeY();
				instance.CulturalIdentityExpandedButton:SetSizeY(newSizeY + 10);
				instance.Top:SetHide(false);
			end
		end
      end
	end
end

function SetPressureBreakdownColumn(instance, pressureValue:number)
	if pressureValue > 0 then
		instance.LoyaltyInfosTopPressureValue:SetText(Locale.Lookup("LOC_CULTURAL_IDENTITY_POSITIVE_PRESSURE", pressureValue));
		instance.LoyaltyInfosTopPressureValue:SetColorByName("White");
		instance.LoyaltyInfosTopFontIcon:SetText("[ICON_PressureUp]");
		instance.LoyaltyInfosTopFontIcon:SetHide(false);
	elseif pressureValue < 0 then
		instance.LoyaltyInfosTopPressureValue:SetText(pressureValue);
		instance.LoyaltyInfosTopPressureValue:SetColorByName("Red");
		instance.LoyaltyInfosTopFontIcon:SetText("[ICON_PressureDown]");
		instance.LoyaltyInfosTopFontIcon:SetHide(false);
	else
		instance.LoyaltyInfosTopPressureValue:SetText(Locale.Lookup("LOC_CULTURAL_IDENTITY_POSITIVE_PRESSURE", pressureValue));
		instance.LoyaltyInfosTopPressureValue:SetColorByName("Gray");
		instance.LoyaltyInfosTopFontIcon:SetHide(true);
	end
    local labelWidth = instance.LoyaltyInfosTopPressureValue:GetSizeX() + 10
    if labelWidth > 42 then
        instance.LoyaltyInfosTop:SetSizeX(labelWidth)
    else
        instance.LoyaltyInfosTop:SetSizeX(42)
    end
end

function LoyaltyModInfo:IsVisible()
	if Game.GetLocalPlayer() >= 0 then
		local pLocalPlayerVis:table   = PlayersVisibility[Game.GetLocalPlayer()];
		local city:table              = self:GetCity();
		local locX:number             = city:GetX();
		local locY:number             = city:GetY();
		if pLocalPlayerVis:IsVisible(locX, locY) then
			return true;
		elseif pLocalPlayerVis:IsRevealed(locX, locY) then
			return true;
		end
	end
	return false;
end


function RealizeLoyalty()
	for _, playerLoyaltyModInfoInstances in pairs(LoyaltyModInfoInstances) do
		for id, CityLoyaltyModInfo in pairs(playerLoyaltyModInfoInstances) do
			if (CityLoyaltyModInfo ~= nil and CityLoyaltyModInfo.m_Instance and CityLoyaltyModInfo:IsVisible()) then
				CityLoyaltyModInfo:UpdateLoyalty();
				CityLoyaltyModInfo:UpdatePosition();
			end
		end
	end
end
-- ===========================================================================
--	LUA Event
--	Set cached values back after a hotload.
-- ===========================================================================
function OnGameDebugReturn( context:string, contextTable:table )
	if context == "LoyaltyModInfo" then
		m_isLoyaltyLensActive = contextTable["m_isLoyaltyLensActive"];
		RealizeLoyalty();
	end
end

-- ===========================================================================
--	Gamecore Event
--	Called once per layer that is turned on when a new lens is activated,
--	or when a player explicitly turns off the layer from the "player" lens.
-- ===========================================================================
function OnLensLayerOn( layerNum:number )
	if RealizeLoyalty and layerNum == LensLayers.CULTURAL_IDENTITY_LENS then
		m_isLoyaltyLensActive = true;
		RealizeLoyalty();
	end
end

-- ===========================================================================
--	Gamecore Event
--	Called once per layer that is turned on when a new lens is deactivated,
--	or when a player explicitly turns off the layer from the "player" lens.
-- ===========================================================================
function OnLensLayerOff( layerNum:number )
	if RealizeLoyalty and layerNum == LensLayers.CULTURAL_IDENTITY_LENS then
		m_isLoyaltyLensActive = false;
		RealizeLoyalty();
	end
end


function Reload()

	local pLocalPlayerVis:table = PlayersVisibility[Game.GetLocalPlayer()];
	if pLocalPlayerVis ~= nil then
		local players = Game.GetPlayers();
		for i, player in ipairs(players) do
			local playerID		:number = player:GetID();
			local pPlayerCities	:table = players[i]:GetCities();

			for _, city in pPlayerCities:Members() do
				local cityID:number = city:GetID();
				local locX	:number = city:GetX();
				local locY	:number = city:GetY();
				OnCityAddedToMap( playerID, cityID, locX, locY );
				if (pLocalPlayerVis:IsVisible(locX, locY) == true) then
					OnCityVisibilityChanged(playerID, cityID, PLOT_VISIBLE);
				end

			end
		end
	end
end

function OnCityVisibilityChanged( playerID: number, cityID : number, eVisibility : number)
	local bannerInstance:table = GetLoyaltyModInfo( playerID, cityID );
	if bannerInstance then
		bannerInstance:SetFogState( eVisibility );
	end
end

function LoyaltyModInfo:SetFogState( fogState : number )

	if( fogState == PLOT_HIDDEN ) then
		self:SetHide( true );
	else
		self:SetHide( false );
	end
	self.m_FogState = fogState;
end

function LoyaltyModInfo:SetHide( bHide : boolean )
	self.m_IsCurrentlyVisible =  not bHide;
	self:UpdateVisibility();
end

function LoyaltyModInfo:UpdateVisibility()

	local bVisible = self.m_IsCurrentlyVisible and not self.m_IsForceHide;
	self.m_Instance.Anchor:SetHide(not bVisible);
end

function OnContextInitialize( isHotload : boolean )
	if isHotload then
		LuaEvents.GameDebug_GetValues( "LoyaltyModInfo" );
		Reload();
	end
end

-- ===========================================================================
--	Handle the UI shutting down.
function OnShutdown()
	-- Cache value for hotloading...
	LuaEvents.GameDebug_AddValue("LoyaltyModInfo", "m_isLoyaltyLensActive", m_isLoyaltyLensActive);
end


function PopulateComboBox(control, values, selected_value, selection_handler, is_locked)

	if (is_locked == nil) then
		is_locked = false;
	end

	control:ClearEntries();
	for i, v in ipairs(values) do
		local instance = {};
		control:BuildEntry( "InstanceOne", instance );
		instance.Button:SetVoid1(i);
        instance.Button:LocalizeAndSetText(v[1]);

		if(v[2] == selected_value) then
			local button = control:GetButton();
            button:LocalizeAndSetText(v[1]);
		end
	end
	control:CalculateInternals();	
		
	control:SetDisabled(is_locked ~= false);

	if(selection_handler) then
		control:RegisterSelectionCallback(
			function(voidValue1, voidValue2, control)
				local option = values[voidValue1];

				local button = control:GetButton();
                button:LocalizeAndSetText(option[1]);
								
				selection_handler(option[2]);
			end
		);
	end
    	
end





function Initialize()
    
    InitializeScripts()
    
    InitializeNotification()
    -- Initialize UI
    
    ContextPtr:SetInitHandler( OnContextInitialize );
	ContextPtr:SetShutdown( OnShutdown );
    
    Events.CityAddedToMap.Add(					OnCityAddedToMap );
    Events.CityRemovedFromMap.Add(				OnCityRemovedFromMap );
    
    Events.LensLayerOff.Add(					OnLensLayerOff );
	Events.LensLayerOn.Add(						OnLensLayerOn  );
    Events.Camera_Updated.Add(					OnCameraUpdate );
    Events.CityVisibilityChanged.Add(			OnCityVisibilityChanged );
    
    LuaEvents.GameDebug_Return.Add(             OnGameDebugReturn);
    
end
Initialize()

 

